<?php

	include_once( PLOG_CLASS_PATH."class/object/object.class.php" );
    include_once( PLOG_CLASS_PATH."class/action/actioninfo.class.php" );
    include_once( PLOG_CLASS_PATH."class/config/properties.class.php" );
    include_once( PLOG_CLASS_PATH."class/net/request.class.php" );
    include_once( PLOG_CLASS_PATH."class/object/observable.class.php" );

	/**
     * Abstract class representing an Action.
     */
	class Action extends Observable {

    	// this is the pointer to the view associated with this action
		var $_view;
        var $_request;
        var $_actionInfo;

        /**
         * Constructor.
         *
         * @param actionInfo An ActionInfo object contaning information about the action
         * @param httpRequest the HTTP request.
         */
    	function Action( $actionInfo, $httpRequest )
        {
			$this->Object();

            $this->_request = new Request( $httpRequest );

            $this->_actionInfo = $actionInfo;
        }

        /**
         * Receives the HTTP request from the client as parameter, so that we can
         * extract the parameters we need and carry out the operation.
         *
         * The result of this will be a view, which will normally be the output of the
         * processing we just did or for example an error view showing an error message.
         * Once we have completed processing, the controller will call the getView() method
         * to get the resulting view and send it back to the customer.
         *
         * @return Returns nothing
         */
        function perform()
        {

        }

        /**
         * This function does not need to be reimplemented by the childs of this class.
         * It just returns the resulting view of the operation.
         */
        function getView()
        {
        	return $this->_view;
        }
    }
?>
