<?php

	include_once( PLOG_CLASS_PATH."class/action/action.class.php" );

	/**
     * Extends the Action class to provide an interface for the validation of forms.
     * When the Controller receives a request to which an object of type ActionForm has been
     * assigned, it first calls the validate() method and depending on its result, will then
     * call the perform() method or not. The validate method also must generate a valid view
     * probably containing some error message if it returns false.
     */
	class ActionForm extends Action {

    	/**
         * Constructor
         *
         * @param actionInfo An ActionInfo object containing information about the action.
         * @param request The HTTP request.
         */
		function ActionForm( $actionInfo, $request )
        {
			$this->Action( $actionInfo, $request );
        }

        /**
         * Validates a form. This method <b>must</b> overriden by any of the classes
         * that wish to validate forms.
         *
         * @return Returns false if any of the values was wrong or empty or 'true'
         * if everything was fine.
         */
        function validate()
        {
			return true;
        }
    }
?>
