<?php

	include_once( PLOG_CLASS_PATH."class/action/siteadminaction.class.php" );
    include_once( PLOG_CLASS_PATH."class/view/adminmessageview.class.php" );
    include_once( PLOG_CLASS_PATH."class/view/adminerrorview.class.php" );
    include_once( PLOG_CLASS_PATH."class/template/templateservice.class.php" );
    include_once( PLOG_CLASS_PATH."class/net/httpvars.class.php" );

	class AdminAddNewGlobalTemplateFileAction extends SiteAdminAction {

    	var $_files;
        var $_templateId;

    	function AdminAddNewGlobalTemplateFileAction( $actionInfo, $request )
        {
        	$this->SiteAdminAction( $actionInfo, $request );
        }

        function validate()
        {
        	// make sure that the user is uploading a file
            $this->_files = HttpVars::getFiles();

            // check if there's any file to upload
            if( count($this->_files) == 0 ) {
            	$this->_view = new AdminErrorView( $this->_blogInfo );
                $this->_view->setMessage( "Please select a file to upload." );
                $this->setCommonData();

                return false;
            }

            // get the template id
            $this->_templateId = $this->_request->getValue( "templateId" );

            return true;
        }

        function perform()
        {
        	// uploads the file and moves it to the correct folder
            $uploads  = new FileUploads( $this->_files );

            // make sure were it should go
            $ts = new TemplateService();
            $destFolder = $ts->getTemplateFolder( $this->_templateId );

            // and move it there
            $result = $uploads->process( $destFolder );

            $this->_view = new AdminMessageView( $this->_blogInfo );
            $this->_view->setMessage( "File added succesfully." );
            $this->setCommonData();

            return true;
        }
    }
?>
