<?php

	include_once( PLOG_CLASS_PATH."class/action/adminaction.class.php" );
    include_once( PLOG_CLASS_PATH."class/view/adminmessageview.class.php" );
    include_once( PLOG_CLASS_PATH."class/view/adminerrorview.class.php" );
    include_once( PLOG_CLASS_PATH."class/dao/articlecategories.class.php" );
    include_once( PLOG_CLASS_PATH."class/dao/articlecategory.class.php" );

    /**
     * Action that adds a new article category to the database.
     */
    class AdminAddArticleCategoryAction extends AdminAction {

    	var $_categoryName;
        var $_categoryUrl;

    	/**
         * Constructor. If nothing else, it also has to call the constructor of the parent
         * class, BlogAction with the same parameters
         */
        function AdminAddArticleCategoryAction( $actionInfo, $request )
        {
        	$this->AdminAction( $actionInfo, $request );
        }

        /**
         * checks that all the information is correct
         */
        function validate()
        {
        	$this->_categoryName     = $this->_request->getValue( "categoryName" );
            $this->_categoryUrl      = $this->_request->getValue( "categoryUrl" );
            $this->_categoryInMainPage = $this->_request->getValue( "categoryInMainPage" );

            if( $this->_categoryName == "" ) {
            	$this->_view = new AdminErrorView( $this->_blogInfo );
                $this->_view->setValue( "message", $this->_locale->tr("error_empty_category_name"));
                $this->setCommonData();

                return false;
            }

            if( $this->_categoryInMainPage == "" || $this->_categoryInMainPage == null )
            	$this->_categoryInMainPage = 0;

            return true;
        }

        /**
         * Carries out the specified action
         */
        function perform()
        {
            $categories = new ArticleCategories();
            $category   = new ArticleCategory( $this->_categoryName,
                                               $this->_categoryUrl,
                                               $this->_blogInfo->getId(),
                                               $this->_categoryInMainPage );

            // once we have built the object, we can add it to the database
            if( $categories->addArticleCategory( $category )) {
        		$this->_view = new AdminMessageView( $this->_blogInfo );
            	$this->_view->setValue( "message", $this->_locale->tr("category_added_ok"));
            }
            else {
            	$this->_view = new AdminErrorView( $this->_blogInfo );
                $this->_view->setValue( "message", $this->_locale->tr("error_adding_article_category"));
            }

            $this->setCommonData();

            // better to return true if everything fine
            return true;
        }
    }
?>
