<?php

	include_once( PLOG_CLASS_PATH."class/action/siteadminaction.class.php" );
    include_once( PLOG_CLASS_PATH."class/view/admintemplatedview.class.php" );
    include_once( PLOG_CLASS_PATH."class/view/adminerrorview.class.php" );
    include_once( PLOG_CLASS_PATH."class/view/adminmessageview.class.php" );
    include_once( PLOG_CLASS_PATH."class/data/stringvalidator.class.php" );
    include_once( PLOG_CLASS_PATH."class/data/integervalidator.class.php" );
    include_once( PLOG_CLASS_PATH."class/data/passwordvalidator.class.php" );
    include_once( PLOG_CLASS_PATH."class/data/emailvalidator.class.php" );
    include_once( PLOG_CLASS_PATH."class/dao/users.class.php" );
    include_once( PLOG_CLASS_PATH."class/dao/userinfo.class.php" );

    /**
     * Adds a new user to the database.
     */
    class AdminAddBlogAction extends SiteAdminAction {

    	var $_blogName;
        var $_ownerId;

    	function AdminAddBlogAction( $actionInfo, $request )
        {
        	$this->SiteAdminAction( $actionInfo, $request );
        }

        function validate()
        {
        	$this->_blogName = $this->_request->getValue( "blogName" );
            $this->_ownerId  = $this->_request->getValue( "blogOwner" );

            $val1 = new StringValidator( $this->_blogName );
            if( !$val1->validate()) {
            	$this->_view = new AdminErrorView( $this->_blogInfo );
                $this->_view->setMessage( $this->_locale->tr("error_must_give_blog_name") );
                $this->setCommonData();

                return false;
            }

            $val2 = new IntegerValidator( $this->_ownerId );
            if( !$val2->validate()) {
            	$this->_view = new AdminErrorView( $this->_blogInfo );
                $this->_view->setMessage( $this->_locale->tr("error_must_give_blog_name") );
                $this->setCommonData();

                return false;
            }

            // check that the user really exists
            $users = new Users();
            $userInfo = $users->getUserInfoFromId( $this->_ownerId );
            if( !$userInfo ) {
            	$this->_view = new AdminErrorView( $this->_blogInfo );
                $this->_view->setMessage( $this->_locale->tr("error_incorrect_blog_owner") );
                $this->setCommonData();

                return false;
            }

            return true;
        }

        function perform()
        {
        	// now that we have validated the data, we can proceed to create the user, making
            // sure that it doesn't already exists
            $blogs = new Blogs();
            $newBlogId = $blogs->addBlog( $this->_blogName, $this->_ownerId );
            if( !$newBlogId) {
            	$this->_view = new AdminErrorView( $this->_blogInfo );
                $this->_view->setMessage( $this->_locale->tr("error_adding_blog") );
                $this->setCommonData();

                return false;
            }

            $this->_view = new AdminMessageView( $this->_blogInfo );
            $this->_view->setMessage($this->_locale->pr("blog_added_ok", $this->_blogName)."<br/><br/>");
            $this->setCommonData();

            return true;
        }
    }
?>
