<?php

	include_once( PLOG_CLASS_PATH."class/action/blogowneradminaction.class.php" );
    include_once( PLOG_CLASS_PATH."class/view/admintemplatedview.class.php" );
    include_once( PLOG_CLASS_PATH."class/view/adminerrorview.class.php" );
    include_once( PLOG_CLASS_PATH."class/view/adminmessageview.class.php" );    
    include_once( PLOG_CLASS_PATH."class/data/stringvalidator.class.php" );
    include_once( PLOG_CLASS_PATH."class/dao/blockedhosts.class.php" );

    /**
     * Adds new blocked content to the blog
     */
    class AdminAddBlogBlockedHostAction extends BlogOwnerAdminAction {

        var $_ip1;
        var $_ip2;
        var $_ip3;
        var $_ip4;
        var $_hostIp;
		var $_mask;
        var $_reason;
        var $_blockType;

    	function AdminAddBlogBlockedHostAction( $actionInfo, $request )
        {
        	$this->BlogOwnerAdminAction( $actionInfo, $request );
        }

        function validate()
        {
        	// get the fields
        	$this->_ip1 = $this->_request->getValue( "ip1" );
            $this->_ip2 = $this->_request->getValue( "ip2" );
            $this->_ip3 = $this->_request->getValue( "ip3" );
            $this->_ip4 = $this->_request->getValue( "ip4" );
            // and build up the ip address
            $this->_hostIp = $this->_ip1.".".$this->_ip2.".".$this->_ip3.".".$this->_ip4;

            // fetch the reason
            $this->_reason = $this->_request->getValue( "reason" );

            // and the type
            $this->_blockType = $this->_request->getValue( "blockType" );
			
			// finally, the mask
			$this->_mask = $this->_request->getValue( "mask" );


            return true;
        }

        function perform()
        {
        	// create the dao object and add the info to the db
            $blockedHosts = new BlockedHosts();
            $result = $blockedHosts->add( $this->_hostIp, $this->_mask, $this->_blogInfo->getId(),
                                          $this->_blockType, BLOCK_BLACKLIST, $this->_reason );

            // and give some feedback to the user
            if( !$result ) {
				$message = $this->_locale->tr("error_adding_blocked_host");
				$message .= "<br/><br/><a href=\"javascript:history.go(-1);\">".$this->_locale->tr("back")."</a>";
                $this->_view = new AdminErrorView( $this->_blogInfo );
            }
            else {
				$message = $this->_locale->pr("blocked_host_added_ok", $this->_hostIp );
				$message .= "<br/><br/><a href=\"admin.php?op=blogBlockedHosts\">".$this->_locale->tr("back")."</a>";
                $this->_view = new AdminMessageView( $this->_blogInfo );
            }

            $this->_view->setMessage( $message );
            $this->setCommonData();

            return true;
        }
    }
?>
