<?php

	include_once( PLOG_CLASS_PATH."class/action/siteadminaction.class.php" );
    include_once( PLOG_CLASS_PATH."class/view/admintemplatedview.class.php" );
    include_once( PLOG_CLASS_PATH."class/view/adminerrorview.class.php" );
    include_once( PLOG_CLASS_PATH."class/view/adminmessageview.class.php" );
    include_once( PLOG_CLASS_PATH."class/data/stringvalidator.class.php" );
    include_once( PLOG_CLASS_PATH."class/dao/filteredcontents.class.php" );

    /**
     * Adds new blocked content to the blog
     */
    class AdminAddFilteredContentAction extends SiteAdminAction {

    	var $_newFilteredContent;
        var $_reason;

    	function AdminAddFilteredContentAction( $actionInfo, $request )
        {
        	$this->SiteAdminAction( $actionInfo, $request );
        }

        function validate()
        {
        	$this->_newFilteredContent = $this->_request->getValue( "filteredContent" );
            $this->_reason = $this->_request->getValue( "reason" );

            $val = new StringValidator( $this->_newFilteredContent );
            if( !$val->validate()) {
            	$this->_view = new AdminErrorView( $this->_blogInfo );
				$message = $this->_locale->tr("error_provide_content_to_block");
				$message .= "<br/><br/><a href=\"javascript:history.go(-1);\">".$this->_locale->tr("back")."</a>";
                $this->_view->setMessage( $message );
                $this->setCommonData();

                return false;
            }

            return true;
        }

        function perform()
        {
        	// create the dao object and add the info to the db
        	$filteredContents = new FilteredContents();
            $result = $filteredContents->addBlogFilteredContent( $this->_newFilteredContent,
                                                                 0,
                                                                 $this->_reason );

            // and give some feedback to the user
            if( !$result ) {
            	$message = $this->_locale->tr("error_adding_blocked_content");
				$message .= "<br/><br/><a href=\"javascript:history.go(-1);\">".$this->_locale->tr("back")."</a>";				
                $this->_view = new AdminErrorView( $this->_blogInfo );
            }
            else {
            	$message = $this->_locale->tr("blocked_content_added_ok");
				$message .= "<br/><br/><a href=\"admin.php?op=filteredContent\">".$this->_locale->tr("view")."</a>";
                $this->_view = new AdminMessageView( $this->_blogInfo );
            }

            $this->_view->setMessage( $message );
            $this->setCommonData();

            return true;
        }
    }
?>
