<?php

	include_once( PLOG_CLASS_PATH."class/action/siteadminaction.class.php" );
    include_once( PLOG_CLASS_PATH."class/view/adminmessageview.class.php" );
    include_once( PLOG_CLASS_PATH."class/view/adminerrorview.class.php" );
    include_once( PLOG_CLASS_PATH."class/template/templateservice.class.php" );
    include_once( PLOG_CLASS_PATH."class/net/httpvars.class.php" );
    include_once( PLOG_CLASS_PATH."class/file/fileuploads.class.php" );

	class AdminAddGlobalTemplateFileAction extends SiteAdminAction {

    	var $_files;
        var $_templateId;

    	function AdminAddGlobalTemplateFileAction( $actionInfo, $request )
        {
        	$this->SiteAdminAction( $actionInfo, $request );
        }

        function validate()
        {
        	// make sure that the user is uploading a file
            $this->_files = HttpVars::getFiles();

            // check if there's any file to upload
            if( count($this->_files) == 0 ) {
            	$this->_view = new AdminErrorView( $this->_blogInfo );
                $this->_view->setMessage( $this->_locale-tr("error_must_upload_file") );
                $this->setCommonData();

                return false;
            }

            // get the template id
            $this->_templateId = $this->_request->getValue( "templateId" );

            return true;
        }

        function perform()
        {
        	// uploads the file and moves it to the correct folder
            $uploads  = new FileUploads( $this->_files );

            // make sure were it should go
            $ts = new TemplateService();
            $destFolder = $ts->getTemplateFolder( $this->_templateId );

            // and move it there
            $processedUploads = $uploads->process( $destFolder );

            // check for the different error conditions we can have
            if( $processedUploads == FILE_UPLOADS_NOT_ENABLED ) {
            	$this->_view = new AdminErrorView( $this->_blogInfo );
            	$this->_view->setMessage( $this->_locale->tr("error_uploads_disabled"));
            	$this->setCommonData();

                return false;
            }

            $fileResult = $processedUploads[0];
            if( $fileResult->getError()) {
            	$this->_view = new AdminErrorView( $this->_blogInfo );
            	$this->_view->setMessage( $this->_locale->tr("error_adding_template_file"));
            	$this->setCommonData();

                return false;
            }

            // now, check if the template is still valid with this new
            // file included
            $this->_view = new AdminMessageView( $this->_blogInfo );
            $this->_view->setMessage( $this->_locale->pr("template_file_added_ok", $this->_templateId));
            $this->setCommonData();

            return true;
        }
    }
?>
