<?php

	include_once( PLOG_CLASS_PATH."class/action/adminaction.class.php" );
    include_once( PLOG_CLASS_PATH."class/dao/mylinkscategory.class.php" );
    include_once( PLOG_CLASS_PATH."class/dao/mylinkscategories.class.php" );
    include_once( PLOG_CLASS_PATH."class/data/stringvalidator.class.php" );
    include_once( PLOG_CLASS_PATH."class/view/adminmessageview.class.php" );

    /**
     * Action that takes care of adding a new link category
     */
    class AdminAddLinkCategoryAction extends AdminAction {

    	var $_linkCategoryName;

    	/**
         * Constructor. If nothing else, it also has to call the constructor of the parent
         * class, BlogAction with the same parameters
         */
        function AdminAddLinkCategoryAction( $actionInfo, $request )
        {
        	$this->AdminAction( $actionInfo, $request );
        }

        /**
         * Makes sure that the information we got from the user is valid
         */
        function validate()
        {
        	$this->_linkCategoryName = $this->_request->getValue( "linkCategoryName" );


            $val = new StringValidator( $this->_linkCategoryName );
            if( !$val->validate()) {
            	$this->_view = new AdminErrorView( $this->_blogInfo );
                $this->_view->setMessage( $this->_locale->tr("error_provide_link_category_name"));
                $this->setCommonData();

                return false;
            }

            return true;
        }

        /**
         * Carries out the specified action
         */
        function perform()
        {
        	// add the new link category to the database
            $mylinksCategories = new MyLinksCategories();
            $mylinksCategory = new MyLinksCategory( $this->_linkCategoryName, $this->_blogInfo->getId());
            if( !$mylinksCategories->addMyLinksCategory( $mylinksCategory, $this->_blogInfo->getId())) {
            	$this->_view = new AdminErrorView( $this->_blogInfo );
                $this->_view->setMessage( $this->_locale->tr("error_adding_link_category"));
                $this->setCommonData();

                return false;
            }

            $this->_view = new AdminMessageView( $this->_blogInfo );
            $this->_view->setMessage( $this->_locale->tr("link_category_added_ok"));
            $this->setCommonData();
            // better to return true if everything fine
            return true;
        }
    }
?>
