<?php

	include_once( PLOG_CLASS_PATH."class/action/adminaction.class.php" );
    include_once( PLOG_CLASS_PATH."class/view/admintemplatedview.class.php" );
    include_once( PLOG_CLASS_PATH."class/view/adminerrorview.class.php" );
    include_once( PLOG_CLASS_PATH."class/view/adminmessageview.class.php" );
    include_once( PLOG_CLASS_PATH."class/gallery/dao/galleryalbums.class.php" );
    include_once( PLOG_CLASS_PATH."class/net/httpvars.class.php" );
    include_once( PLOG_CLASS_PATH."class/gallery/dao/galleryresources.class.php" );

    /**
     * Adds a new resource to an album
     */
    class AdminAddResourceAction extends AdminAction
    {

    	var $_description;
        var $_albumId;
        var $_resource;

    	/**
         * Constructor. If nothing else, it also has to call the constructor of the parent
         * class, BlogAction with the same parameters
         */
        function AdminAddResourceAction( $actionInfo, $request )
        {
        	$this->AdminAction( $actionInfo, $request );
        }

        /**
         * get the data from the request
         */
        function validate()
        {
        	// fetch the information coming from the resource
        	$this->_description = $this->_request->getValue( "resourceDescription" );
            $this->_albumId     = $this->_request->getValue( "albumId" );
            $this->_resource    = $this->_request->getValue( "resourceFile" );

            // check if there is any file uploaded
            $files = HttpVars::getFiles();

            if( count($files) == 0 || $files["resourceFile"]["name"] == "" || $files["resourceFile"]["size"] == 0 ) {
            	$this->_view = new AdminErrorView( $this->_blogInfo );
                $message = $this->_locale->tr( "error_no_resource_uploaded" );
				$message .= "<br/><br/><a href=\"javascript:history.go(-1);\">".$this->_locale->tr("back")."</a>";
				$this->_view->setMessage( $message );
                $this->setCommonData();

            	return false;
            }

            return true;
        }

        /**
         * Carries out the specified action
         */
        function perform()
        {
        	// let the gallery library do its work...
        	$resources = new GalleryResources();
            $files = HttpVars::getFiles();

            $upload = new FileUpload( $files["resourceFile"] );

            // add the resource to the db
            $res = $resources->addResource( $this->_blogInfo->getId(), $this->_albumId,
                                            $this->_description, $upload );

            // check if everything went fine and if not, show an error message
            if( $res > 0 ) {
            	$this->_view = new AdminMessageView( $this->_blogInfo );
				$message = $this->_locale->tr("resource_added_ok");
				$message .= "<br/><br/><a href=\"admin.php?op=resources&amp;albumId=".$this->_albumId."\">".$this->_locale->tr("view")."</a>";
                $this->_view->setMessage( $message );
            }
            else {
            	$this->_view = new AdminErrorView( $this->_blogInfo );
                if( $res == UPLOAD_VALIDATOR_ERROR_FORBIDDEN_EXTENSION )
                  $message = $this->_locale->tr("error_resource_forbidden_extension" );
                elseif( $res == UPLOAD_VALIDATOR_ERROR_UPLOAD_TOO_BIG )
                  $message = $this->_locale->tr("error_resource_too_big" );
                elseif( $res == FILE_UPLOADS_NOT_ENABLED )
                	$message = $this->_locale->tr("error_uploads_disabled" );
                else
                  $message = $this->_locale->tr("error_adding_resource");
				  $message .= "<br/><br/><a href=\"javascript:history.go(-1);\">".$this->_locale->tr("back")."</a>";
				  
				  $this->_view->setMessage( $message );
            }
            $this->setCommonData();

            return true;
        }
    }
?>
