<?php

	include_once( PLOG_CLASS_PATH."class/action/adminaction.class.php" );
    include_once( PLOG_CLASS_PATH."class/view/adminmessageview.class.php" );
    include_once( PLOG_CLASS_PATH."class/view/adminerrorview.class.php" );
    include_once( PLOG_CLASS_PATH."class/data/stringvalidator.class.php" );
    include_once( PLOG_CLASS_PATH."class/gallery/dao/galleryalbums.class.php" );

    /**
     * Adds a new album
     */
    class AdminAddResourceAlbumAction extends AdminAction
    {

    	var $_albumName;
        var $_albumDescription;
        var $_parentId;

    	/**
         * Constructor. If nothing else, it also has to call the constructor of the parent
         * class, BlogAction with the same parameters
         */
        function AdminAddResourceAlbumAction( $actionInfo, $request )
        {
        	$this->AdminAction( $actionInfo, $request );
        }

        function validate()
        {
        	$this->_albumName = $this->_request->getValue( "albumName" );
            $this->_albumDescription = $this->_request->getValue( "albumDescription" );
            $this->_parentId = $this->_request->getValue( "parentId" );

            $val = new StringValidator( $this->_albumName );
            if( !$val->validate()) {
            	$this->_view = new AdminErrorView( $this->_blogInfo );
				$message = $this->_locale->tr("error_must_give_album_name" );
				$message .= "<br/><br/><a href=\"javascript:history.go(-1);\">".$this->_locale->tr("back")."</a>";
                $this->_view->setMessage( $message );
                $this->setCommonData();
                
                return false;
            }

            return true;
        }

        /**
         * Carries out the specified action
         */
        function perform()
        {
        	$albums = new GalleryAlbums();

            $result = $albums->addAlbum( $this->_blogInfo->getId(), $this->_albumName, $this->_albumDescription, $this->_parentId );
            if( $result ) {
            	$this->_view = new AdminMessageView( $this->_blogInfo );
				$message = $this->_locale->pr( "album_added_ok", $this->_albumName );
				$message .= "<br/><br/><a href=\"admin.php?op=resourceAlbums\">".$this->_locale->tr("view")."</a>";								
                $this->_view->setMessage( $message );
            }
            else {
            	$this->_view = new AdminErrorView( $this->_blogInfo );
				$message = $this->_locale->tr("error_adding_album" );
				$message .= "<br/><br/><a href=\"javascript:history.go(-1);\">".$this->_locale->tr("back")."</a>";								
                $this->_view->setMessage( $message );
            }
            $this->setCommonData();

            // better to return true if everything fine
            return true;
        }
    }
?>
