<?php

	include_once( PLOG_CLASS_PATH."class/action/siteadminaction.class.php" );
    include_once( PLOG_CLASS_PATH."class/view/admintemplatedview.class.php" );
    include_once( PLOG_CLASS_PATH."class/view/adminerrorview.class.php" );
    include_once( PLOG_CLASS_PATH."class/view/adminmessageview.class.php" );
    include_once( PLOG_CLASS_PATH."class/data/stringvalidator.class.php" );
    include_once( PLOG_CLASS_PATH."class/data/passwordvalidator.class.php" );
    include_once( PLOG_CLASS_PATH."class/data/emailvalidator.class.php" );
	include_once( PLOG_CLASS_PATH."class/data/integervalidator.class.php" );
    include_once( PLOG_CLASS_PATH."class/dao/users.class.php" );
    include_once( PLOG_CLASS_PATH."class/dao/userinfo.class.php" );
	include_once( PLOG_CLASS_PATH."class/dao/userpermissions.class.php" );

    /**
     * Adds a new user to the database.
     */
    class AdminAddUserAction extends SiteAdminAction {

    	var $_userName;
        var $_userPassword;
        var $_userEmail;
		var $_userBlog;

    	function AdminAddUserAction( $actionInfo, $request )
        {
        	$this->SiteAdminAction( $actionInfo, $request );
        }

        function validate()
        {
        	$this->_userName = $this->_request->getValue( "userName" );
            $this->_userPassword = $this->_request->getValue( "userPassword" );
            $this->_userEmail = $this->_request->getValue( "userEmail" );

            $errors = false;

            $val1 = new StringValidator( $this->_userName );
            if( !$val1->validate()) {
            	$errors = true;
                $message .= $this->_locale->tr("error_incorrect_username")."<br/>";
            }

            $val2 = new PasswordValidator( $this->_userPassword );
            if( !$val2->validate()) {
            	$errors = true;
                if( $val2->getMessage() == ERROR_PASSWORD_TOO_SHORT )
                	$message .= $this->_locale->tr("error_password_incorrect")."<br/>";
                else
                	$message .= $this->_locale->tr("error_password_incorrect")."<br/>";
            }

            $val3 = new EmailValidator( $this->_userEmail );
            if( !$val3->validate()) {
            	$errors = true;
                $message .= $this->_locale->tr("error_incorrect_email_address")."<br/>";
            }
			
			$this->_userBlog = $this->_request->getValue( "userBlog" );
			$val4 = new IntegerValidator( $this->_userBlog );
			if( !$val4->validate()) {
				$errors = true;
				$message .= $this->_locale->tr("error_incorrect_blog_id")."<br/>";
			}

            if( $errors ) {
            	$this->_view = new AdminErrorView( $this->_blogInfo );
                $this->_view->setValue( "message", $message );
                $this->setCommonData();

                return false;
            }
            else
            	return true;

        }

        function perform()
        {
        	// now that we have validated the data, we can proceed to create the user, making
            // sure that it doesn't already exists
            $users = new Users();
            $userInfo = $users->getUserInfoFromUsername( $this->_userName );
            if( $userInfo ) {
            	if( $userInfo->getUsername() == $this->_userName )
                	$message = $this->_locale->tr("error_username_already_exists")."<br/><br/>";
                else
                	$message = $this->_locale->tr("error_username_already_exists")."<br/><br/>";

                $this->_view = new AdminErrorView( $this->_blogInfo );
                $this->_view->setMessage( $message );
                $this->setCommonData();

                return false;
            }

            // otherwise, we can create a new one
            $newUserId = $users->addUser( $this->_userName, $this->_userPassword, $this->_userEmail, "" );
            if( !$newUserId ) {
                $this->_view = new AdminErrorView( $this->_blogInfo );
                $this->_view->setMessage( $this->_locale->tr("error_adding_user"));
                $this->setCommonData();

                return false;
            }
			
			// if the userBlog parameter is different than 0, we have to add a relationship
			// between that user and the blog
			if( $this->_userBlog > 0 ) {
				$permissions = new UserPermissions();
				$result = $permissions->grantPermission( $newUserId, $this->_userBlog, PERMISSION_BLOG_USER );
			}

            $this->_view = new AdminMessageView( $this->_blogInfo );
            $this->_view->setMessage($this->_locale->pr("user_added_ok", $this->_userName)."<br/><br/>");
            $this->setCommonData();

            return true;
        }
    }
?>
