<?php

	include_once( PLOG_CLASS_PATH."class/action/siteadminaction.class.php" );
    include_once( PLOG_CLASS_PATH."class/view/admintemplatedview.class.php" );
    include_once( PLOG_CLASS_PATH."class/dao/blockedhosts.class.php" );

    /**
     * Shows the list of hosts that have been globally blocked
     */
    class AdminBlockedHostsAction extends SiteAdminAction {

        function AdminBlockedHostsAction( $actionInfo, $request )
        {
        	$this->SiteAdminAction( $actionInfo, $request );
        }

        /**
         * Carries out the specified action
         */
        function perform()
        {
        	// get the content that has been filtered by this blog
            $blockedHosts = new BlockedHosts();
            $hostsBlockedFromPosting = $blockedHosts->getBlogBlacklist( GLOBALLY_BLOCKED_HOST, BLOCK_COMMENT_POSTING );
            $hostsBlocked = $blockedHosts->getBlogBlacklist( GLOBALLY_BLOCKED_HOST, BLOCK_ACCESS );

            $blogBlockedHosts = array_merge( $hostsBlockedFromPosting, $hostsBlocked );

            $this->_view = new AdminTemplatedView( $this->_blogInfo, "blockedhosts" );
            $this->_view->setValue( "blockedhosts", $blogBlockedHosts );
            $this->setCommonData();

            // better to return true if everything fine
            return true;
        }
    }
?>
