<?php

	include_once( PLOG_CLASS_PATH."class/action/blogowneradminaction.class.php" );
    include_once( PLOG_CLASS_PATH."class/view/admintemplatedview.class.php" );
    include_once( PLOG_CLASS_PATH."class/dao/blockedhosts.class.php" );

    /**
     * Shows the list of hosts that have been blocked by the current blog
     */
    class AdminBlogBlockedHostsAction extends BlogOwnerAdminAction {

        function AdminBlogBlockedHostsAction( $actionInfo, $request )
        {
        	$this->BlogOwnerAdminAction( $actionInfo, $request );
        }

        /**
         * Carries out the specified action
         */
        function perform()
        {
        	// get the content that has been filtered by this blog
            $blockedHosts = new BlockedHosts();
            $hostsBlockedFromPosting = $blockedHosts->getBlogBlacklist( $this->_blogInfo->getId(), BLOCK_COMMENT_POSTING );
            $hostsBlocked = $blockedHosts->getBlogBlacklist( $this->_blogInfo->getId(), BLOCK_ACCESS );

            $blogBlockedHosts = array_merge( $hostsBlockedFromPosting, $hostsBlocked );

            $this->_view = new AdminTemplatedView( $this->_blogInfo, "blogblockedhosts" );
            $this->_view->setValue( "blockedhosts", $blogBlockedHosts );
            $this->setCommonData();

            // better to return true if everything fine
            return true;
        }
    }
?>
