<?php

	include_once( PLOG_CLASS_PATH."class/action/blogowneradminaction.class.php" );
    include_once( PLOG_CLASS_PATH."class/view/adminblogsettingsview.class.php" );

    /**
     * Action that shows a form to change the settings of the current blog.
     */
    class AdminBlogSettingsAction extends BlogOwnerAdminAction {

    	/**
         * Constructor. If nothing else, it also has to call the constructor of the parent
         * class, BlogAction with the same parameters
         */
        function AdminBlogSettingsAction( $actionInfo, $request )
        {
        	$this->BlogOwnerAdminAction( $actionInfo, $request );
        }

        /**
         * Carries out the specified action
         */
        function perform()
        {
        	$this->_view = new AdminBlogSettingsView( $this->_blogInfo );
            $this->_view->setValue( "blogsettings", $this->_blogInfo->getSettings());

            $ts = new TemplateService();
            $templates = $ts->getAllTemplates( $this->_blogInfo->getId());
            $this->_view->setValue( "templates", $templates);
            $this->_view->setValue( "locales", $this->_config->getValue("locales"));
            $this->setCommonData();

            // better to return true if everything fine
            return true;
        }
    }
?>
