<?php

	include_once( PLOG_CLASS_PATH."class/action/blogowneradminaction.class.php" );
    include_once( PLOG_CLASS_PATH."class/view/adminerrorview.class.php" );
    include_once( PLOG_CLASS_PATH."class/plugin/pluginmanager.class.php" );
    include_once( PLOG_CLASS_PATH."class/view/admintemplatedview.class.php" );

    class AdminConfigurePluginAction extends BlogOwnerAdminAction {

    	var $_pluginId;

        function AdminConfigurePluginAction( $actionInfo, $request )
        {
        	$this->BlogOwnerAdminAction( $actionInfo, $request );
        }

        function validate()
        {
        	$this->_pluginId = $this->_request->getValue( "pluginId" );

            // :TODO:
            // check that the string is valid!!
            //

            return true;
        }

        /**
         * Carries out the specified action
         */
        function perform()
        {
        	// initialize the plugin manager and load the plugins
            $pm = new PluginManager( $this->_blogInfo, $this->_userInfo );

            // check if the plugin manager is enabled or not, since if it's not
            // there is no point in this feature...
            if( !$pm->isEnabled()) {
            	$this->_view = new AdminErrorView( $this->_blogInfo );
                $this->_view->setMessage( $this->_locale->tr("error_plugins_disabled"));
                $this->setCommonData();

                return false;
            }

            // get the configuration message of the plugin
            $pluginConfigMessage = $pm->getPluginConfigurationMessage( $this->_pluginId );

            // check if the message is valid and if it is, continue or show an
            // error otherwise
            if( $pluginConfigMessage == "" ) {
            	$this->_view = new AdminErrorView( $this->_blogInfo );
                $this->_view->setMessage( $this->_locale->tr("error_plugin_cannot_be_configured"));
                $this->setCommonData();
            }
            else {
            	// create a view and put the plugin objects in the template
            	$this->_view = new AdminTemplatedView( $this->_blogInfo, "pluginconfig" );
            	$this->_view->setValue( "pluginconfiguration", $pluginConfigMessage );
            	$this->setCommonData();
            }

            return true;
        }
    }
?>
