<?php

	include_once( PLOG_CLASS_PATH."class/action/siteadminaction.class.php" );
    include_once( PLOG_CLASS_PATH."class/view/adminmessageview.class.php" );
    include_once( PLOG_CLASS_PATH."class/view/adminerrorview.class.php" );
    include_once( PLOG_CLASS_PATH."class/dao/blockedhosts.class.php" );

    /**
     * Deletes a post from the database
     */
    class AdminDeleteBlockedHostAction extends SiteAdminAction {

    	var $_blockedIds;

    	/**
         * Constructor. If nothing else, it also has to call the constructor of the parent
         * class, BlogAction with the same parameters
         */
        function AdminDeleteBlockedHostAction( $actionInfo, $request )
        {
        	$this->SiteAdminAction( $actionInfo, $request );
        }

        /**
         * Validates that the information coming from the user is valid
         */
        function validate()
        {
            $this->_blockedIds = $this->_request->getValue( "deleteBlockedHost" );

            if( count($this->_blockedIds) == 0 ) {
                $this->_view = new AdminErrorView( $this->_blogInfo );
				$message = $this->_locale->tr( "error_no_blocked_hosts_selected" );
				$message .= "<br/><br/><a href=\"javascript:history.go(-1);\">".$this->_locale-tr("back")."</a>";
                $this->_view->setValue( "message", $message );
                $this->setCommonData();

                return false;
            }

            return true;
        }

        /**
         * Carries out the specified action
         */
        function perform()
        {
        	// delete the post (it is not physically deleted but rather, we set
            // the status field to 'DELETED'
            $blockedHosts = new BlockedHosts();
            $message = "";
            foreach( $this->_blockedIds as $blockedId ) {
            	// get the post
                $blockedHost = $blockedHosts->getBlockedHost( $blockedId, GLOBALLY_BLOCKED_HOST );
            	$result = $blockedHosts->remove( $blockedId );
                if( !$result )
					$message .= $this->_locale->pr("error_deleting_blocked_host", $blockedHost->getHost());
                else
					$message .= $this->_locale->pr("blocked_host_deleted_ok", $blockedHost->getHost());

                $message .= "<br/><br/>";
            }


            $this->_view = new AdminMessageView( $this->_blogInfo );
			$message .= "<a href=\"admin.php?op=blockedHosts\">".$this->_locale->tr("back")."</a>";
            $this->_view->setValue( "message", $message );
            $this->setCommonData();

            return true;

        }
    }
?>
