<?php

	include_once( PLOG_CLASS_PATH."class/action/siteadminaction.class.php" );
    include_once( PLOG_CLASS_PATH."class/view/adminerrorview.class.php" );
    include_once( PLOG_CLASS_PATH."class/view/adminmessageview.class.php" );
    include_once( PLOG_CLASS_PATH."class/dao/blogs.class.php" );

	class AdminDeleteBlogAction extends SiteAdminAction {

    	function AdminDeleteBlogAction( $actionInfo, $request )
        {
        	$this->SiteAdminAction( $actionInfo, $request );
        }

        function validate()
        {
        	$this->_blogIds = $this->_request->getValue( "deleteBlogs" );

            if( $this->_blogIds == "" || count($this->_blogIds) == 0 ) {
            	$this->_view = new AdminErrorView( $this->_blogInfo );
                $this->_view->setMessage( $this->_locale->tr("error_no_blogs_selected"));
                $this->setCommonData();

                return false;
            }

            return true;
        }

        function perform()
        {
        	$config =& Config::getConfig();
            $defaultBlogId = $config->getValue( "default_blog_id" );

        	$message = "";
            $blogs = new Blogs();
        	foreach( $this->_blogIds as $blogId ) {
            	// get some info about the blog before deleting it
                $blogInfo = $blogs->getBlogInfo( $blogId );
                // make sure we're not deleting the default one!
                if( $defaultBlogId == $blogId ) {
                	$message .= $this->_locale->pr("error_blog_is_default_blog", $blogInfo->getBlog())."<br /><br/>";
                }
                else {
                	if( $blogs->deleteBlog( $blogId ))
            			$message .= $this->_locale->pr("blog_deleted_ok", $blogInfo->getBlog())."<br/><br/>";
                	else
                		$message .= $this->_locale->pr("error_deleting_blog", $blogInfo->getBlog())."<br/><br/>";
                }
            }

            $this->_view = new AdminMessageView( $this->_blogInfo );
            $this->_view->setMessage( $message );
            $this->setCommonData();

            return true;
        }
    }
?>
