<?php

	include_once( PLOG_CLASS_PATH."class/action/blogowneradminaction.class.php" );
    include_once( PLOG_CLASS_PATH."class/view/adminmessageview.class.php" );
    include_once( PLOG_CLASS_PATH."class/view/adminerrorview.class.php" );
    include_once( PLOG_CLASS_PATH."class/dao/filteredcontents.class.php" );

    /**
     * removes filtered content from a blog
     */
    class AdminDeleteBlogFilteredContentAction extends BlogOwnerAdminAction {

    	var $_deleteFilteredContents;

        function AdminBlogFilteredContentsAction( $actionInfo, $request )
        {
        	$this->BlogOwnerAdminAction( $actionInfo, $request );
        }

        function validate()
        {
        	$this->_deleteFilteredContents = $this->_request->getValue( "deleteBlogFilteredContent" );

            if( count($this->_deleteFilteredContents) == 0 ) {
            	$this->_view = new AdminErrorView( $this->_blogInfo );
                $this->_view->setMessage( $this->_locale->tr("error_no_contents_selected_to_remove"));
                $this->setCommonData();

                return false;
            }

            return true;
        }

        /**
         * Carries out the specified action
         */
        function perform()
        {
        	// get the content that has been filtered by this blog
            $filteredContents = new FilteredContents();
            $blogFilteredContents = $filteredContents->getBlogFilteredContents( $this->_blogInfo->getId());

            // loop through the array of things to remove
            $message = "";
            foreach( $this->_deleteFilteredContents as $filteredContentId ) {
            	// fetch the content
                $blogFilteredContent = $filteredContents->getBlogFilteredContent( $filteredContentId, $this->_blogInfo->getId() );
                // first remove it
                if( !$filteredContents->removeBlogFilteredContent( $filteredContentId, $this->_blogInfo->getId()))
                	$message .= $this->_locale->pr("error_deleting_content", $blogFilteredContent->getRegExp(false))."<br/><br/>";
                else
                	$message .= $this->_locale->pr("content_deleted_ok", $blogFilteredContent->getRegExp(false))."<br/><br/>";
            }

            $this->_view = new AdminMessageView( $this->_blogInfo );
            $this->_view->setMessage( $message );
            $this->setCommonData();

            // better to return true if everything fine
            return true;
        }
    }
?>
