<?php

	include_once( PLOG_CLASS_PATH."class/action/blogowneradminaction.class.php" );
    include_once( PLOG_CLASS_PATH."class/view/admintemplatedview.class.php" );
    include_once( PLOG_CLASS_PATH."class/view/adminmessageview.class.php" );
    include_once( PLOG_CLASS_PATH."class/view/adminerrorview.class.php" );
    include_once( PLOG_CLASS_PATH."class/dao/users.class.php" );
    include_once( PLOG_CLASS_PATH."class/dao/userpermissions.class.php" );

    /**
     * Revokes the permissions some users might have in a given blog
     */
    class AdminDeleteBlogUserPermissionsAction extends BlogOwnerAdminAction {

    	var $_revokedUsers;

    	function AdminDeleteBlogUserPermissionsAction( $actionInfo, $request )
        {
        	$this->BlogOwnerAdminAction( $actionInfo, $request );
        }

        function validate()
        {
        	$this->_revokedUsers = $this->_request->getValue( "revokeUsers" );

            if( count($this->_revokedUsers) == 0 ) {
            	$this->_view = new AdminErrorView();
                $this->_view->setMessage( $this->_locale->tr("error_no_users_selected_to_remove_from_blog") );
                $this->setCommonData();

            	return false;
            }

            return true;
        }

        function perform()
        {
        	// now that we have the list of users we'd like to remove
            // let's go through it and remove those that have been selected
            $users = new Users();
            $userPermissions = new UserPermissions();
            foreach( $this->_revokedUsers as $userId ) {
            	$res = $userPermissions->revokePermission( $userId, $this->_blogInfo->getId(), PERMISSION_BLOG_USER );
                $userInfo = $users->getUserInfoFromId( $userId );
                if( $res )
                	$message .= $this->_locale->pr("user_removed_from_blog_ok", $userInfo->getUsername())."<br/><br/>";
                else
                	$message .= $this->_locale->pr("error_removing_user_from_blog", $userInfo->getUsername())."<br/><br/>";
            }

            $this->_view = new AdminMessageView( $this->_blogInfo );
            $this->_view->setMessage( $message );
            $this->setCommonData();

            return true;
        }
    }
?>
