<?php

	include_once( PLOG_CLASS_PATH."class/action/adminaction.class.php" );
    include_once( PLOG_CLASS_PATH."class/view/adminerrorview.class.php" );
    include_once( PLOG_CLASS_PATH."class/view/adminmessageview.class.php" );
    include_once( PLOG_CLASS_PATH."class/dao/mylinks.class.php" );

    /**
     * Action that shows a form to change the settings of the current blog.
     */
    class AdminDeleteLinkAction extends AdminAction {

        var $_linkIds;

    	/**
         * Constructor. If nothing else, it also has to call the constructor of the parent
         * class, BlogAction with the same parameters
         */
        function AdminDeleteLinkAction( $actionInfo, $request )
        {
        	$this->AdminAction( $actionInfo, $request );
        }

        /**
         * checks that the parameters are all correct
         */
        function validate()
        {
            $this->_linkIds = $this->_request->getValue( "deleteLinks" );
            if( count($this->_linkIds) == 0 ) {
            	$this->_view = new AdminErrorView( $this->_blogInfo );
                $this->_view->setMessage( $this->_locale->tr("error_no_links_selected"));
                $this->setCommonData();

                return false;
            }

            return true;
        }

        /**
         * Carries out the specified action
         */
        function perform()
        {
        	// delete the link
            $links = new MyLinks();

            $message = "";
            foreach( $this->_linkIds as $linkId ) {
            	// load the link
                $link = $links->getMyLink( $linkId, $this->_blogInfo->getId());
            	if( !$links->deleteMyLink( $linkId, $this->_blogInfo->getId()))
                	$message .= $this->_locale->pr("error_removing_link", $link->getName())."<br/><br/>";
                else
            		$message .= $this->_locale->pr("link_deleted_ok", $link->getName())."<br/><br/>";
            }

            $this->_view = new AdminMessageView( $this->_blogInfo );
            $this->_view->setMessage( $message );
            $this->setCommonData();

            // better to return true if everything fine
            return true;
        }
    }
?>
