<?php

	include_once( PLOG_CLASS_PATH."class/action/adminaction.class.php" );
    include_once( PLOG_CLASS_PATH."class/view/adminerrorview.class.php" );
    include_once( PLOG_CLASS_PATH."class/view/adminmessageview.class.php" );
    include_once( PLOG_CLASS_PATH."class/dao/mylinkscategories.class.php" );

    /**
     * Action that deletes a link category from the database
     */
    class AdminDeleteLinkCategoryAction extends AdminAction {

        var $_categoryIds;

    	/**
         * Constructor. If nothing else, it also has to call the constructor of the parent
         * class, BlogAction with the same parameters
         */
        function AdminDeleteLinkCategoryAction( $actionInfo, $request )
        {
        	$this->AdminAction( $actionInfo, $request );
        }

        /**
         * checks that the parameters are all correct
         */
        function validate()
        {
            $this->_categoryIds = $this->_request->getValue( "deleteLinkCategories" );
            if( count($this->_categoryIds) == 0 ) {
            	$this->_view = new AdminErrorView( $this->_blogInfo );
                $this->_view->setMessage( $this->_locale->tr("error_no_link_category_selected"));
                $this->setCommonData();

                return false;
            }

            return true;
        }

        /**
         * Carries out the specified action
         */
        function perform()
        {
        	// delete the link category, but only if there are no links under it
            $categories = new MyLinksCategories();
            $message = "";
            foreach( $this->_categoryIds as $categoryId ) {
            	// fetch the category
                $linkCategory = $categories->getMyLinksCategory( $categoryId, $this->_blogInfo->getId());
                if( $linkCategory ) {
            		if( $categories->getNumMyLinksCategory( $categoryId ) > 0 ) {
                		$message .= $this->_locale->pr("error_links_in_link_category",$linkCategory->getName())."<br/><br/>";
                	}
                	else {
            			// if all correct, now delete it and check how it went
            			if( !$categories->deleteMyLinksCategory( $categoryId, $this->_blogInfo->getId())) {
                        	$message .= $this->_locale->pr("error_removing_link_category", $linkCategory->getName());
            			}
                    	else
                        	$message .= $this->_locale->pr( "link_category_deleted_ok", $linkCategory->getName())."<br/><br/>";
                	}
                }
                else {              
                	$message .= $this->_locale->pr("error_removing_link_category_2", $categoryId )."<br/><br/>";
                }
            }

            $this->_view = new AdminMessageView( $this->_blogInfo );
            $this->_view->setMessage( $message );
            $this->setCommonData();

            // better to return true if everything fine
            return true;
        }
    }
?>
