<?php

	include_once( PLOG_CLASS_PATH."class/action/siteadminaction.class.php" );
    include_once( PLOG_CLASS_PATH."class/view/adminerrorview.class.php" );
    include_once( PLOG_CLASS_PATH."class/view/adminmessageview.class.php" );
    include_once( PLOG_CLASS_PATH."class/locale/locales.class.php" );

    class AdminDeleteLocalesAction extends SiteAdminAction {

    	function AdminSiteLocalesAction( $actionInfo, $request )
        {
        	$this->SiteAdminAction( $actionInfo, $request );
        }

        function validate()
        {
        	$this->_localeIds = $this->_request->getValue( "deleteLocale" );

            if( (!is_array($this->_localeIds)) || (count($this->_localeIds) == 0 )) {
            	$this->_view = new AdminErrorView( $this->_blogInfo );
                $this->_view->setMessage( $this->_locale->tr("error_no_locales_selected") );
                $this->setCommonData();

            	return false;
            }

            if( empty($this->_localeIds )) {
            	$this->_view = new AdminErrorView( $this->_blogInfo );
                $this->_view->setMessage( $this->_locale->tr("error_no_locales_selected") );
                $this->setCommonData();

            	return false;
            }

            return true;
        }

        function perform()
        {

            $locales = new Locales();

            // if there is only one locale available in the system, we should
            // not allow to remove it either
            if( count($locales->getAvailableLocales()) == 1 ) {
            	$this->_view = new AdminErrorView( $this->_blogInfo );
                $this->_view->setMessage( $this->_locale->tr("error_deleting_only_locale"));
                $this->setCommonData();

                return false;
            }

            // keep the value of the default locale because plog should not allow
            // to remove the default one
            $defaultLocale = $this->_config->getValue( "default_locale" );

            $message = "";
            foreach( $this->_localeIds as $localeId ) {
            	if( $localeId != $defaultLocale ) {
            		if( $locales->removeLocale( $localeId ))
                    	$message .= $this->_locale->pr("locale_deleted_ok", $localeId)."<br/><br/>";
                    else
                    	$message .= $this->_locale->pr("error_deleting_locale", $localeId)."<br/><br/>";
                }
                else {
                    $message .= $this->_locale->pr("error_cant_delete_default_locale", $localeId)."<br/><br/>";
                }
            }

            //
            // :TODO:
            //
            // when a locale is deleted, should we make sure that the hosts that are
            // using it use anoter locale, since the we just deleted the one that
            // they were using????
            //

            $this->_view = new AdminMessageView( $this->_blogInfo );
            $this->_view->setMessage( $message );
            $this->setCommonData();

            return true;
        }
    }
?>
