<?php

	include_once( PLOG_CLASS_PATH."class/action/adminaction.class.php" );
    include_once( PLOG_CLASS_PATH."class/view/adminerrorview.class.php" );
    include_once( PLOG_CLASS_PATH."class/view/adminmessageview.class.php" );
    include_once( PLOG_CLASS_PATH."class/gallery/dao/galleryresource.class.php" );
    include_once( PLOG_CLASS_PATH."class/gallery/dao/galleryalbums.class.php" );

    /**
     * Deletes a resource from the blog
     */
    class AdminDeleteResourceAction extends AdminAction
    {

    	var $_resourceIds;

    	/**
         * Constructor. If nothing else, it also has to call the constructor of the parent
         * class, BlogAction with the same parameters
         */
        function AdminDeleteResourceAction( $actionInfo, $request )
        {
        	$this->AdminAction( $actionInfo, $request );
        }

        function validate()
        {
        	$this->_resourceIds = $this->_request->getValue( "deleteResource" );
			$this->_albumId = $this->_request->getValue( "albumId" );

            if( count($this->_resourceIds) == 0 ) {
            	$this->_view = new AdminErrorView( $this->_blogInfo );
				$message = $this->_locale->tr("error_no_resources_selected");
				$message .= "<br/><br/><a href=\"javascript:history.go(-1);\">".$this->_locale->tr("back")."</a>";
                $this->_view->setMessage( $message );
                $this->setCommonData();

            	return false;
            }

            return true;
        }

        /**
         * Carries out the specified action
         */
        function perform()
        {
        	// load the resource
        	$resources = new GalleryResources();

            // loop through the array of resource ids and
            // remove them all
            foreach( $this->_resourceIds as $resourceId => $value ) {
            	// fetch the resource first, to get some info about it
                $resource = $resources->getResource( $resourceId, $this->_blogInfo->getId());
                // and now remove it
            	$res = $resources->deleteResource( $resourceId, $this->_blogInfo->getId());
                if( $res )
                	$message .= $this->_locale->pr("resource_deleted_ok", $resource->getFileName())."<br/><br/>";
                else 
                	$message .= $this->_locale->pr("error_deleting_resource", $resourceId )."<br/><br/>";
            }

            // return the view
            $this->_view = new AdminMessageView( $this->_blogInfo );
			$message .= "<br/><br/><a href=\"admin.php?op=resources&albumId=".$this->_albumId."\">".$this->_locale->tr("back")."</a>";
            $this->_view->setMessage( $message );
            $this->setCommonData();

            // better to return true if everything fine
            return true;
        }
    }
?>
