<?php

	include_once( PLOG_CLASS_PATH."class/action/siteadminaction.class.php" );
    include_once( PLOG_CLASS_PATH."class/view/adminerrorview.class.php" );
    include_once( PLOG_CLASS_PATH."class/template/templateservice.class.php" );
	include_once( PLOG_CLASS_PATH."class/view/adminmessageview.class.php" );

    /**
     * Removes a global template from disk.
     */
    class AdminDeleteTemplatesAction extends SiteAdminAction {

    	var $_templateIds;

        function AdminDeleteTemplatesAction( $actionInfo, $request )
        {
        	$this->SiteAdminAction( $actionInfo, $request );
        }

        function validate()
        {
        	$this->_templateIds = $this->_request->getValue( "deleteTemplate" );

            if( count($this->_templateIds) == 0 ) {
            	$this->_view = new AdminErrorView( $this->_blogInfo );
				$message = $this->_locale->tr("error_no_templates_selected");
				$message .= "<br/><br/><a href=\"admin.php?op=siteTemplates\">".$this->_locale->tr("back")."</a>";
                $this->_view->setMessage( $message );
                $this->setCommonData();

                return false;
            }

            return true;
        }

        /**
         * Carries out the specified action
         */
        function perform()
        {
        	$ts = new TemplateService();

            foreach( $this->_templateIds as $templateId ) {
            	if( !$ts->removeTemplate( $templateId ))
                	$message .= $this->_locale->pr("error_removing_template", $templateId )."<br/><br/>";
                else
                	$message .= $this->_locale->pr("template_removed_ok", $templateId)."<br/><br/>";
            }
			
			$message .= "<a href=\"admin.php?op=siteTemplates\">".$this->_locale->tr("back")."</a>";			

            $this->_view = new AdminMessageView( $this->_blogInfo );
            $this->_view->setMessage( $message );
            $this->setCommonData();

            return true;
        }
    }
?>
