<?php

	include_once( PLOG_CLASS_PATH."class/action/siteadminaction.class.php" );
    include_once( PLOG_CLASS_PATH."class/dao/users.class.php" );
    include_once( PLOG_CLASS_PATH."class/data/integervalidator.class.php" );
    include_once( PLOG_CLASS_PATH."class/view/adminerrorview.class.php" );
    include_once( PLOG_CLASS_PATH."class/view/adminmessageview.class.php" );

	class AdminDeleteUsersAction extends SiteAdminAction {

    	var $_usersId;

    	function AdminDeleteUsersAction( $actionInfo, $request )
        {
        	$this->SiteAdminAction( $actionInfo, $request );
        }

        function validate()
        {
        	// array with the ids of the users we want to remove
        	$this->_usersId = $this->_request->getValue( "deleteUsers" );

            return true;
        }

        function perform()
        {
            if( empty($this->_usersId)) {
            	$this->_view = new AdminErrorView( $this->_blogInfo );
                $this->_view->setMessage( $this->_locale->tr("error_no_users_selected") );
                $this->setCommonData();

                return false;
            }

            $message = "";
            $users = new Users();
            // go user by user to remove them
            foreach( $this->_usersId as $userId ) {
            	// get some info about the user
                $userInfo = $users->getUserInfoFromId( $userId );
                if( !$userInfo ) {
                	$message .= $this->_locale->pr("error_could_not_find_user", $userId )."<br/><br/>";
                }
                else {
                	if( !$users->deleteUser( $userId ))
                    	$message .= $this->_locale->pr("error_deleting_user", $userInfo->getUsername())."<br/><br/>";
                    else
                    	$message .= $this->_locale->pr("user_deleted_ok", $userInfo->getUsername())."<br/><br/>";
                }
            }

            $this->_view = new AdminMessageView( $this->_blogInfo );
			$message .= "<br/><a href=\"admin.php?op=editSiteUsers\">".$this->_locale->tr("back")."</a>";
            $this->_view->setMessage( $message );
            $this->setCommonData();

            return false;
        }

    }
?>
