<?php

	include_once( PLOG_CLASS_PATH."class/action/adminaction.class.php" );
    include_once( PLOG_CLASS_PATH."class/view/admineditarticlecategoryview.class.php" );
    include_once( PLOG_CLASS_PATH."class/view/adminerrorview.class.php" );
    include_once( PLOG_CLASS_PATH."class/dao/articlecategories.class.php" );

    /**
     * Action that shows a form to change the settings of the article category
     */
    class AdminEditArticleCategoryAction extends AdminAction {

    	var $_categoryId;

    	/**
         * Constructor. If nothing else, it also has to call the constructor of the parent
         * class, BlogAction with the same parameters
         */
        function AdminEditArticleCategoryAction( $actionInfo, $request )
        {
        	$this->AdminAction( $actionInfo, $request );
        }

        /**
         * Checks that the categoryId parameter is valid
         */
        function validate()
        {
        	$this->_categoryId = $this->_request->getValue( "categoryId" );

            if( $this->_categoryId == "" || $this->_categoryId <= 0 ) {
            	$this->_view = new AdminErrorView( $this->_blogInfo );
                $this->_view->setMessage( $this->_locale->tr("error_incorrect_category_id"));
                $this->setCommonData();

                return false;
            }

            return true;
        }

        /**
         * Carries out the specified action
         */
        function perform()
        {
        	// fetch the category
            $categories = new ArticleCategories();
            $category   = $categories->getCategory( $this->_categoryId, $this->_blogInfo->getId());
            // show an error if we couldn't fetch the category
            if( !$category ) {
            	$this->_view = new AdminErrorView( $this->_blogInfo );
                $this->_view->setMessage( $this->_locale->tr("error_fetching_category") );
                $this->setCommonData();

                return false;
            }
            // otherwise show the form to edit its fields
        	$this->_view = new AdminEditArticleCategoryView( $this->_blogInfo );
            $this->_view->setValue( "category", $category );
            $this->setCommonData();

            // better to return true if everything fine
            return true;
        }
    }
?>
