<?php

	include_once( PLOG_CLASS_PATH."class/action/siteadminaction.class.php" );
    include_once( PLOG_CLASS_PATH."class/view/admintemplatedview.class.php" );
    include_once( PLOG_CLASS_PATH."class/view/adminerrorview.class.php" );
    include_once( PLOG_CLASS_PATH."class/dao/blogs.class.php" );
    include_once( PLOG_CLASS_PATH."class/dao/users.class.php" );

    /**
     * Action that shows a form to change the settings of a blog.
     */
    class AdminEditBlogAction extends SiteAdminAction {

    	var $_editBlogId;

    	/**
         * Constructor. If nothing else, it also has to call the constructor of the parent
         * class, BlogAction with the same parameters
         */
        function AdminEditBlogAction( $actionInfo, $request )
        {
        	$this->SiteAdminAction( $actionInfo, $request );
        }

        function validate()
        {
        	$this->_editBlogId = $this->_request->getValue( "editBlogId" );

            return true;
        }

        /**
         * Carries out the specified action
         */
        function perform()
        {
        	// get the blog and its settings
            $blogs = new Blogs();
            $blogInfo = $blogs->getBlogInfo( $this->_editBlogId);

            if( !$blogInfo ) {
            	$this->_view = new AdminErrorView( $this->_blogInfo );
                $this->_view->setMessage( $this->_locale->tr("error_incorrect_blog_id" ));
                $this->setCommonData();

                return false;
            }

            $blogSettings = $blogInfo->getSettings();

            // get all the users
            $users = new Users();
            $siteUsers = $users->getAllUsers();

        	$this->_view = new AdminTemplatedView( $this->_blogInfo, "editblog" );
            $this->_view->setValue( "editblog", $blogInfo );
            $this->_view->setValue( "editblogsettings", $blogSettings );

            $this->_view->setValue( "templates", $this->_config->getValue( "templates" ));
            $this->_view->setValue( "locales", $this->_config->getValue("locales"));
            $this->_view->setValue( "siteusers", $siteUsers );
            $this->setCommonData();

            // better to return true if everything fine
            return true;
        }
    }
?>
