<?php

	include_once( PLOG_CLASS_PATH."class/action/blogowneradminaction.class.php" );
    include_once( PLOG_CLASS_PATH."class/view/admintemplatedview.class.php" );
    include_once( PLOG_CLASS_PATH."class/view/adminerrorview.class.php" );
    include_once( PLOG_CLASS_PATH."class/dao/blockedhosts.class.php" );
    include_once( PLOG_CLASS_PATH."class/data/integervalidator.class.php" );

    /**
     * Changes the settings of a blocked host
     */
    class AdminEditBlogBlockedHostAction extends BlogOwnerAdminAction
    {

    	var $_hostId;

    	/**
         * Constructor. If nothing else, it also has to call the constructor of the parent
         * class, BlogAction with the same parameters
         */
        function AdminEditBlogBlockedHostAction( $actionInfo, $request )
        {
        	$this->BlogOwnerAdminAction( $actionInfo, $request );
        }

        function validate()
        {
        	$this->_hostId = $this->_request->getValue( "hostId" );

            $val = new IntegerValidator( $this->_hostId );
            if( !$val->validate()) {
            	$this->_view = new AdminErrorView( $this->_blogInfo );
                $this->_view->setMessage( $this->_locale->tr( "error_incorrect_blocked_host_id" ));
                $this->setCommonData();

                return false;
            }

            return true;
        }

        /**
         * Carries out the specified action
         */
        function perform()
        {
        	$blockedHosts = new BlockedHosts();
            $blockedHost = $blockedHosts->getBlockedHost( $this->_hostId, $this->_blogInfo->getId());

            // check if the info about the blocked host is correct
            if( !$blockedHost ) {
            	$this->_view = new AdminErrorView( $this->_blogInfo );
                $this->_view->setMessage( $this->_locale->tr( "error_fetching_blocked_host" ));
                $this->setCommonData();

                return false;
            }

            // if so, continue
            $this->_view = new AdminTemplatedView( $this->_blogInfo, "editblogblockedhost" );
            $this->_view->setValue( "blockedhost", $blockedHost );

            // to make things easier in the template, let's do the following:
            $ipParts = explode( ".", $blockedHost->getHost());
            $this->_view->setValue( "ip1", $ipParts[0] );
            $this->_view->setValue( "ip2", $ipParts[1] );
            $this->_view->setValue( "ip3", $ipParts[2] );
            $this->_view->setValue( "ip4", $ipParts[3] );

            $this->setCommonData();

            // better to return true if everything fine
            return true;
        }
    }
?>
