<?php

	include_once( PLOG_CLASS_PATH."class/action/blogowneradminaction.class.php" );
    include_once( PLOG_CLASS_PATH."class/view/admintemplatedview.class.php" );
    include_once( PLOG_CLASS_PATH."class/view/adminerrorview.class.php" );
    include_once( PLOG_CLASS_PATH."class/data/integervalidator.class.php" );
    include_once( PLOG_CLASS_PATH."class/dao/filteredcontents.class.php" );

    /**
     * Shows a form to add a new blocked content to the blog
     */
    class AdminEditBlogFilteredContentAction extends BlogOwnerAdminAction
    {

    	var $_contentId;

    	function AdminEditBlogFilteredContentAction( $actionInfo, $request )
        {
        	$this->BlogOwnerAdminAction( $actionInfo, $request );
        }

        function validate()
        {
        	$this->_contentId = $this->_request->getValue( "contentId" );

            $val = new IntegerValidator( $this->_contentId );
            if( !$val->validate()) {
            	$this->_view = new AdminErrorView( $this->_locale->tr("error_incorrect_content_id"));
                $this->setCommonData();

                return false;
            }

            return true;
        }

        function perform()
        {
        	// fetch the filtered content that we're going to edit
            $contents = new FilteredContents();
            $filteredContent = $contents->getBlogFilteredContent( $this->_contentId, $this->_blogInfo->getId());

            if( !$filteredContent ) {
            	$this->_view = new AdminErrorView( $this->_blogInfo );
                $this->_view->setMessage( $this->_locale->tr("error_fetching_filtered_content"));
                $this->setCommonData();

            	return false;
            }

        	$this->_view = new AdminTemplatedView( $this->_blogInfo, "editblogfilteredcontent" );
            $this->_view->setValue( "filteredcontent", $filteredContent );
            $this->setCommonData();

            return true;
        }
    }
?>