<?php

	include_once( PLOG_CLASS_PATH."class/action/adminaction.class.php" );
    include_once( PLOG_CLASS_PATH."class/view/admineditcommentsview.class.php" );
    include_once( PLOG_CLASS_PATH."class/dao/articlecomments.class.php" );
    include_once( PLOG_CLASS_PATH."class/data/integervalidator.class.php" );
    include_once( PLOG_CLASS_PATH."class/dao/articles.class.php" );

    /**
     * Action that shows a list of all the comments for a given post
     */
    class AdminEditCommentsAction extends AdminAction {

    	var $_articleId;

    	/**
         * Constructor. If nothing else, it also has to call the constructor of the parent
         * class, BlogAction with the same parameters
         */
        function AdminEditCommentsAction( $actionInfo, $request )
        {
        	$this->AdminAction( $actionInfo, $request );
        }

        /**
         * Checks that the post id is correct.
         */
        function validate()
        {
        	$this->_articleId = $this->_request->getValue( "postId" );

            $validator = new IntegerValidator( $this->_articleId );
            if( !$validator->validate()) {
            	$this->_view = new AdminErrorView( $this->_blogInfo );
                $this->_view->setMessage( $this->_locale->tr("error_incorrect_article_id"));
                $this->setCommonData();
                return false;
            }

            return true;
        }

        /**
         * Carries out the specified action
         */
        function perform()
        {
        	$this->_view = new AdminEditCommentsView( $this->_blogInfo );

            // fetch the article
            $articles = new Articles();
            $article  = $articles->getBlogArticle( $this->_articleId, $this->_blogInfo->getId());
            if( !$article ) {
            	$this->_view = new AdminErrorView( $this->_blogInfo );
                $this->_view->setMessage( $this->_locale->tr("error_fetching_post" ));
                $this->setCommonData();

                return false;
            }

            $comments = new ArticleComments();
            $postComments = $comments->getPostComments( $this->_articleId );
            if( !$postComments ) {
            	$this->_view = new AdminErrorView( $this->_blogInfo );
                $this->_view->setMessage( $this->_locale->tr("error_fetching_comments"));
                $this->setCommonData();
                return false;
            }

            $this->_view->setValue( "comments", $postComments);
            $this->_view->setValue( "post", $article );
            $this->setCommonData();

            // better to return true if everything fine
            return true;
        }
    }
?>
