<?php

	include_once( PLOG_CLASS_PATH."class/action/adminaction.class.php" );
    include_once( PLOG_CLASS_PATH."class/view/admineditlinkview.class.php" );
    include_once( PLOG_CLASS_PATH."class/view/adminerrorview.class.php" );
    include_once( PLOG_CLASS_PATH."class/dao/mylinkscategories.class.php" );
    include_once( PLOG_CLASS_PATH."class/dao/mylinkscategory.class.php" );
    include_once( PLOG_CLASS_PATH."class/dao/mylinks.class.php" );
    include_once( PLOG_CLASS_PATH."class/dao/mylink.class.php" );

    /**
     * Action that shows a form to change the settings of the link
     */
    class AdminEditLinkAction extends AdminAction {

    	var $_linkId;

    	/**
         * Constructor. If nothing else, it also has to call the constructor of the parent
         * class, BlogAction with the same parameters
         */
        function AdminEditLinkAction( $actionInfo, $request )
        {
        	$this->AdminAction( $actionInfo, $request );
        }

        /**
         * Checks that the categoryId parameter is valid
         */
        function validate()
        {
        	$this->_linkId = $this->_request->getValue( "linkId" );

            if( $this->_linkId == "" || $this->_linkId <= 0 ) {
            	$this->_view = new AdminErrorView( $this->_blogInfo );
                $this->_view->setMessage( $this->_locale->tr("error_invalid_link_id"));
                $this->setCommonData();

                return false;
            }

            return true;
        }

        /**
         * Carries out the specified action
         */
        function perform()
        {
        	// fetch the link
            $links = new MyLinks();
            $link  = $links->getMyLink( $this->_linkId, $this->_blogInfo->getId());
            // show an error if we couldn't fetch the link
            if( !$link ) {
            	$this->_view = new AdminErrorView( $this->_blogInfo );
                $this->_view->setMessage( $this->_locale->tr("error_fetching_link"));
                $this->setCommonData();

                return false;
            }

            // fetch and check the link categories and the category to which this
            // link belongs.
            $categories = new MyLinksCategories();
            $linkCategories = $categories->getMyLinksCategories( $this->_blogInfo->getId());
            if( !$linkCategories ) {
            	$this->_view = new AdminErrorView( $this->_blogInfo );
                $this->_view->setMessage( $this->_locale->tr("error_fetching_link_categories"));
                $this->setCommonData();

                return false;
            }
            $linkCategory = $categories->getMyLinksCategory( $link->getCategoryId(), $this->_blogInfo->getId());

            // otherwise show the form to edit its fields
        	$this->_view = new AdminEditLinkView( $this->_blogInfo );
            $this->_view->setValue( "link", $link );
            $this->_view->setValue( "linkcategory", $linkCategory );
            $this->_view->setValue( "linkcategories", $linkCategories );
            $this->setCommonData();

            // better to return true if everything fine
            return true;
        }
    }
?>
