<?php

	include_once( PLOG_CLASS_PATH."class/action/adminaction.class.php" );
    include_once( PLOG_CLASS_PATH."class/view/admineditlinksview.class.php" );
    include_once( PLOG_CLASS_PATH."class/dao/mylinks.class.php" );
    include_once( PLOG_CLASS_PATH."class/dao/mylinkscategories.class.php" );    

    /**
     * Action that shows the list of user defined links (blogroll)
     */
    class AdminEditLinksAction extends AdminAction {

    	var $_categoryId;

    	/**
         * Constructor. If nothing else, it also has to call the constructor of the parent
         * class, BlogAction with the same parameters
         */
        function AdminEditLinksAction( $actionInfo, $request )
        {
        	$this->AdminAction( $actionInfo, $request );
        }

        /**
         * validates the data
         */
        function validate()
        {
        	// categoryId == 0 means that we want to see all of them
        	$this->_categoryId = $this->_request->getValue( "showCategory" );
            if( $this->_categoryId == "" )
            	$this->_categoryId = 0;
        	return true;
        }

        /**
         * Carries out the specified action
         */
        function perform()
        {
        	// get all the links
        	$links = new MyLinks();
            $blogLinks = $links->getLinks( $this->_blogInfo->getId(), $this->_categoryId );
            // get all the link categories
            $linkCategories = new MyLinksCategories();
            $blogLinkCategories = $linkCategories->getMyLinksCategories( $this->_blogInfo->getId());

            // create the view and fill the template context
            $this->_view = new AdminEditLinksView( $this->_blogInfo );
            $this->_view->setValue( "links", $blogLinks );
            $this->_view->setValue( "linkscategories", $blogLinkCategories );
            $this->_view->setValue( "currentcategory", $this->_categoryId );
            $this->setCommonData();

            // better to return true if everything fine
            return true;
        }
    }
?>
