<?php

	include_once( PLOG_CLASS_PATH."class/action/adminaction.class.php" );
    include_once( PLOG_CLASS_PATH."class/view/admineditpostsview.class.php" );
    include_once( PLOG_CLASS_PATH."class/dao/articles.class.php" );
    include_once( PLOG_CLASS_PATH."class/dao/articlecategories.class.php" );

    /**
     * Fetches all the posts and offers them for edition or deletion.
     */
    class AdminEditPostsAction extends AdminAction 
    {

    	var $_showCategory = 0;
        var $_showStatus   = 1;
        var $_showUser     = 0;
        var $_showMonth;

    	/**
         * Constructor. If nothing else, it also has to call the constructor of the parent
         * class, BlogAction with the same parameters
         */
        function AdminEditPostsAction( $actionInfo, $request )
        {
        	$this->AdminAction( $actionInfo, $request );        	
        }
        
        function _getMonths()
        {
        	$articles = new Articles();
            $archiveStats = $articles->getNumberPostsPerMonthAdmin( $this->_blogInfo->getId());
            
            if( !$archiveStats )
            	return Array();          
            	
            $result = Array();
            
            $t = new Timestamp();
            $curyear = (int)$t->getYear();
            $curmonth = (int)$t->getMonth();

            foreach( $archiveStats as $yearName => $year) {
            	foreach( $year as $monthName => $month ) {
            	   // the next bit is so disgustingly ugly that I am ashamed of it... 
            	   // what I'm trying to do here is that the getNumberPostsPerMonthAdmin() method
            	   // won't return the current month if there wasn't anything posted during it but
            	   // we still should show the current month even if there's nothing in it, because otherwise
            	   // when generating page where the posts are listed, it will end up saying "Date: All" 
            	   // but no posts at all shown (it didn't have anything to show) This is a way of
            	   // "introducing" a month in the array without fucking it up. In fact, PHP *was*
            	   // indeed fucking it up... it didn't just want to keep the order! Oh well, it's a very
            	   // long and stupid story but we need this hack, ok? :)
            	    if( $archiveStats[$curyear][$curmonth] == "" && !$alreadyAdded ) {
            	       // there goes the dirty hack :P
            	       if( $yearName == $curyear && $monthName < $curmonth ) {
            	            $t = new Timestamp();
                            $name = $this->_locale->formatDate( $t, "%B %Y" );
                            $monthStr = Array( "name" => $name, 
                                       "date" => $this->_locale->formatDate($t, "%Y%m"));
                            array_push( $result, $monthStr );
                            $alreadyAdded = true;    
            	       }
            	    }
            	
            	
                	// we can use the Timestamp class to help us with this...
                	$t = new Timestamp( "" );
                    $t->setYear( $yearName );
                    $t->setMonth( $monthName );
                    $name = $this->_locale->formatDate( $t, "%B %Y" );
                    $monthStr = Array( "name" => $name, 
                                       "date" => $this->_locale->formatDate($t, "%Y%m"));
                    array_push( $result, $monthStr );                    
                }
            }
            
            return $result;
        }        

        /**
         * Validates
         */
        function validate()
        {
        	$this->_showCategory = $this->_request->getValue( "showCategory" );
            if( $this->_showCategory == "" )
            	$this->_showCategory = -1;

            $this->_showStatus   = $this->_request->getValue( "showStatus" );
            if( $this->_showStatus == "" )
            	$this->_showStatus = 0;

            $this->_showUser   = $this->_request->getValue( "showUser" );
            if( $this->_showUser == "" )
            	$this->_showUser = 0;
            	
            $this->_showMonth = $this->_request->getValue( "showMonth" );
            if( $this->_showMonth == "" ) {
            	// let's show the post for current month by default
            	$t = new Timestamp();
            	$this->_showMonth = $this->_locale->formatDate( $t, "%Y%m" );
        	}


            return true;
        }

        /**
         * Carries out the specified action
         */
        function perform()
        {
        	$this->_view = new AdminEditPostsView( $this->_blogInfo );

            // fetch all the articles for edition
            $articles = new Articles();
            $posts    = $articles->getBlogArticles( $this->_blogInfo->getId(), $this->_showMonth, -1, $this->_showCategory, $this->_showStatus, $this->_showUser );
            $this->_view->setValue( "posts", $posts );
            // and the categories
            $categories = new ArticleCategories();
            $blogCategories = $categories->getBlogCategories( $this->_blogInfo->getId());
            // and all the users that belong to this blog
            $users = new Users();
            $blogUsers = $users->getBlogUsers( $this->_blogInfo->getId());

            $this->_view->setValue( "categories", $blogCategories );
            $this->_view->setValue( "currentcategory", $this->_showCategory );
            $this->_view->setValue( "currentstatus", $this->_showStatus );
            $this->_view->setValue( "currentuser", $this->_showUser );
            $this->_view->setValue( "currentmonth", $this->_showMonth );
            $this->_view->setValue( "users", $blogUsers );
            $this->_view->setValue( "months", $this->_getMonths());

            $this->setCommonData();

            // better to return true if everything fine
            return true;
        }
    }
?>
