<?php

	include_once( PLOG_CLASS_PATH."class/action/adminaction.class.php" );
    include_once( PLOG_CLASS_PATH."class/view/admintemplatedview.class.php" );
    include_once( PLOG_CLASS_PATH."class/view/adminerrorview.class.php" );
    include_once( PLOG_CLASS_PATH."class/gallery/dao/galleryalbums.class.php" );

    /**
     * Shows information about a resource
     */
    class AdminEditResourceAlbumAction extends AdminAction
    {

    	var $_albumId;

    	/**
         * Constructor. If nothing else, it also has to call the constructor of the parent
         * class, BlogAction with the same parameters
         */
        function AdminEditResourceAlbumAction( $actionInfo, $request )
        {
        	$this->AdminAction( $actionInfo, $request );
        }

        function validate()
        {
        	$this->_albumId = $this->_request->getValue( "albumId" );

            if( $this->_albumId == "" || $this->_albumId == 0 ) {
            	$this->_view = new AdminErrorView( $this->_blogInfo );
                $this->_view->setMessage( $this->_locale->tr("error_album_id_parameter_missing"));
                $this->setCommonData();

                return false;
            }

            return true;
        }

        /**
         * Carries out the specified action
         */
        function perform()
        {
            // fetch the albums for this blog
            $albums = new GalleryAlbums();
            $album = $albums->getAlbum( $this->_albumId, $this->_blogInfo->getId());

            $userAlbums = $albums->getUserAlbums( $this->_blogInfo->getId());

            if( !$album ) {
            	$this->_view = new AdminErrorView( $this->_blogInfo );
                $this->_view->setMessage( $this->_locale->tr("error_loading_resource_album"));
            }
            else {
            	$this->_view = new AdminTemplatedView( $this->_blogInfo, "editresourcealbum" );
                $this->_view->setValue( "album", $album );
                $this->_view->setValue( "albums", $userAlbums );
            }

            $this->setCommonData();

            // better to return true if everything fine
            return true;
        }
    }
?>
