<?php

	include_once( PLOG_CLASS_PATH."class/action/siteadminaction.class.php" );
    include_once( PLOG_CLASS_PATH."class/view/admintemplatedview.class.php" );
    include_once( PLOG_CLASS_PATH."class/view/adminerrorview.class.php" );
    include_once( PLOG_CLASS_PATH."class/dao/users.class.php" );
    include_once( PLOG_CLASS_PATH."class/dao/blogs.class.php" );

    class AdminEditSiteBlogUsersAction extends SiteAdminAction {

    	var $_editBlogId;

    	function AdminEditSiteBlogUsersAction( $actionInfo, $request )
        {
        	$this->SiteAdminAction( $actionInfo, $request );
        }

        function validate()
        {
        	$this->_editBlogId = $this->_request->getValue( "editBlogId" );

            return true;
        }

        /**
         * Removes all the users in blogUsers from siteUsers and
         * returns the new array.
         */
        function filterAvailableUsers( $siteUsers, $blogUsers )
        {
        	$resultArray = Array();

            // not the cleanest and fastest solution in the world, tho :(
            $found = false;
            foreach( $siteUsers as $siteUser ) {
            	foreach( $blogUsers as $blogUser ) {
            		if( $blogUser->getId() == $siteUser->getId()) {
                		$found = true;
                        break;
                    }
                    else
                    	$found = false;
                }

                if( !$found ) {
                	array_push( $resultArray, $siteUser );
                    $found = false;
                }
            }

            return $resultArray;
        }

        function perform()
        {
            $this->_view = new AdminTemplatedView( $this->_blogInfo, "siteblogusers" );

            // get all the users in the site
            $users = new Users();
            $siteUsers = $users->getAllUsers();
            $this->_view->setValue( "siteusers", $siteUsers );

            // get info about the blog we'd like to edit
            $blogs = new Blogs();
            $editBlogInfo = $blogs->getBlogInfo( $this->_editBlogId );

            if( !$editBlogInfo ) {
            	$this->_view = new AdminErrorView( $this->_blogInfo );
                $this->_view->setMessage( $this->_locale->tr("error_incorrect_blog_id" ));
                $this->setCommonData();

                return false;
            }

            $this->_view->setValue( "editblog", $editBlogInfo );

            // and the users who belong to the given blog
            $blogUsers = $users->getBlogUsers( $this->_editBlogId, false );
            $this->_view->setValue( "blogusers", $blogUsers );

            $this->_view->setValue( "availableusers", $this->filterAvailableUsers( $siteUsers, $blogUsers ));
            $this->setCommonData();

            return true;
        }
    }
?>
