<?php

	include_once( PLOG_CLASS_PATH."class/action/adminaction.class.php" );
    include_once( PLOG_CLASS_PATH."class/view/adminlogoutview.class.php" );
    include_once( PLOG_CLASS_PATH."class/net/httpvars.class.php" );

    /**
     * Logs the user out, by removing all the information from the session.
     */
    class AdminLogoutAction extends AdminAction {

    	/**
         * Constructor. If nothing else, it also has to call the constructor of the parent
         * class, BlogAction with the same parameters
         */
        function AdminLogoutAction( $actionInfo, $request )
        {
        	$this->AdminAction( $actionInfo, $request );
        }

        /**
         * Carries out the specified action
         */
        function perform()
        {
        	$this->_view = new AdminLogoutView();

            // remove all the information from the session
            //$_SESSION["SessionInfo"] = null;
            $session = HttpVars::getSession();
            $session["SessionInfo"] = null;
            unset($session["SessionInfo"]);
            $session = Array();
            HttpVars::setSession( $session );
            session_destroy();

            // and pass the locale to the template
            $config =& Config::getConfig();
            $locale =& Locales::getLocale( $config->getValue( "default_locale" ));
            $url = new RequestGenerator( $this->_blogInfo );
            $blogTitle = $this->_blogInfo->getBlog();
            $this->_view->setValue( "locale", $locale );
            $this->_view->setValue( "blogtitle", $blogTitle );
            $this->_view->setValue( "blogurl", $url->blogLink());

            // better to return true if everything fine
            return true;
        }
    }
?>
