<?php

	include_once( PLOG_CLASS_PATH."class/action/adminaction.class.php" );
    include_once( PLOG_CLASS_PATH."class/view/adminmainview.class.php" );
    include_once( PLOG_CLASS_PATH."class/dao/blogs.class.php" );

    /**
     * Sample action on how to develop our own actions.
     *
     * Please also refer to SampleView.class.php for more information
     */
    class AdminMainAction extends AdminAction {

    	/**
         * Constructor. If nothing else, it also has to call the constructor of the parent
         * class, BlogAction with the same parameters
         */
        function AdminMainAction( $actionInfo, $request )
        {
        	$this->AdminAction( $actionInfo, $request );
        }

        /**
         * Validate if everything is correct
         */
        function validate()
        {
        	// first of all, check if we have a valid blog id
            $this->_blogId = $this->_request->getValue( "blogId" );
            if( $this->_blogId == "" || $this->_blogId < 0 ) {
            	$this->_view = new AdminSimpleErrorView();
                $this->_view->setValue( "message", "Invalid blog identifier" );

                return false;
            }

            // if the blog identifier is valid, now we should now check if the user belongs
            // to that blog so that we know for sure that nobody has tried to forge the
            // parameter in the meantime

            /***************
            /**
            /** IMPORTANT: TODO!!!
            /**
            /**
             **************/

             // if all correct, we can now set the blogInfo object in the session for later
             // use
             $blogs = new Blogs();
             $this->_blogInfo = $blogs->getBlogInfo( $this->_blogId );

             $session = HttpVars::getSession();
             $session["SessionInfo"]->setValue( "blogInfo", $this->_blogInfo );
             HttpVars::setSession( $session );

            return true;
        }

        /**
         * Carries out the specified action
         */
        function perform()
        {
        	// initialize the view
        	$this->_view = new AdminMainView( $this->_blogInfo );
            $this->setCommonData();
            // better to return true if everything fine
            return true;
        }
    }
?>
