<?php

	include_once( PLOG_CLASS_PATH."class/action/blogowneradminaction.class.php" );
    include_once( PLOG_CLASS_PATH."class/view/admintemplatedview.class.php" );
    include_once( PLOG_CLASS_PATH."class/template/templateservice.class.php" );
    include_once( PLOG_CLASS_PATH."class/view/adminerrorview.class.php" );

	class AdminNewBlogTemplateFileAction extends BlogOwnerAdminAction {

    	var $_templateId;

    	function AdminNewBlogTemplateFileAction( $actionInfo, $request )
        {
        	$this->BlogOwnerAdminAction( $actionInfo, $request );
        }

        function validate()
        {
            $this->_templateId = $this->_request->getValue( "templateId" );

            $error = false;

            // check if the parameter is there
            if( $this->_templateId == "" )
            	$error = true;

            // and make sure that the template exists
            $ts = new TemplateService();
            if( !$ts->isBlogTemplate( $this->_templateId, $this->_blogInfo->getId()))
            	$error = true;

            if( $error ) {
            	$this->_view = new AdminErrorView( $this->_blogInfo );
                $this->_view->setMessage( $this->_locale->tr("error_incorrect_template_id"));
                $this->setCommonData();

                return false;
            }

            return true;
        }

        function perform()
        {
        	// show the template
            $this->_view = new AdminTemplatedView( $this->_blogInfo, "newblogtemplatefile" );
            $this->_view->setValue( "templateId", $this->_templateId );
            $this->setCommonData();

            return true;
        }
    }
?>
