<?php

    include_once( PLOG_CLASS_PATH."class/action/adminaction.class.php" );
    include_once( PLOG_CLASS_PATH."class/view/adminnewlinkview.class.php" );
    include_once( PLOG_CLASS_PATH."class/view/adminerrorview.class.php" );
    include_once( PLOG_CLASS_PATH."class/dao/mylinkscategories.class.php" );
    include_once( PLOG_CLASS_PATH."class/dao/mylinkscategory.class.php" );

    /**
     * Action that shows a form to add a link for the blogroll feature
     */
    class AdminNewLinkAction extends AdminAction {

        /**
         * Constructor. If nothing else, it also has to call the constructor of the parent
         * class, BlogAction with the same parameters
         */
        function AdminNewLinAction( $actionInfo, $request )
        {
            $this->AdminAction( $actionInfo, $request );
        }

        /**
         * Carries out the specified action
         */
        function perform()
        {
            // fetch all the link categories
            $mylinksCategories = new MyLinksCategories();
            $blogMyLinksCategories = $mylinksCategories->getMyLinksCategories( $this->_blogInfo->getId());
            // if there is none, we should not be allowed to add any link!
            if( empty($blogMyLinksCategories)) {
                $this->_view = new AdminErrorView( $this->_blogInfo );
                $this->_view->setMessage( $this->_locale->tr("error_must_have_one_link_category" ));
                $this->setCommonData();

                return false;
            }

            // else, put that in the template and continue
            $this->_view = new AdminNewLinkView( $this->_blogInfo );
            $this->_view->setValue( "linkcategories", $blogMyLinksCategories );
            $this->setCommonData();

            // better to return true if everything fine
            return true;
        }
    }
?>
