<?php

	include_once( PLOG_CLASS_PATH."class/action/adminaction.class.php" );
    include_once( PLOG_CLASS_PATH."class/view/adminnewpostview.class.php" );
    include_once( PLOG_CLASS_PATH."class/dao/blogs.class.php" );
    include_once( PLOG_CLASS_PATH."class/dao/articlecategories.class.php" );
    include_once( PLOG_CLASS_PATH."class/view/adminerrorview.class.php" );

    /**
     * Action that adds a new post to the database. It also lets the user
     * preview the article before posting it.
     */
    class AdminNewPostAction extends AdminAction {

    	/**
         * Constructor. If nothing else, it also has to call the constructor of the parent
         * class, BlogAction with the same parameters
         */
        function AdminNewPostAction( $actionInfo, $request )
        {
        	$this->AdminAction( $actionInfo, $request );
        }

        /**
         * Carries out the specified action
         */
        function perform()
        {
        	// initialize the view
        	$this->_view = new AdminNewPostView( $this->_blogInfo );
            $this->setCommonData();

            // fetch the categories
            $categories = new ArticleCategories();
            $blogCategories = $categories->getBlogCategories( $this->_blogInfo->getId());
            // but make sure that we have at least one!
            if( count($blogCategories) == 0) {
            	$this->_view = new AdminErrorView( $this->_blogInfo );
				$message = $this->_locale->tr("error_must_have_one_category");
				$message .= "<br/><br/><a href=\"admin.php?op=newArticleCategory\">".$this->_locale->tr("add_new_category")."</a>";
                $this->_view->setMessage( $message );
                $this->setCommonData();

                return false;
            }

            // get some stuff for the time stamp of the post, which is changeable now
            $t = new Timestamp();
            $months = $this->_locale->getMonthNames();
            $days = $this->_locale->getDayNamesShort();
            $years = range( 1990, 2030 );
            $minutes = Array( "00", "01", "02", "03", "04", "05", "06", "07", "08", "09",
                              "10", "11", "12", "13", "14", "15", "16", "17", "18", "19",
                              "20", "21", "22", "23", "24", "25", "26", "27", "28", "29",
                              "30", "31", "32", "33", "34", "35", "36", "37", "38", "39",
                              "40", "41", "42", "43", "44", "45", "46", "47", "48", "49",
                              "50", "51", "52", "53", "54", "55", "56", "57", "58", "59" );

            //$hours   = range( 0, 23 );
            $hours = Array( "00", "01", "02", "03", "04", "05", "06", "07", "08",
                            "09", "10", "11", "12", "13", "14", "15", "16", "17",
                            "18", "19", "20", "21", "22", "23" );

            // and put everything in the template
            $this->_view->setValue( "commentsEnabled", true );
            $this->_view->setValue( "categories", $blogCategories );
            $this->_view->setValue( "previewMode", false );
            $this->_view->setValue( "today", $t );
            $this->_view->setValue( "months", $months );
            $this->_view->setValue( "days", $days );
            $this->_view->setValue( "years", $years );
            $this->_view->setValue( "hours", $hours );
            $this->_view->setValue( "minutes", $minutes );
            $this->_view->setValue( "disableJavascriptCalendar", $this->_config->getValue( "disable_javascript_calendar" ));

            // better to return true if everything fine
            return true;
        }
    }
?>
