<?php

	include_once( PLOG_CLASS_PATH."class/action/adminaction.class.php" );
    include_once( PLOG_CLASS_PATH."class/view/admintemplatedview.class.php" );
    include_once( PLOG_CLASS_PATH."class/view/adminerrorview.class.php" );
    include_once( PLOG_CLASS_PATH."class/gallery/dao/galleryalbums.class.php" );
	include_once( PLOG_CLASS_PATH."class/gallery/dao/galleryresourcestorage.class.php" );

    /**
     * Adds a new resource to an album
     */
    class AdminNewResourceAction extends AdminAction {

    	/**
         * Constructor. If nothing else, it also has to call the constructor of the parent
         * class, BlogAction with the same parameters
         */
        function AdminNewResourceAction( $actionInfo, $request )
        {
        	$this->AdminAction( $actionInfo, $request );
        }
		
		function validate()
		{
			// check that all the folders are in place
			if( !GalleryResourceStorage::checkBaseStorageFolder()) {
				$this->_view = new AdminErrorView( $this->_blogInfo );
				$this->_view->setMessage( $this->_locale->tr("error_gallery_folder_missing" ));
				$this->setCommonData();
				
				return false;
			}
			
			return true;
		}

        /**
         * Carries out the specified action
         */
        function perform()
        {
            // fetch the albums for this blog
            $albums = new GalleryAlbums();
            $blogAlbums = $albums->getUserAlbums( $this->_blogInfo->getId());

            // check that we have at least one album where to put our pictures
            if( count($blogAlbums) == 0 ) {
            	$this->_view = new AdminErrorView( $this->_blogInfo );
				$message = $this->_locale->tr("error_must_create_album_first");
				$message .= "<br/><br/><a href=\"javascript:history.go(-1);\">".$this->_locale->tr("back")."</a>";
                $this->_view->setMessage( $message );
                $this->setCommonData();

            	return false;
            }

            // if all's fine, continue...
            $this->_view = new AdminTemplatedView( $this->_blogInfo, "newresource" );
            $this->setCommonData();
            $this->_view->setValue( "albums", $blogAlbums );

            // better to return true if everything fine
            return true;
        }
    }
?>
