<?php

	include_once( PLOG_CLASS_PATH."class/action/adminaction.class.php" );
    include_once( PLOG_CLASS_PATH."class/view/adminpoststatsview.class.php" );
    include_once( PLOG_CLASS_PATH."class/data/integervalidator.class.php" );
    include_once( PLOG_CLASS_PATH."class/dao/referers.class.php" );
    include_once( PLOG_CLASS_PATH."class/dao/articles.class.php" );
    include_once( PLOG_CLASS_PATH."class/dao/trackbacks.class.php" );

    /**
     * Action that shows a page with the statistics about a form
     */
    class AdminPostStatsAction extends AdminAction {

    	var $_postId;

    	/**
         * Constructor. If nothing else, it also has to call the constructor of the parent
         * class, BlogAction with the same parameters
         */
        function AdminPostStatsAction( $actionInfo, $request )
        {
        	$this->AdminAction( $actionInfo, $request );
        }

        /**
         * Check that the parameter is correct.
         */
        function validate()
        {
        	$this->_postId = $this->_request->getValue( "postId" );

            $postVal = new IntegerValidator( $this->_postId );
            if( !$postVal->validate()) {
            	$this->_view = new AdminErrorView( $this->_blogInfo );
                $this->_view->setMessage( $this->_locale->tr("error_incorrect_article_id"));
                $this->setCommonData();

                return false;
            }

            return true;
        }

        /**
         * Carries out the specified action
         */
        function perform()
        {
            // fetch the post itself
            $posts = new Articles();
            $post  = $posts->getBlogArticle( $this->_postId, $this->_blogInfo->getId());
            if( !$post ) {
            	$this->_view = new AdminErrorView( $this->_blogInfo );
                $this->_view->setMessage( $this->_locale->tr("error_fetching_post"));
                $this->setCommonData();

                return false;
            }

        	// fetch information about the referers
            $referers = new Referers();
            $postReferers = $referers->getArticleReferers( $this->_postId );
            // fetch information about the trackbacks
            $trackbacks = new Trackbacks();
            $postTrackbacks = $trackbacks->getArticleTrackbacks( $this->_postId );
            // create the view and export everything to the template
        	$this->_view = new AdminPostStatsView( $this->_blogInfo );
            $this->_view->setValue( "referers", $postReferers );
            $this->_view->setValue( "trackbacks", $postTrackbacks );
            $this->_view->setValue( "post", $post );
            $this->setCommonData();

            // better to return true if everything fine
            return true;
        }
    }
?>