<?php

	include_once( PLOG_CLASS_PATH."class/action/adminaction.class.php" );
    include_once( PLOG_CLASS_PATH."class/view/admintemplatedview.class.php" );
    include_once( PLOG_CLASS_PATH."class/gallery/dao/galleryalbums.class.php" );

    /**
     * shows a list of the albums
     */
    class AdminResourceAlbumsAction extends AdminAction
    {
    	var $_albumId;

    	/**
         * Constructor. If nothing else, it also has to call the constructor of the parent
         * class, BlogAction with the same parameters
         */
        function AdminResourceAlbumsAction( $actionInfo, $request )
        {
        	$this->AdminAction( $actionInfo, $request );
        }

        function validate()
        {
        	$this->_albumId = $this->_request->getValue( "albumId" );

            if( $this->_albumId == "" || $this->_albumId == null )
            	$this->_albumId = 0;

            return true;
        }

        /**
         * Carries out the specified action
         */
        function perform()
        {
        	// fetch the child albums of the current top level album
        	$galleryAlbums = new GalleryAlbums();
            $albums = $galleryAlbums->getChildAlbums( $this->_albumId, $this->_blogInfo->getId());

            // get some info about the parent album if it's different from the
            // top level album
            if( $this->_albumId > 0 ) {
            	$album = $galleryAlbums->getAlbum( $this->_albumId, $this->_blogInfo->getId());
            }

            // and put everything to the template
            $this->_view = new AdminTemplatedView( $this->_blogInfo, "resourcealbums" );
            $this->setCommonData();

            // fetch the albums for this blog
            $this->_view->setValue( "albums", $albums );
            $this->_view->setValue( "albumid", $this->_albumId );
            $this->_view->setValue( "album", $album );

            return true;
        }
    }
?>
