<?php

	include_once( PLOG_CLASS_PATH."class/action/adminaction.class.php" );
    include_once( PLOG_CLASS_PATH."class/view/admintemplatedview.class.php" );
	include_once( PLOG_CLASS_PATH."class/view/adminerrorview.class.php" );
	include_once( PLOG_CLASS_PATH."class/gallery/dao/galleryresourcestorage.class.php" );

    /**
     * Shows the main page of the "Resource Center"
     */
    class AdminResourceCenterAction extends AdminAction {

    	/**
         * Constructor. If nothing else, it also has to call the constructor of the parent
         * class, BlogAction with the same parameters
         */
        function AdminResourceCenter( $actionInfo, $request )
        {
        	$this->AdminAction( $actionInfo, $request );
        }

        /**
         * Carries out the specified action
         */
        function perform()
        {
			$baseFolder = GalleryResourceStorage::getResourcesStorageFolder();
			$userFolder = GalleryResourceStorage::getUserFolder( $this->_blogInfo->getId());
			$previewsFolder = GalleryResourceStorage::getPreviewsFolder( $this->_blogInfo->getId());
			$folders = "$baseFolder<br/>$userFolder<br/>$previewsFolder";
			// check if the storage folder exists and it is readable
			if( !GalleryResourceStorage::checkBaseStorageFolder()) {
				$this->_view = new AdminErrorView( $this->_blogInfo );
				$this->_view->setMessage( $this->_locale->pr("error_base_storage_folder_missing_or_unreadable", $folders));
				$this->setCommonData();
				
				return false;
			}

			if( !GalleryResourceStorage::checkUserStorageFolder( $this->_blogInfo->getId())) {
				$this->_view = new AdminErrorView( $this->_blogInfo );
				$this->_view->setMessage( $this->_locale->pr("error_base_storage_folder_missing_or_unreadable",$folders));
				$this->setCommonData();
				
				return false;
			}
			
			if( !GalleryResourceStorage::checkPreviewsStorageFolder( $this->_blogInfo->getId())) {
				$this->_view = new AdminErrorView( $this->_blogInfo );
				$this->_view->setMessage( $this->_locale->pr("error_base_storage_folder_missing_or_unreadable",$folders));
				$this->setCommonData();
				
				return false;
			}
			
			
            $this->_view = new AdminTemplatedView( $this->_blogInfo, "resourcecenter" );
            $this->setCommonData();

            // better to return true if everything fine
            return true;
        }
    }
?>
