<?php

	include_once( PLOG_CLASS_PATH."class/action/adminaction.class.php" );
    include_once( PLOG_CLASS_PATH."class/view/admintemplatedview.class.php" );
    include_once( PLOG_CLASS_PATH."class/view/adminerrorview.class.php" );
    include_once( PLOG_CLASS_PATH."class/gallery/dao/galleryresource.class.php" );
    include_once( PLOG_CLASS_PATH."class/gallery/dao/galleryalbums.class.php" );

    /**
     * Shows information about a resource
     */
    class AdminResourceInfoAction extends AdminAction
    {

    	var $_resourceId;

    	/**
         * Constructor. If nothing else, it also has to call the constructor of the parent
         * class, BlogAction with the same parameters
         */
        function AdminNewResourceAlbumAction( $actionInfo, $request )
        {
        	$this->AdminAction( $actionInfo, $request );
        }

        function validate()
        {
        	$this->_resourceId = $this->_request->getValue( "resourceId" );

            if( $this->_resourceId == "" || $this->_resourceId == 0 ) {
            	$this->_view = new AdminErrorView( $this->_blogInfo );
                $this->_view->setMessage( $this->_locale->tr("error_resource_id_parameter_missing"));
                $this->setCommonData();

                return false;
            }

            return true;
        }

        /**
         * Carries out the specified action
         */
        function perform()
        {
            $this->_view = new AdminTemplatedView( $this->_blogInfo, "newresourcealbum" );
            $this->setCommonData();

            // fetch the albums for this blog
            $albums = new GalleryAlbums();
            $blogAlbums = $albums->getUserAlbums( $this->_blogInfo->getId());
            // and the resource itself
            $resources = new GalleryResources();
            $resource = $resources->getResource( $this->_resourceId, $this->_blogInfo->getId());

            if( $resource == false ) {
            	$this->_view = new AdminErrorView( $this->_blogInfo );
                $this->_view->setMessage( $this->_locale->tr("error_loading_resource"));
            }
            else {
            	$this->_view = new AdminTemplatedView( $this->_blogInfo, "resourceinfo" );
                $this->_view->setValue( "resource", $resource );
                $this->_view->setValue( "albums", $blogAlbums );                
            }

            $this->setCommonData();

            // better to return true if everything fine
            return true;
        }
    }
?>
