<?php

	include_once( PLOG_CLASS_PATH."class/action/adminaction.class.php" );
    include_once( PLOG_CLASS_PATH."class/view/admintemplatedview.class.php" );
    include_once( PLOG_CLASS_PATH."class/gallery/dao/galleryresource.class.php" );
    include_once( PLOG_CLASS_PATH."class/gallery/dao/galleryalbums.class.php" );

    /**
     * Deletes a resource from the blog
     */
    class AdminResourceListAction extends AdminAction
    {

    	var $_destination;

    	/**
         * Constructor. If nothing else, it also has to call the constructor of the parent
         * class, BlogAction with the same parameters
         */
        function AdminResourceListAction( $actionInfo, $request )
        {
        	$this->AdminAction( $actionInfo, $request );
        }

        function validate()
        {
        	$this->_destination = $this->_request->getValue( "mode" );
            $this->_albumId = $this->_request->getValue( "albumId" );
            if( $this->_albumId == "" )
            	$this->_albumId = 0;

            return true;
        }

        /**
         * Carries out the specified action
         */
        function perform()
        {
        	$galleryAlbums = new GalleryAlbums();
            if( $this->_albumId > 0 )
            	$album = $galleryAlbums->getAlbum( $this->_albumId, $this->_blogInfo->getId());
        	// get the subalbums
            $albums = $galleryAlbums->getChildAlbums( $this->_albumId, $this->_blogInfo->getId());
            // and the resources in this album
            $galleryResources = new GalleryResources();
            $resources = $galleryResources->getUserResources( $this->_blogInfo->getId(), $this->_albumId );

            $this->_view = new AdminTemplatedView( $this->_blogInfo, "resourcelist" );
            $this->_view->setValue( "album", $album );
            $this->_view->setValue( "albums", $albums );
            $this->_view->setValue( "resources", $resources );
            $this->_view->setValue( "destination", $this->_destination );
            $this->_view->setValue( "blogname", StringUtils::text2url( $this->_blogInfo->getBlog() ));            
            $this->_view->setValue( "requestformat", $this->_config->getValue( "request_format_mode"));
            $this->_view->setValue( "baseurl", $this->_config->getValue( "base_url" ));
            $this->_view->setValue( "htmlarea", $this->_config->getValue( "htmlarea_enabled" ));
            $this->setCommonData();

            return true;
        }
    }
?>
