<?php

	include_once( PLOG_CLASS_PATH."class/action/adminaction.class.php" );
    include_once( PLOG_CLASS_PATH."class/view/admintemplatedview.class.php" );
    include_once( PLOG_CLASS_PATH."class/gallery/dao/galleryalbums.class.php" );
    include_once( PLOG_CLASS_PATH."class/gallery/dao/galleryresources.class.php" );
	include_once( PLOG_CLASS_PATH."class/view/adminerrorview.class.php" );

    /**
     * shows all the resources of a blog
     */
    class AdminResourcesAction extends AdminAction
    {

    	var $_albumId;

    	/**
         * Constructor. If nothing else, it also has to call the constructor of the parent
         * class, BlogAction with the same parameters
         */
        function AdminResourcesAction( $actionInfo, $request )
        {
        	$this->AdminAction( $actionInfo, $request );
        }

        /**
         * get the data from the request
         */
        function validate()
        {
        	// fetch the information coming from the resource
            $this->_albumId = $this->_request->getValue( "albumId" );
            if( $this->_albumId == "" )
            	$this->_albumId = 0;

            return true;
        }

        /**
         * Carries out the specified action
         */
        function perform()
        {
        	// and the current album
        	$galleryAlbums = new GalleryAlbums();
            if( $this->_albumId > 0 ) {
            	$album = $galleryAlbums->getAlbum( $this->_albumId, $this->_blogInfo->getId());
				if( !$album || $album == "") {
					$this->_view = new AdminErrorView( $this->_blogInfo );
					$this->_view->setMessage( $this->_locale->tr("error_fetching_album" ));
					$this->setCommonData();
					
					return false;
				}
				$resources = $album->getResources();
			}
			else {
				// get the subalbums
				$albums = $galleryAlbums->getChildAlbums( $this->_albumId, $this->_blogInfo->getId());
				$resources = Array();
			}

            $this->_view = new AdminTemplatedView( $this->_blogInfo, "resources" );
            $this->_view->setValue( "album", $album );
			if( $this->_albumId > 0 )
				$this->_view->setValue( "albums", $album->getChildren());
			else
				$this->_view->setValue( "albums", $albums );
            $this->_view->setValue( "resources", $resources );
            $this->setCommonData();

            return true;
        }
    }
?>
