<?php

	include_once( PLOG_CLASS_PATH."class/action/siteadminaction.class.php" );
    include_once( PLOG_CLASS_PATH."class/view/admintemplatedview.class.php" );
    include_once( PLOG_CLASS_PATH."class/view/adminerrorview.class.php" );
    include_once( PLOG_CLASS_PATH."class/dao/blogs.class.php" );

    /**
     * Shows a list with all the blogs available in the site
     */
    class AdminSiteBlogsAction extends SiteAdminAction {

    	function AdminSiteBlogsAction( $actionInfo, $request )
        {
        	$this->SiteAdminAction( $actionInfo, $request );
        }

        function perform()
        {
            // we need to get all the blogs
            $blogs = new Blogs();
            $siteBlogs = $blogs->getAllBlogs();
            if( !$siteBlogs ) {
            	$this->_view = new AdminErrorView( $this->_blogInfo );
                $this->_view->setMessage( $this->_locale->tr("error_fetching_blogs") );
                $this->_view->setCommonData();

                return false;
            }

            // if no problem, continue
            $this->_view = new AdminTemplatedView( $this->_blogInfo, "siteblogs" );
            $this->setCommonData();
            // and pass them to the template
            $this->_view->setValue( "siteblogs", $siteBlogs );

            return true;
        }
    }
?>
