<?php

	include_once( PLOG_CLASS_PATH."class/action/blogowneradminaction.class.php" );
    include_once( PLOG_CLASS_PATH."class/view/adminerrorview.class.php" );
    include_once( PLOG_CLASS_PATH."class/dao/referers.class.php" );
    include_once( PLOG_CLASS_PATH."class/view/adminstatisticsview.class.php" );

    /**
     * Action that shows statistics
     */
    class AdminStatisticsAction extends BlogOwnerAdminAction {

    	/**
         * Constructor. If nothing else, it also has to call the constructor of the parent
         * class, BlogAction with the same parameters
         */
        function AdminStatisticsAction( $actionInfo, $request )
        {
        	$this->BlogOwnerAdminAction( $actionInfo, $request );
        }

        /**
         * Carries out the specified action
         */
        function perform()
        {
        	$referers = new Referers();
            $blogReferers = $referers->getBlogReferers( $this->_blogInfo->getId());
            if( !$blogReferers ) {
            	$this->_view = new AdminErrorView( $this->_blogInfo );
            	$this->_view->setMessage( $this->_locale->tr("error_fetching_referers"));
            	$this->setCommonData();

                return false;
            }

            $this->_view = new AdminStatisticsView( $this->_blogInfo );
            $this->_view->setValue( "referers", $blogReferers );
            $this->setCommonData();

            // better to return true if everything fine
            return true;
        }
    }
?>
