<?php

	include_once( PLOG_CLASS_PATH."class/action/adminaction.class.php" );
    include_once( PLOG_CLASS_PATH."class/view/adminmessageview.class.php" );
    include_once( PLOG_CLASS_PATH."class/view/adminerrorview.class.php" );
    include_once( PLOG_CLASS_PATH."class/dao/articlecategories.class.php" );
    include_once( PLOG_CLASS_PATH."class/dao/articlecategory.class.php" );

    /**
     * Updates an article category.
     */
    class AdminUpdateArticleCategoryAction extends AdminAction {

    	var $_categoryName;
        var $_categoryUrl;
        var $_categoryId;
        var $_categoryInMainPage;

    	/**
         * Constructor. If nothing else, it also has to call the constructor of the parent
         * class, BlogAction with the same parameters
         */
        function AdminUpdateArticleCategoryAction( $actionInfo, $request )
        {
        	$this->AdminAction( $actionInfo, $request );
        }

        /**
         * Checks the data from the form
         */
        function validate()
        {
        	$this->_categoryName = $this->_request->getValue( "categoryName" );
            $this->_categoryUrl  = $this->_request->getValue( "categoryUrl" );
            $this->_categoryId   = $this->_request->getValue( "categoryId" );
            $this->_categoryInMainPage = $this->_request->getValue( "categoryInMainPage" );

            if( $this->_categoryName == "" || $this->_categoryId == "" || $this->_categoryId <= 0 ) {
            	$this->_view = new AdminErrorView( $this->_blogInfo );
                $this->_view->setMessage( $this->_locale->tr("error_empty_category_name"));
                $this->setCommonData();

                return false;
            }

            if( $this->_categoryInMainPage == "" )
            	$this->_categoryInMainPage = 0;

            return true;
        }

        /**
         * Carries out the specified action
         */
        function perform()
        {
        	// fetch the category we're trying to update
            $categories = new ArticleCategories();
            $category   = $categories->getCategory( $this->_categoryId, $this->_blogInfo->getId());
            if( !$category ) {
            	$this->_view = new AdminErrorView( $this->_blogInfo );
                $this->_view->setMessage( $this->_locale->tr("error_fetching_category"));
                $this->setCommonData();

                return false;
            }

            // update the fields
            $category->setName( $this->_categoryName );
            $category->setUrl( $this->_categoryUrl );
            $category->setInMainPage( $this->_categoryInMainPage );
            if( !$categories->updateCategory( $category )) {
            	$this->_view = new AdminErrorView( $this->_blogInfo );
                $this->_view->setMessage( $this->_locale->tr("error_updating_category"));
                $this->setCommonData();

                return false;
            }

            $this->_view = new AdminMessageView( $this->_blogInfo );
            $this->_view->setMessage( $this->_locale->tr("category_updated_ok"));
            $this->setCommonData();

            // better to return true if everything fine
            return true;
        }
    }
?>
