<?php

	include_once( PLOG_CLASS_PATH."class/action/siteadminaction.class.php" );
    include_once( PLOG_CLASS_PATH."class/view/adminerrorview.class.php" );
    include_once( PLOG_CLASS_PATH."class/view/adminmessageview.class.php" );
    include_once( PLOG_CLASS_PATH."class/dao/blockedhosts.class.php" );

    /**
     * Changes the settings of a blocked host
     */
    class AdminUpdateBlockedHostAction extends SiteAdminAction
    {

    	var $_hostId;
        var $_reason;
        var $_ip1;
        var $_ip2;
        var $_ip3;
        var $_ip4;
        var $_ip;
        var $_mask;
        var $_type;

    	/**
         * Constructor. If nothing else, it also has to call the constructor of the parent
         * class, BlogAction with the same parameters
         */
        function AdminUpdateBlockedHostAction( $actionInfo, $request )
        {
        	$this->SiteAdminAction( $actionInfo, $request );
        }

        function validate()
        {
        	$this->_hostId = $this->_request->getValue( "hostId" );
            $this->_ip1    = $this->_request->getValue( "ip1" );
            $this->_ip2    = $this->_request->getValue( "ip2" );
            $this->_ip3    = $this->_request->getValue( "ip3" );
            $this->_ip4    = $this->_request->getValue( "ip4" );
            $this->_ip     = $this->_ip1.".".$this->_ip2.".".$this->_ip3.".".$this->_ip4;
            $this->_mask   = $this->_request->getValue( "mask" );
            $this->_type   = $this->_request->getValue( "blockType" );
            $this->_reason = $this->_request->getValue( "reason" );

            return true;
        }

        /**
         * Carries out the specified action
         */
        function perform()
        {
        	$blockedHosts = new BlockedHosts();
            $blockedHost = $blockedHosts->getBlockedHost( $this->_hostId );

            // check if the info about the blocked host is correct
            if( !$blockedHost ) {
            	$this->_view = new AdminErrorView( $this->_blogInfo );
				$message = $this->_locale->tr( "error_fetching_blocked_host" );
				$message .= "<br/><br/><a href=\"javascript:history.go(-1);\">".$this->_locale->tr("back")."</a>";				
                $this->_view->setMessage( $message );
                $this->setCommonData();

                return false;
            }

            // set the new information
            $blockedHost->setHost( $this->_ip );
            $blockedHost->setReason( $this->_reason );
            $blockedHost->setType( $this->_type );
            $blockedHost->setMask( $this->_mask );
            if( !$blockedHosts->update( $blockedHost )) {
            	$this->_view = new AdminErrorView( $this->_blogInfo );
				$message = $this->_locale->tr( "error_updating_blocked_host" );
				$message .= "<br/><br/><a href=\"javascript:history.go(-1);\">".$this->_locale->tr("back")."</a>";
                $this->_view->setMessage( $message );
                $this->setCommonData();

                return false;
            }

            $this->_view = new AdminMessageView( $this->_blogInfo );
			$message = $this->_locale->tr("blocked_host_updated_ok" );
			$message .= "<br/><br/><a href=\"admin.php?op=blockedHosts\">".$this->_locale->tr("back")."</a>";
            $this->_view->setMessage( $message );
            $this->setCommonData();

            return true;
        }
    }
?>
