<?php

	include_once( PLOG_CLASS_PATH."class/action/siteadminaction.class.php" );
    include_once( PLOG_CLASS_PATH."class/view/admintemplatedview.class.php" );
    include_once( PLOG_CLASS_PATH."class/view/adminerrorview.class.php" );
    include_once( PLOG_CLASS_PATH."class/view/adminmessageview.class.php" );
    include_once( PLOG_CLASS_PATH."class/data/stringvalidator.class.php" );
    include_once( PLOG_CLASS_PATH."class/dao/filteredcontents.class.php" );

    /**
     * Adds new blocked content to the blog
     */
    class AdminUpdateFilteredContentAction extends SiteAdminAction {

    	var $_filteredContentRule;
        var $_reason;
        var $_contentId;

    	function AdminUpdateFilteredContentAction( $actionInfo, $request )
        {
        	$this->SiteAdminAction( $actionInfo, $request );
        }

        function validate()
        {
        	$this->_filteredContentRule = $this->_request->getValue( "filteredContent" );
            $this->_reason = $this->_request->getValue( "reason" );
            $this->_contentId = $this->_request->getValue( "contentId" );

            $val = new StringValidator( $this->_filteredContentRule );
            if( !$val->validate()) {
            	$this->_view = new AdminErrorView( $this->_blogInfo );
            	$this->_view = new AdminErrorView( $this->_blogInfo );
				$message = $this->_locale->tr("error_provide_content_to_block");
				$message .= "<br/><br/><a href=\"javascript:history.go(-1);\">".$this->_locale->tr("back")."</a>";				
                $this->_view->setMessage( $message );

                $this->setCommonData();

                return false;
            }

            return true;
        }

        function perform()
        {
        	// create the dao object and add the info to the db
        	$filteredContents = new FilteredContents();
            $content = $filteredContents->getBlogFilteredContent( $this->_contentId, 0 );

            // check if we could find the information, or give up otherwise...
            if( !$content ) {
            	$this->_view = new AdminErrorView( $this->_blogInfo );
                $this->_view->setMessage( $this->_locale->tr("error_fetching_filtered_content"));
                $this->setCommonData();

            	return false;
            }

            $content->setRegExp( $this->_filteredContentRule );
            $content->setReason( $this->_reason );

            $result = $filteredContents->updateFilteredContent( $content );

            // and give some feedback to the user
            if( !$result ) {
            	$message = $this->_locale->tr("error_updating_blocked_content");
                $this->_view = new AdminErrorView( $this->_blogInfo );
            }
            else {
            	$message = $this->_locale->tr("blocked_content_updated_ok");
                $this->_view = new AdminMessageView( $this->_blogInfo );
            }

            $this->_view->setMessage( $message );
            $this->setCommonData();

            return true;
        }
    }
?>
