<?php

	include_once( PLOG_CLASS_PATH."class/action/siteadminaction.class.php" );
    include_once( PLOG_CLASS_PATH."class/view/admintemplatedview.class.php" );
    include_once( PLOG_CLASS_PATH."class/view/adminmessageview.class.php" );    

    /**
     * Updates the settings of the site
     */
    class AdminUpdateGlobalSettingsAction extends SiteAdminAction {

    	var $_newConfigOpts;

    	function AdminUpdateGlobalSettingsAction( $actionInfo, $request )
        {
        	$this->SiteAdminAction( $actionInfo, $request );
        }

        function validate()
        {
	    	// all the seettings come from a very nice array from the html form
            $this->_newConfigOpts = Array();
            $this->_newConfigOpts = $this->_request->getValue( "config" );

            // the xmlrpc_ping_hosts requires special treatment, since we need to
            // split the input returned from the textbox into an array
            $array = Array();
            foreach(explode( "\r\n", $this->_newConfigOpts["xmlrpc_ping_hosts"] ) as $host ) {
            	trim($host);
            	if( $host != "" && $host != "\r\n" && $host != "\r" && $host != "\n" )
                	array_push( $array, $host );
            }
            $this->_newConfigOpts["xmlrpc_ping_hosts"] = $array;

            // the 'locales' and 'arrays' settings are not coming from the request
            $configOpts = $this->_config->getAsArray();
            $locales = new Locales();
            $this->_newConfigOpts["locales"] = $locales->getAvailableLocales();
            $this->_newConfigOpts["templates"] = $configOpts["templates"];

            //
            // :KLUDGE: oscar
            // the problem here is that... hmmm... how to say this...
            // this settings do not come fro the form so they don't exist
            // in the array _newConfigOpts. So, if we call $config->save() now
            // we will lose them and they won't appear in the configuration file
            // if we are using database storage for the configuration, we don't really
            // care about this, but if we're using file-based storage it is a problem
            // since we will lose them and the application will not be able to connect
            // this shouldn't be so since the config backend is supposed to be generic
            // and interchangeable but can't find a better way to do it...
            // comments are welcome :)
            //
            if( $this->_config->getStorageMethod() == "file" ) {
            	$this->_newConfigOpts["db_prefix"] = $configOpts["db_prefix"];
                $this->_newConfigOpts["db_host"] = $configOpts["db_host"];
                $this->_newConfigOpts["db_username"] = $configOpts["db_username"];
                $this->_newConfigOpts["db_database"] = $configOpts["db_database"];
                $this->_newConfigOpts["db_password"] = $configOpts["db_password"];
            }

            return true;
        }

        function perform()
        {
        	// we can proceed to update the config
            foreach( $this->_newConfigOpts as $key => $value ) {
            	$this->_config->setValue( $key, $value );
            }
            // and finally save everything
            $res = $this->_config->save();

            // depending on the result, we shall show one thing or another...
            if( $res ) {
            	$this->_view = new AdminMessageView( $this->_blogInfo );
                $this->_view->setMessage( $this->_locale->tr("site_config_saved_ok")."<br/><br/><a href=\"admin.php?op=editSiteSettings\">".$this->_locale->tr("back")."</a>" );
                $this->setCommonData();
            }
            else {
            	$this->_view = new AdminErrorView( $this->_blogInfo );
                $this->_view->setMessage( $this->_locale->tr("error_saving_site_config"));
                $this->setCommonData();
            }

            return $res;
        }
    }
?>
