<?php

	include_once( PLOG_CLASS_PATH."class/action/adminaction.class.php" );
    include_once( PLOG_CLASS_PATH."class/view/adminmessageview.class.php" );
    include_once( PLOG_CLASS_PATH."class/view/adminerrorview.class.php" );
    include_once( PLOG_CLASS_PATH."class/dao/mylinks.class.php" );
    include_once( PLOG_CLASS_PATH."class/dao/mylink.class.php" );

    /**
     * Updates a link
     */
    class AdminUpdateLinkAction extends AdminAction {

    	var $_linkName;
        var $_linkUrl;
        var $_linkId;
        var $_linkDescription;
        var $_linkCategoryId;

    	/**
         * Constructor. If nothing else, it also has to call the constructor of the parent
         * class, BlogAction with the same parameters
         */
        function AdminUpdateLinkAction( $actionInfo, $request )
        {
        	$this->AdminAction( $actionInfo, $request );
        }

        /**
         * Checks the data from the form
         */
        function validate()
        {
        	$this->_linkName = $this->_request->getValue( "linkName" );
            $this->_linkDescription = $this->_request->getValue( "linkDescription" );
            $this->_linkUrl  = $this->_request->getValue( "linkUrl" );
            $this->_linkCategoryId = $this->_request->getValue( "linkCategory" );
            $this->_linkId = $this->_request->getValue( "linkId" );

            // we should have at least a name, a url and a the category identifier
            if( $this->_linkName == "" || $this->_linkUrl == "" || $this->_linkCategoryId == "" || $this->_linkCategoryId <= 0 ) {
            	$this->_view = new AdminErrorView( $this->_blogInfo );
                $this->_view->setMessage( $this->_locale->tr("error_provide_name_and_url"));
                $this->setCommonData();

                return false;
            }

            // check that we have a link identifier
            if( $this->_linkId == "" || $this->_linkId <= 0 ) {
            	$this->_view = new AdminErrorView( $this->_blogInfo );
                $this->_view->setMessage( $this->_locale->tr("error_invalid_link_id"));
                $this->setCommonData();

                return false;
            }

            return true;
        }

        /**
         * Carries out the specified action
         */
        function perform()
        {
        	// fetch the link we're trying to update
            $links = new MyLinks();
            $link  = $links->getMyLink( $this->_linkId, $this->_blogInfo->getId());
            if( !$link ) {
            	$this->_view = new AdminErrorView( $this->_blogInfo );
                $this->_view->setMessage( $this->_locale->tr("error_fetching_link"));
                $this->setCommonData();

                return false;
            }

            // update the fields
            $link->setName( $this->_linkName );
            $link->setDescription( $this->_linkDescription );
            $link->setCategoryId( $this->_linkCategoryId );
            $link->setUrl( $this->_linkUrl );
            // and now update it in the database
            if( !$links->updateMyLink( $link )) {
            	$this->_view = new AdminErrorView( $this->_blogInfo );
                $this->_view->setMessage( $this->_locale->tr("error_updating_link"));
                $this->setCommonData();

                return false;
            }

            $this->_view = new AdminMessageView( $this->_blogInfo );
            $this->_view->setMessage( $this->_locale->tr("link_updated_ok"));
            $this->setCommonData();

            // better to return true if everything fine
            return true;
        }
    }
?>
