<?php

	include_once( PLOG_CLASS_PATH."class/action/adminaction.class.php" );
    include_once( PLOG_CLASS_PATH."class/view/adminerrorview.class.php" );
    include_once( PLOG_CLASS_PATH."class/view/adminmessageview.class.php" );
    include_once( PLOG_CLASS_PATH."class/view/admineditpostview.class.php" );
    include_once( PLOG_CLASS_PATH."class/data/integervalidator.class.php" );
    include_once( PLOG_CLASS_PATH."class/dao/articles.class.php" );
    include_once( PLOG_CLASS_PATH."class/data/textfilter.class.php" );

    /**
     * Updates the values of the post in the database
     */
    class AdminUpdatePostAction extends AdminAction 
    {

    	var $_postTopic;
        var $_postText;
        var $_postExtendedText;
        var $_postCategory;
        var $_postStatus;
        var $_sendNotification;
        var $_postId;
        //var $_subOp;
        var $_updatePost;
        var $_previewPost;
        var $_commentsEnabled;
        // stuff about the date
        var $_postYear;
        var $_postMonth;
        var $_postDay;
        var $_postHour;
        var $_postMinutes;
        var $_postTimestamp;

    	/**
         * Constructor. If nothing else, it also has to call the constructor of the parent
         * class, BlogAction with the same parameters
         */
        function AdminUpdatePostAction( $actionInfo, $request )
        {
        	$this->AdminAction( $actionInfo, $request );
        }

        /**
         * Checks that the data is correct
         */
        function validate()
        {
        	$this->_postText     = Textfilter::xhtmlize($this->_request->getValue( "postText" ));
            $this->_postExtendedText = Textfilter::xhtmlize($this->_request->getValue( "postExtendedText" ));
            $this->_postTopic    = $this->_request->getValue( "postTopic" );
            $this->_postCategory = $this->_request->getValue( "postCategory" );
            $this->_postStatus   = $this->_request->getValue( "postStatus" );
            $this->_sendNotification = $this->_request->getValue( "sendNotification" );
            $this->_postId       = $this->_request->getValue( "postId" );
            //$this->_subOp        = $this->_request->getValue( "subOp" );
            $this->_previewPost  = $this->_request->getValue( "previewPost" );
            $this->_updatePost   = $this->_request->getValue( "updatePost" );
            $this->_commentsEnabled = $this->_request->getValue( "commentsEnabled" );

            if( $this->_commentsEnabled == "1" )
            	$this->_commentsEnabled = true;
            else
            	$this->_commentsEnabled = false;

            // fetch the timestamp that the post will have
            /*$this->_postDay = $this->_request->getValue( "postDay" );
            $this->_postMonth = $this->_request->getValue( "postMonth" );
            $this->_postHour = $this->_request->getValue( "postHour" );
            $this->_postMinutes = $this->_request->getValue( "postMinutes" );
            $this->_postYear = $this->_request->getValue( "postYear" );*/
            // fetch the timestamp that the post will have
            if( $this->_config->getValue( "disable_javascript_calendar")) {
            	$this->_postDay = $this->_request->getValue( "postDay" );
                $this->_postMonth = $this->_request->getValue( "postMonth" );
                $this->_postHour = $this->_request->getValue( "postHour" );
                $this->_postMinutes = $this->_request->getValue( "postMinutes" );
                $this->_postYear = $this->_request->getValue( "postYear" );
            }
            else {
            	$postDateTime = $this->_request->getValue( "postDateTime" );
                $dateTimeParts = explode(" ", $postDateTime);
                $dateParts = explode("/", $dateTimeParts[0] );
                $timeParts = explode(":",$dateTimeParts[1] );
                $this->_postDay = $dateParts[0];
                $this->_postMonth = $dateParts[1];
                $this->_postYear = $dateParts[2];
                $this->_postHour = $timeParts[0];
                $this->_postMinutes = $timeParts[1];
            }

            $this->_postTimestamp = new Timestamp();
            $this->_postTimestamp->setMinutes( $this->_postMinutes );
            $this->_postTimestamp->setHour( $this->_postHour );
            $this->_postTimestamp->setDay( $this->_postDay );
            $this->_postTimestamp->setMonth( $this->_postMonth );
            $this->_postTimestamp->setYear( $this->_postYear );

            // check the information
            if( $this->_postText == "" || $this->_postTopic == "" || $this->_postCategory == "" ) {
            	$this->_view = new AdminErrorView( $this->_blogInfo );
                $this->_view->setValue( "message", $this->_locale->tr("error_must_give_post_intro"));
                $this->setCommonData();

                return false;
            }

            // check the post identifier
            $val = new IntegerValidator( $this->_postId );
            if( !$val->validate()) {
            	$this->_view = new AdminErrorView( $this->_blogInfo );
                $this->_view->setValue( "message", $this->_locale->tr("error_incorrect_article_id"));
                $this->setCommonData();

                return false;
            }

            return true;
        }

        function sendXmlRpcPings()
        {
        	// send the xmlrpc ping
            $blogs = new Blogs();
            $resultArray = $blogs->updateNotify( $this->_blogInfo );
            //print_r($resultArray);
            foreach( $resultArray as $host => $result ) {
            	if( $result == "OK" )
                	$message .= $this->_locale->tr("xmlrpc_ping_ok").$host.".<br/><br/>";
                else {
                    $message .= $this->_locale->tr("error_sending_xmlrpc_ping").$host.".";
                    if( $result != "" ) $message .= "<br/>".$this->_locale->tr("error_sending_xmlrpc_ping_message").$result.".";
                    $message .= "<br/><br/>";
                 }
            }

            return $message;
        }

        /**
         * Carries out the specified action
         */
        function perform()
        {
            // fetch the old post
            $articles =  new Articles();
            $post     = $articles->getBlogArticle( $this->_postId, $this->_blogInfo->getId());
            // there must be something wrong if we can't fetch the post that we are trying to update...
            if( !$post ) {
            	$this->_view = new AdminErrorView( $this->_blogInfo );
                $this->_view->setValue( "message", $this->_locale->tr("error_getting_post_to_update"));
                $this->setCommonData();

                return false;
            }

            // if we got it, update some fields
            $post->setTopic( stripslashes($this->_postTopic));
            $postText = $this->_postText.POST_EXTENDED_TEXT_MODIFIER.$this->_postExtendedText;
            $post->setText( stripslashes($postText));
            $post->setCategoryId( $this->_postCategory );
            $post->setStatus( $this->_postStatus );
            $post->setDateObject( $this->_postTimestamp );
            $post->setCommentsEnabled( $this->_commentsEnabled );

            // check if we have to update or preview
            //if( $this->_subOp == $this->_locale->tr("update")) {
            if( $this->_updatePost != "" ) {
            	// and finally save the post to the database
            	if( !$articles->updateArticle( $post )) {
            		$this->_view = new AdminErrorView( $this->_blogInfo );
                	$this->_view->setValue( "message", $this->_locale->tr("error_updating_post_in_database"));
                	$this->setCommonData();

                	return false;

            	}

            	// create the definitive view
            	$this->_view = new AdminMessageView( $this->_blogInfo );
            	// show a message saying that the post was updated
            	$message = $this->_locale->tr("post_successfully_updated");

            	// check if there was a previous notification
            	$notifications = new ArticleNotifications();
            	$artNotification = $notifications->getUserArticleNotification( $this->_postId, $this->_blogInfo->getId(), $this->_userInfo->getId());
            	// check if we have to add or remove a notification
            	if( $this->_sendNotification == "on" ) {
            		if( !$artNotification ) {
                		// if there wasn't one and now we want it, we have to add it
                    	$notifications->addNotification( $this->_postId, $this->_blogInfo->getId(), $this->_userInfo->getId());
                    	$message .= "<br/><br/>".$this->_locale->tr("you_will_be_notified");
                	}
            	}
            	else {
            		// if we don't want notifications, then we have to check if there is one since we
                	// should remove it
                	if( $artNotification ) {
                		$notifications->deleteNotification( $this->_postId, $this->_blogInfo->getId(), $this->_userInfo->getId());
                    	$message .= "<br/><br/>".$this->_locale->tr("notification_removed");
                	}
            	}

                /*if( $post->getStatus() == PUBLISED ) {
                	$pingsOutput = $this->sendXmlRpcPings();
                    $message .= $pingsOutput;
                }*/

            	// show the message
				$message .= "<br/><br/><a href=\"admin.php?op=editPosts\">".$this->_locale->tr("back")."</a>";
            	$this->_view->setMessage( $message );
            }
            //elseif( $this->_subOp == $this->_locale->tr("preview")) {
            elseif( $this->_previewPost != "" ) {
            	$this->_view = new AdminEditPostView( $this->_blogInfo );
            	// fetch the categories since we're going to need them
            	$categories = new ArticleCategories();
            	$blogCategories = $categories->getBlogCategories( $this->_blogInfo->getId());

            	// check if there is a notification for the article set up by this user
            	$notifications = new ArticleNotifications();
            	$userNotification = $notifications->getUserArticleNotification( $this->_postId, $this->_blogInfo->getId(), $this->_userInfo->getId());

                //
                // :KLUDGE:
                //
                // this very dirty and should be fixed somehow...
                // we have the same piece of code in both AdminAddPostAction
                // and AdminNewPostAction and this is not what OOP is all about,
                // is it? :)
                //
                $months = $this->_locale->getMonthNames();
                $years = range( 1990, 2030 );
                $minutes = Array( "00", "01", "02", "03", "04", "05", "06", "07", "08", "09",
                                  "10", "11", "12", "13", "14", "15", "16", "17", "18", "19",
                                  "20", "21", "22", "23", "24", "25", "26", "27", "28", "29",
                                  "30", "31", "32", "33", "34", "35", "36", "37", "38", "39",
                                  "40", "41", "42", "43", "44", "45", "46", "47", "48", "49",
                                  "50", "51", "52", "53", "54", "55", "56", "57", "58", "59" );
                $hours = Array( "00", "01", "02", "03", "04", "05", "06", "07", "08",
                                "09", "10", "11", "12", "13", "14", "15", "16", "17",
                                "18", "19", "20", "21", "22", "23" );
                                
                $days = $this->_locale->getDayNamesShort();

                // put all this stuff back into the template
                $this->_view->setValue( "postYear", $this->_postYear );
                $this->_view->setValue( "postMonth", $this->_postMonth );
                $this->_view->setValue( "postDay", $this->_postDay );
                $this->_view->setValue( "postHour", $this->_postHour );
                $this->_view->setValue( "postMinutes", $this->_postMinutes );
                $this->_view->setValue( "months", $months );
                $this->_view->setValue( "years", $years );
                $this->_view->setValue( "days", $days );                
                $this->_view->setValue( "minutes", $minutes );
                $this->_view->setValue( "hours", $hours );
                $this->_view->setValue( "commentsEnabled", $this->_commentsEnabled );

            	// put the post in the template context so that its information can be displayed
            	$this->_view->setValue( "post", $post );
            	$this->_view->setValue( "categories", $blogCategories );
                $this->_view->setValue( "previewMode", true );
                if( $this->_sendNotification == "on" )
                	$this->_view->setValue( "notification", true );
                else
                	$this->_view->setValue( "notification", false );
            }

            $this->setCommonData();

            return true;
        }
    }
?>
