<?php

	include_once( PLOG_CLASS_PATH."class/action/adminaction.class.php" );
    include_once( PLOG_CLASS_PATH."class/view/adminerrorview.class.php" );
    include_once( PLOG_CLASS_PATH."class/view/adminmessageview.class.php" );
    include_once( PLOG_CLASS_PATH."class/gallery/dao/galleryresource.class.php" );
    include_once( PLOG_CLASS_PATH."class/gallery/dao/galleryalbums.class.php" );

    /**
     * Updates a resource in the database
     */
    class AdminUpdateResourceAction extends AdminAction
    {

    	var $_resourceId;
        var $_resourceDescription;
        var $_albumId;

    	/**
         * Constructor. If nothing else, it also has to call the constructor of the parent
         * class, BlogAction with the same parameters
         */
        function AdminUpdateResourceAction( $actionInfo, $request )
        {
        	$this->AdminAction( $actionInfo, $request );
        }

        function validate()
        {
        	$this->_resourceId = $this->_request->getValue( "resourceId" );
            $this->_albumId = $this->_request->getValue( "albumId" );
            $this->_resourceDescription = $this->_request->getValue( "resourceDescription" );

            return true;
        }

        /**
         * Carries out the specified action
         */
        function perform()
        {
        	// load the resource
        	$resources = new GalleryResources();
            $resource = $resources->getResource( $this->_resourceId, $this->_blogInfo->getId());
            // update the fields we'd like to update
            $resource->setAlbumId( $this->_albumId );
            $resource->setDescription( $this->_resourceDescription );
            // and update it in the db
            $result = $resources->updateResource( $resource );

            if( !$result ) {
            	$this->_view = new AdminErrorView( $this->_blogInfo );
                $this->_view->setMessage( $this->_locale->tr("error_updating_resource"));
            }
            else {
            	$this->_view = new AdminMessageView( $this->_blogInfo );
                $this->_view->setMessage( $this->_locale->pr("resource_updated_ok", $resource->getFileName()));
            }

            $this->setCommonData();

            // better to return true if everything fine
            return true;
        }
    }
?>
