<?php

	include_once( PLOG_CLASS_PATH."class/action/adminaction.class.php" );
    include_once( PLOG_CLASS_PATH."class/view/adminmessageview.class.php" );
    include_once( PLOG_CLASS_PATH."class/view/adminerrorview.class.php" );
    include_once( PLOG_CLASS_PATH."class/gallery/dao/galleryalbums.class.php" );
    include_once( PLOG_CLASS_PATH."class/data/integervalidator.class.php" );
    include_once( PLOG_CLASS_PATH."class/data/stringvalidator.class.php" );

    /**
     * Shows information about a resource
     */
    class AdminUpdateResourceAlbumAction extends AdminAction
    {

    	var $_albumId;
        var $_albumName;
        var $_albumDescription;
        var $_parentId;
        var $_showAlbum;

    	/**
         * Constructor. If nothing else, it also has to call the constructor of the parent
         * class, BlogAction with the same parameters
         */
        function AdminUpdateResourceAlbumAction( $actionInfo, $request )
        {
        	$this->AdminAction( $actionInfo, $request );
        }

        function validate()
        {
        	$this->_albumId = $this->_request->getValue( "albumId" );
            $val1 = new IntegerValidator( $this->_albumId );
            if( !$val1->validate()) {
            	$this->_view = new AdminErrorView( $this->_blogInfo );
                $this->_view->setMessage( $this->_locale->tr("error_album_id_parameter_missing"));
                $this->setCommonData();

                return false;
            }

        	$this->_parentId = $this->_request->getValue( "parentAlbumId" );
            $val2 = new IntegerValidator( $this->_albumId );
            if( !$val2->validate()) {
            	$this->_view = new AdminErrorView( $this->_blogInfo );
                $this->_view->setMessage( $this->_locale->tr("error_album_parent_id_parameter_missing"));
                $this->setCommonData();

                return false;
            }

            $this->_albumDescription = $this->_request->getValue( "albumDescription" );

            $this->_albumName = $this->_request->getValue( "albumName" );
            $val3 = new StringValidator( $this->_albumName );
            if( !$val3->validate()) {
            	$this->_view = new AdminErrorView( $this->_blogInfo );
                $this->_view->setMessage( $this->_locale->tr("error_album_parent_id_parameter_missing"));
                $this->setCommonData();

                return false;
            }

            $this->_showAlbum = $this->_request->getValue( "showAlbum" );
            if( $this->_showAlbum == "" )
            	$this->_showAlbum = 0;

            return true;
        }

        /**
         * Carries out the specified action
         */
        function perform()
        {
            // fetch the albums for this blog
            $albums = new GalleryAlbums();
            $album = $albums->getAlbum( $this->_albumId, $this->_blogInfo->getId());

            if( !$album ) {
            	$this->_view = new AdminErrorView( $this->_blogInfo );
                $this->_view->setMessage( "error_loading_resource_album" );
                $this->setCommonData();

                return false;
            }

            // update the fields in the object
            $album->setName( $this->_albumName );
            $album->setDescription( $this->_albumDescription );
            $album->setParentId( $this->_parentId );
            $album->setShowAlbum( $this->_showAlbum );
            // and update the data in the database
            if( !$albums->updateAlbum( $album )) {
            	$this->_view = new AdminErrorView( $this->_blogInfo );
                $this->_view->setMessage( $this->_locale->tr("error_updating_resource_album" ));
            	$this->setCommonData();

                return false;
            }

            $this->_view = new AdminMessageView( $this->_blogInfo );
            $this->_view->setMessage( $this->_locale->pr("resource_album_updated_ok", $album->getName()));
            $this->setCommonData();

            // better to return true if everything fine
            return true;
        }
    }
?>
