<?php

	include_once( PLOG_CLASS_PATH."class/action/siteadminaction.class.php" );
    include_once( PLOG_CLASS_PATH."class/data/integervalidator.class.php" );
    include_once( PLOG_CLASS_PATH."class/view/adminerrorview.class.php" );
    include_once( PLOG_CLASS_PATH."class/view/admintemplatedview.class.php" );
    include_once( PLOG_CLASS_PATH."class/data/passwordvalidator.class.php" );
    include_once( PLOG_CLASS_PATH."class/dao/users.class.php" );
    include_once( PLOG_CLASS_PATH."class/view/adminmessageview.class.php" );

    class AdminUpdateUserProfileAction extends SiteAdminAction {

    	var $_userId;
        var $_userPassword;
        var $_userEmail;
        var $_userAbout;
        var $_adminPrivs;

    	function AdminUpdateUserProfileAction( $actionInfo, $request )
        {
        	$this->SiteAdminAction( $actionInfo, $request );
        }

        function validate()
        {
        	$this->_userId = $this->_request->getValue( "userId" );
            $this->_userPassword = $this->_request->getValue( "userPassword" );
            $this->_userEmail = $this->_request->getValue( "userEmail" );
            $this->_userAbout = $this->_request->getValue( "userAbout" );
            $this->_adminPrivs = $this->_request->getValue( "adminPrivs" );

            $val = new IntegerValidator( $this->_userId );
            if( !$val->validate()) {
                $this->_view = new AdminErrorView( $this->_blogInfo );
                $this->_view->setMessage( $this->_locale->tr("error_user_id_incorrect"));
                $this->setCommonData();

                return false;
            }

            // validate the password if we're intending to change it
            if( $this->_userPassword != "" ) {
            	$val2 = new PasswordValidator( $this->_userPassword );
                if( !$val2->validate()) {
                	$this->_view = new AdminErrorView( $this->_blogInfo );
                    $this->_view->setMessage( $this->_locale->tr("error_password_incorrect") );
                    $this->setCommonData();

                    return false;
                }
            }

            if( $this->_adminPrivs == "on" )
            	$this->_adminPrivs = true;
            else
            	$this->_adminPrivs = false;

            return true;
        }

        function perform()
        {
        	// load the user settings
            $users = new Users();
            $user  = $users->getUserInfoFromId( $this->_userId );

            // if no info could be fetched, shown an error and quit
            if( !$user ) {
            	$this->_view = new AdminErrorView( $this->_blogInfo );
                $this->_view->setMessage( $this->_locale->tr("error_fetching_user_information") );
                $this->setCommonData();

                return false;
            }

            // update the user settings
            $user->setEmail( $this->_userEmail );
            $user->setAboutMyself( $this->_userAbout );
            $user->setSiteAdmin( $this->_adminPrivs );
            if( $this->_userPassword != "" )
            	$user->setPassword( $this->_userPassword );

            // and now update them
            if( !$users->updateUser( $user )) {
            	$this->_view =  new AdminErrorView( $this->_blogInfo );
                $this->_view->setMessage( $this->_locale->tr("error_updating_user_settings") );
                $this->setCommonData();

                return false;
            }

            $this->_view = new AdminMessageView( $this->_blogInfo );
            $this->_view->setMessage( $this->_locale->pr("user_settings_updated_ok", $user->getUsername()) );
            $this->setCommonData();

            return true;
        }
    }
?>
