<?php

	include_once( PLOG_CLASS_PATH."class/action/siteadminaction.class.php" );
    include_once( PLOG_CLASS_PATH."class/data/integervalidator.class.php" );
    include_once( PLOG_CLASS_PATH."class/view/adminerrorview.class.php" );
    include_once( PLOG_CLASS_PATH."class/view/admintemplatedview.class.php" );
    include_once( PLOG_CLASS_PATH."class/dao/users.class.php" );

    class AdminUserProfileAction extends SiteAdminAction {

    	var $_userId;

    	function AdminUserProfileAction( $actionInfo, $request )
        {
        	$this->SiteAdminAction( $actionInfo, $request );
        }

        function validate()
        {
        	$this->_userId = $this->_request->getValue( "userId" );

            $val = new IntegerValidator( $this->_userId );
            if( !$val->validate()) {
                $this->_view = new AdminErrorView( $this->_blogInfo );
                $this->_view->setMessage( $this->_locale->tr("error_user_id_incorrect") );
                $this->setCommonData();

                return false;
            }

            return true;
        }

        function perform()
        {
        	// load the user settings
            $users = new Users();
            $user  = $users->getUserInfoFromId( $this->_userId );

            // if no info could be fetched, shown an error and quit
            if( !$user ) {
            	$this->_view = new AdminErrorView( $this->_blogInfo );
                $this->_view->setMessage( $this->_locale->tr("error_fetching_user_information"));
                $this->setCommonData();

                return false;
            }

            // fetch the blogs to which this user belongs
            $userBlogs = $users->getUsersBlogs( $user->getId());

            // otherwise, transfer it to the template context and let the
            // template do the rest
            $this->_view = new AdminTemplatedView( $this->_blogInfo, "userprofile" );
            $this->_view->setValue( "edituser", $user );
            $this->_view->setValue( "edituserblogs", $userBlogs );
            $this->setCommonData();

            return true;
        }
    }
?>
