<?php

	include_once( PLOG_CLASS_PATH."class/action/adminaction.class.php" );

    //
	// :TODO:
    // at the moment the class shows a bare message and simply dies if there are not
    // enough privileges. I think we should show a nicer message
    //

    /**
     * Extends the AdminAction class in a way that any class subclassing this one,
     * will check if the user has BLOG_OWNER privileges to be here
     */
    class BlogOwnerAdminAction extends AdminAction {

    	/**
         * The constructor calls AdminAction so that we can fetch the information we need
         * from the session (blogInfo and userInfo) and then check if the owner of the blog
         * is the same as the user who is currently trying to access. If so, we continue. If not,
         * then we show an error message and quit.
         */   
    	function BlogOwnerAdminAction( $actionInfo, $request )
        {
        	$this->AdminAction( $actionInfo, $request );

            // we should check if the user has permissions to be here...
            if( $this->_blogInfo->getOwner() != $this->_userInfo->getId()) {
            	print("Sorry, only the owner of the blog can access this area." );
                die();
            }
        }
    }
?>
