<?php

	include_once( PLOG_CLASS_PATH."class/action/blogaction.class.php" );
    include_once( PLOG_CLASS_PATH."class/view/commentview.class.php" );
	include_once( PLOG_CLASS_PATH."class/view/errorview.class.php" );
    include_once( PLOG_CLASS_PATH."class/dao/blogs.class.php" );
    include_once( PLOG_CLASS_PATH."class/dao/articles.class.php" );
    include_once( PLOG_CLASS_PATH."class/dao/articlecategories.class.php" );
    include_once( PLOG_CLASS_PATH."class/dao/users.class.php" );
    include_once( PLOG_CLASS_PATH."class/data/integervalidator.class.php" );

    /**
     * Adds a comment
     */
	class CommentAction extends BlogAction {

    	var $_articleId;
        var $_parentId;

		function ViewArticleAction( $actionInfo, $request )
        {
			$this->BlogAction( $actionInfo, $request );
        }

        /**
         * Fetches and checks the parameters.
         */
        function validate()
        {
        	$this->_parentId  = $this->_request->getValue( "parentId" );
            $this->_articleId = $this->_request->getValue( "articleId" );

            // check if comments are enabled
            $blogSettings = $this->_blogInfo->getSettings();
            if( !$blogSettings->getValue( "comments_enabled" )) {
            	$this->_view = new ErrorView( $this->_blogInfo, "error_comments_not_enabled" );
                $this->setCommonData();

                return false;
            }

            // if they are enabled, proceed
            $validator = new IntegerValidator( $this->_articleId );
            // if the information is not correct, we better show a message and quit
            if( !$validator->validate()) {
            	$this->_view = new ErrorView( $this->_blogInfo, "error_incorrect_article_id" );
                $this->setCommonData();

                return false;
            }

            return true;
        }

        function perform()
        {
            if( $this->_parentId < 0 || $this->_parentId == "" )
            	$this->_parentId = 0;

            // fetch the article
            $blogs    = new Blogs();
            $articles = new Articles();
            $article  = $articles->getBlogArticle( $this->_articleId, $this->_blogInfo->getId());

        	$this->_view = new CommentView( $this->_blogInfo );

            // if there was a problem fetching the article, we give an error and quit
            if( $article == false ) {
            	$this->_view = new ErrorView( $this->_blogInfo );
                $this->_view->setValue( "message", "error_fetching_article" );
                $this->setCommonData();
                return false;
            }

			// fetch the comments so far
			$comments = new ArticleComments();
			$postComments = $comments->getPostComments( $article->getId());

            // if everything's fine, we set up the article object for the view
            $this->_view->setValue( "category", $category );
            $this->_view->setValue( "post", $article );
            $this->_view->setValue( "user", $user );
            $this->_view->setValue( "parentId", $parentId );
			$this->_view->setValue( "comments", $postComments );
			$this->_view->setValue( "postcomments", $postComments );
	    
            //**** sorry, but this has to go into every action that will include the header.template *****//
            //**** dirtiest hack I've ever seen, though :( ******//
            $this->setCommonData();

            // and return everything normal
            return true;
        }
    }
?>
