<?php

	include_once( PLOG_CLASS_PATH."class/action/blogaction.class.php" );
    include_once( PLOG_CLASS_PATH."class/view/defaultview.class.php" );
    include_once( PLOG_CLASS_PATH."class/net/sessioninfo.class.php" );
    include_once( PLOG_CLASS_PATH."class/dao/articles.class.php" );
    include_once( PLOG_CLASS_PATH."class/dao/blogs.class.php" );
    include_once( PLOG_CLASS_PATH."class/dao/blogsettings.class.php" );
    include_once( PLOG_CLASS_PATH."class/view/errorview.class.php" );
    include_once( PLOG_CLASS_PATH."class/dao/referers.class.php" );

    /**
     * This class represents the defaut view in our application
     */
	class DefaultAction extends BlogAction {

		var $_config;
        var $_date;
        var $_categoryId;
        var $_postAmount;

		function DefaultAction( $actionInfo, $request )
        {
			$this->BlogAction( $actionInfo, $request );
        }

        function validate()
        {
            // value of the Date parameter from the request
            $this->_date = $this->_request->getValue( "Date" );
            if( $this->_date == "" )
            	$this->_date = -1;

            //
            // :KLUDGE:
            //
            // beware, the following is not very nice...
            //
            $this->_categoryId = $this->_request->getValue( "postCategoryId" );
            if( $this->_categoryId == "" )
            	if( $this->_date == -1 )
                	$this->_categoryId = 0;
                else
                	$this->_categoryId = -1;

            return true;
        }

        /**
         * Executes the action
         */
        function perform()
        {

        	// update the referer statistics
            $referers = new Referers();
            $referers->addReferer( $_SERVER["HTTP_REFERER"], 0, $this->_blogInfo->getId());
        	// first of all, we have to determine which blog we would like to see
			$blogId = $this->_blogInfo->getId();

            // fetch the settings for that blog
            $blogSettings = $this->_blogInfo->getSettings();

            // prepare the view
        	$this->_view = new DefaultView( $this->_blogInfo );

			// fetch all the articles from that blog
            $articles =  new Articles();

            $t = new Timestamp();
            $todayTimestamp = $t->getTimestamp();
            
            // amount of posts that we have to show, but keeping in mind that when browsing a
            // category or specific date, we should show *all* of them
            if( $this->_date > 0 || $this->_categoryId > 0 ) {
                $this->_postAmount = -1;
                // also, inform the template that we're showing them all!
                $this->_view->setValue( "showAll", true );
            }
            else {
                $this->_postAmount = $blogSettings->getValue( "show_posts_max" );
                $this->_view->setValue( "showAll", false );
            }
            
            //
            // :KLUDGE:
            // the more things we add here to filter, the more complicated this function
            // gets... look at this call and look at how many parameters it needs!! :(
            //
			$config =& Config::getConfig();
			if( ($config->getValue( "show_future_posts_in_calendar")) && ( $this->_date > -1 )) {
				// if posts in the future are to be shown, we shouldn't set a maximum date
				$blogArticles = $articles->getBlogArticles( $blogId, $this->_date,
								$this->_postAmount, $this->_categoryId,
								POST_STATUS_PUBLISHED, 0 );			
			}
			else {
				$blogArticles = $articles->getBlogArticles( $blogId, $this->_date,
								$this->_postAmount, $this->_categoryId,
								POST_STATUS_PUBLISHED, 0, $todayTimestamp );
			}

            // if we couldn't fetch the articles, send an error and quit
            if( !$blogArticles ) {
            	$this->_view = new ErrorView( $this->_blogInfo );
                $this->_view->setValue( "message", "error_fetching_articles" );
            }
            else {
	            // otherwise, continue
                // the view will take care of cutting the post if we have the "show more"
                // feature enabled or not... we could do it here but I think that belongs
                // to the view since it is presentation stuff... It could also be handled
                // by the template but then it'd make the template a little bit more
                // complicated...
    	        $this->_view->setValue( "posts", $blogArticles );
            }

            //**** sorry, but this has to go into every action that will include the header.template *****//
            //**** dirtiest hack I've ever seen, though :( ******//
            $this->setCommonData();

            // save the information about the session for later
            $this->saveSession();

            return true;
        }
    }
?>