<?php

	include_once( PLOG_CLASS_PATH."class/action/blogaction.class.php" );
    include_once( PLOG_CLASS_PATH."class/view/linktrackerview.class.php" );
    include_once( PLOG_CLASS_PATH."class/view/errorview.class.php" );
    include_once( PLOG_CLASS_PATH."class/dao/linktracker.class.php" );
    include_once( PLOG_CLASS_PATH."class/dao/linktrackerresult.class.php" );

    /**
     * Action that receives the input when the operation called
     * is "LinkTracker"
     */
    class LinkTrackerAction extends BlogAction {

    	/**
         * Constructor
         */
    	function LinkTrackerAction( $blogInfo, $request )
        {
        	$this->BlogAction( $blogInfo, $request );
        }

        /**
         * Carries out the action
         */
        function perform()
        {
        	$l = new LinkTracker();
            $links =  $l->getLinks( $this->_blogInfo->getId());

            // if any error, return the error view
            if( ($links == "") || (empty($links))) {
            	$this->_view = new ErrorView( $this->_blogInfo );
                $this->_view->setValue( "message", "error_blog_has_no_links" );
                $this->setCommonData();
                return false;
            }

            $this->_view = new LinkTrackerView( $this->_blogInfo );
            $this->_view->setValue( "links", $links );
            $this->setCommonData();

            return true;
        }
    }
?>
