<?php

	include_once( PLOG_CLASS_PATH."class/action/blogaction.class.php" );
    include_once( PLOG_CLASS_PATH."class/view/viewalbumview.class.php" );
    include_once( PLOG_CLASS_PATH."class/view/viewalbumsview.class.php" );
    include_once( PLOG_CLASS_PATH."class/view/errorview.class.php" );
    include_once( PLOG_CLASS_PATH."class/gallery/dao/galleryresources.class.php" );
    include_once( PLOG_CLASS_PATH."class/gallery/dao/galleryalbums.class.php" );
    include_once( PLOG_CLASS_PATH."class/data/integervalidator.class.php" );

    /**
     * This class shows an album with resources
     */
	class ViewAlbumAction extends BlogAction
    {

        var $_albumId;

		function ViewAlbumAction( $actionInfo, $request )
        {
			$this->BlogAction( $actionInfo, $request );
        }

        // checks that the articleId is valid
        function validate()
        {
        	$this->_albumId = $this->_request->getValue( "albumId" );

            $validator = new IntegerValidator( $this->_albumId );
            // if the information is not correct, we better show a message and quit
            if( !$validator->validate()) {
            	$this->_view = new ErrorView( $this->_blogInfo, "error_incorrect_album_id" );
                $this->setCommonData();

                return false;
            }

            return true;
        }

        function perform()
        {
        	$galleryResources = new GalleryResources();
            $galleryAlbums = new GalleryAlbums();

            // fetch the album we're trying to browse
            if( $this->_albumId == 0 ) {
            	// fetch only the first level albums
                $blogAlbums = $galleryAlbums->getChildAlbums( 0, $this->_blogInfo->getId(), true );
				if( count($blogAlbums) == 0 ) {
					$this->_view = new ErrorView( $this->_blogInfo );
					$this->_view->setValue( "message", "error_no_albums_defined" );
				}
				else {
					$this->_view = new ViewAlbumsView( $this->_blogInfo );
					$this->_view->setValue( "albums", $blogAlbums );
				}
            }
            else {
            	// the third parameter is telling _not_ to fetch all those albums that have
                // been disabled and are not to be shown in the page when browsing the album
            	$album = $galleryAlbums->getAlbum( $this->_albumId, $this->_blogInfo->getId(), true, true );
                // check if the album was correctly fetched
                if( !$album ) {
                	$this->_view = new ErrorView( $this->_blogInfo );
                    $this->_view->setValue( "message", "error_fetching_album" );
                    $this->setCommonData();

                    return false;
                }
                // put the album to the template
            	$this->_view = new ViewAlbumView( $this->_blogInfo );
                $this->_view->setValue( "album", $album );
            }

            // if all went fine, continue
            $this->setCommonData();
            // and return everything normal
            return true;
        }
    }
?>
