<?php

	include_once( PLOG_CLASS_PATH."class/action/blogaction.class.php" );
    include_once( PLOG_CLASS_PATH."class/view/viewarticletrackbacksview.class.php" );
    include_once( PLOG_CLASS_PATH."class/dao/articles.class.php" );
    include_once( PLOG_CLASS_PATH."class/dao/articlecategories.class.php" );
    include_once( PLOG_CLASS_PATH."class/dao/articlecomments.class.php" );
    include_once( PLOG_CLASS_PATH."class/dao/trackbacks.class.php" );
    include_once( PLOG_CLASS_PATH."class/dao/users.class.php" );
    include_once( PLOG_CLASS_PATH."class/dao/userinfo.class.php" );
    include_once( PLOG_CLASS_PATH."class/data/integervalidator.class.php" );
    include_once( PLOG_CLASS_PATH."class/view/errorview.class.php" );

    /**
     * It's almost the same as the ViewArticleAction...
     */
	class ViewArticleTrackbacksAction extends BlogAction {

    	var $_config;
        var $_articleId;

		function ViewArticleTrackbacksAction( $actionInfo, $request )
        {
			$this->BlogAction( $actionInfo, $request );

            $this->_config = new Config();
        }


        function validate()
        {
        	$this->_articleId = $this->_request->getValue( "articleId" );

            $validator = new IntegerValidator( $this->_articleId );
            if( !$validator->validate()) {
            	$this->_view = new ErrorView( $this->_blogInfo, "error_incorrect_article_id" );
                $this->setCommonData();
            	return false;
            }

            return true;
        }

        function perform()
        {
            // fetch the article
            $blogs    = new Blogs();
            $articles = new Articles();
            $article  = $articles->getBlogArticle( $this->_articleId, $this->_blogInfo->getId());
            $blogSettings = $this->_blogInfo->getSettings();

            // if the article id doesn't exist, cancel the whole thing...
            if( $article == false ) {
            	$this->_view = new ErrorView( $this->_blogInfo );
                $this->_view->setValue( "message", "error_fetching_article" );
                $this->setCommonData();

                return false;
            }

        	$this->_view = new ViewArticleTrackbacksView( $this->_blogInfo );

            // fetch the comments
            $comments = new ArticleComments();
            $articleComments = $comments->getPostComments( $article->getId());
            $this->_view->setValue( "comments", $articleComments );

            // fetch the trackback items related to this article, in case we want to show them.
            $trackbacks = new TrackBacks();
            $postTrackbacks = $trackbacks->getArticleTrackbacks( $article->getId());
            if( count($postTrackbacks) == 0 || $postTrackbacks == "" ) {
            $this->_view = new ErrorView( $this->_blogInfo );
                $this->_view->setValue( "message", "error_trackback_no_trackback" );
                $this->setCommonData();

                return false;
            }

            // if everything's fine, we set up the article object for the view
            $this->_view->setValue( "post", $article );
            $this->_view->setValue( "user", $user );
            $this->_view->setValue( "trackbacks", $postTrackbacks );
            $this->setCommonData();

            // and return everything normal
            return true;
        }
    }
?>
