<?php

	include_once( PLOG_CLASS_PATH."class/action/blogaction.class.php" );
    include_once( PLOG_CLASS_PATH."class/view/viewresourceview.class.php" );
    include_once( PLOG_CLASS_PATH."class/view/errorview.class.php" );
    include_once( PLOG_CLASS_PATH."class/gallery/dao/galleryresources.class.php" );
    include_once( PLOG_CLASS_PATH."class/data/integervalidator.class.php" );

    /**
     * This class shows a resource and its information
     */
	class ViewResourceAction extends BlogAction
    {

        var $_resourceId;

		function ViewResourceAction( $actionInfo, $request )
        {
			$this->BlogAction( $actionInfo, $request );
        }

        // checks that the articleId is valid
        function validate()
        {
        	$this->_resourceId = $this->_request->getValue( "resId" );
            $this->_resourceName = $this->_request->getValue( "resource" );

            if( $this->_resourceName == "" ) {
            	$validator = new IntegerValidator( $this->_resourceId );
                // if the information is not correct, we better show a message and quit
                if( !$validator->validate()) {
                	$this->_view = new ErrorView( $this->_blogInfo, "error_incorrect_resource_id" );
                    $this->setCommonData();

                    return false;
                }
            }

            return true;
        }

        function perform()
        {
        	$galleryResources = new GalleryResources();

            // fetch the album we're trying to browse
            if( $this->_resourceName != "" ) {
            	$resource = $galleryResources->getResourceFile( $this->_blogInfo->getId(), $this->_resourceName );
            }
            else {
            	$resource = $galleryResources->getResource( $this->_resourceId, $this->_blogInfo->getId());
            }

            // check if the album was correctly fetched
            if( !$resource ) {
            	$this->_view = new ErrorView( $this->_blogInfo );
                $this->_view->setValue( "message", "error_fetching_resource" );
                $this->setCommonData();

                return false;
            }

            // if all went fine, continue
            $this->_view = new ViewResourceView( $this->_blogInfo );
            $this->_view->setValue( "resource", $resource );
            $this->setCommonData();

            // and return everything normal
            return true;
        }
    }
?>
