<?php

	/*
     * This is the array definition of the different mappings
     * action parameter->action class used by the controller of the administrative
     * interface.
     */

    // default action that is used if no other
    $actions["Default"]    = "AdminDefaultAction";
    // after logging in, this is the action called
    $actions["Login"]      = "AdminLoginAction";
    // this action is called after we have verified that the user is valid
    // and want to make him or her choose a blog to work on (or skip
    // directly to the admin menu of the blog if he or she belongs to
    // only one)
    $actions["blogSelect"] = "AdminMainAction";
    // form to add new posts
    $actions["newPost"]    = "AdminNewPostAction";
    // adds a post to the database
    $actions["addPost"]    = "AdminAddPostAction";
    // form to add new article categories
    $actions["newArticleCategory"] = "AdminNewArticleCategoryAction";
    // adds the category to the db
    $actions["addArticleCategory"] = "AdminAddArticleCategoryAction";
    // shows the settings of the blog
    $actions["blogSettings"] = "AdminBlogSettingsAction";
    // updates the settings of the blog
    $actions["updateBlogSettings"] = "AdminUpdateBlogSettingsAction";
    // shows a list of the posts
    $actions["editPosts"] = "AdminEditPostsAction";
    // removes a post from the database
    $actions["deletePost"] = "AdminDeletePostAction";
    // log out
    $actions["Logout"] = "AdminLogoutAction";
    // shows form to add a new link category
    $actions["newLinkCategory"] = "AdminNewLinkCategoryAction";
    // adds a new link category
    $actions["addLinkCategory"] = "AdminAddLinkCategoryAction";
    // shows the form to add a new link
    $actions["newLink"] = "AdminNewLinkAction";
    // adds the action to the database
    $actions["addLink"] = "AdminAddLinkAction";
    // shows a post for edition
    $actions["editPost"] = "AdminEditPostAction";
    // updates the post in the database
    $actions["updatePost"] = "AdminUpdatePostAction";
    // shows the list with the categories
    $actions["editArticleCategories"] = "AdminEditArticleCategoriesAction";
    // deletes an article category from the database
    $actions["deleteArticleCategory"] = "AdminDeleteArticleCategoryAction";
    // edits an article category
    $actions["editArticleCategory"] = "AdminEditArticleCategoryAction";
    // updates the category
    $actions["updateArticleCategory"] = "AdminUpdateArticleCategoryAction";
    // shows the list of links in order to edit them
    $actions["editLinks"] = "AdminEditLinksAction";
    // deletes a link from the database
    $actions["deleteLink"] = "AdminDeleteLinkAction";
    // shows the list of link categories
    $actions["editLinkCategories"] = "AdminEditLinkCategoriesAction";
    // deletes a link category
    $actions["deleteLinkCategory"] = "AdminDeleteLinkCategoryAction";
    // edits a link
    $actions["editLink"] = "AdminEditLinkAction";
    // updates a link
    $actions["updateLink"] = "AdminUpdateLinkAction";
    // edits a link category
    $actions["editLinkCategory"] = "AdminEditLinkCategoryAction";
    // updates a link category
    $actions["updateLinkCategory"] = "AdminUpdateLinkCategoryAction";
    // statistics
    $actions["Stats"] = "AdminStatisticsAction";
    // edit comments
    $actions["editComments"] = "AdminEditCommentsAction";
    // deletes a comment
    $actions["deleteComment"] = "AdminDeleteCommentAction";
    // show the user settings
    $actions["userSettings"] = "AdminUserSettingsAction";
    // update the user settings
    $actions["updateUserSettings"] = "AdminUpdateUserSettingsAction";
    // show statistics about a post
    $actions["postStats"] = "AdminPostStatsAction";
    // sends trackbacks
    $actions["sendTrackbacks"] = "AdminSendTrackbacksAction";
    // plugin center
    $actions["pluginCenter"] = "AdminPluginCenterAction";
    // pop-up help window
    $actions["Help"] = "AdminHelpAction";
    // super admin interface, main part
    $actions["adminSettings"] = "AdminSiteSettingsAction";
    // list of users in the site
    $actions["editSiteUsers"] = "AdminSiteUsersAction";
    // delete users
    $actions["deleteUsers"] = "AdminDeleteUsersAction";
    // list of blogs in the site
    $actions["editSiteBlogs"] = "AdminSiteBlogsAction";
    // global settings that can be changed
    $actions["editSiteSettings"] = "AdminGlobalSettingsAction";
    // updates the global settings
    $actions["updateGlobalSettings"] = "AdminUpdateGlobalSettingsAction";    
    // edit any user profile
    $actions["editUserProfile"] = "AdminUserProfileAction";
    // updates a user profie
    $actions["updateUserProfile"] = "AdminUpdateUserProfileAction";
    // shows the form to add a user
    $actions["createUser"] = "AdminCreateUserAction";
    // adds a user to the database
    $actions["addUser"] = "AdminAddUserAction";
    // shows the form to add a blog
    $actions["createBlog"] = "AdminCreateBlogAction";
    // adds the blog to the database
    $actions["addBlog"] = "AdminAddBlogAction";
    // edit the users in a blog
    $actions["editBlogUsers"] = "AdminEditSiteBlogUsersAction";
    // edit a blog
    $actions["editBlog"] = "AdminEditBlogAction";
    // saves the settings of the blog we edited
    $actions["updateEditBlog"] = "AdminUpdateEditBlogAction";
    // updates the users of a blog
    $actions["updateBlogUsers"] = "AdminUpdateSiteBlogUsersAction";
    // shows the form to add a user to the blog
    $actions["newBlogUser"] = "AdminNewBlogUserAction";
    // adds a user to the blog
    $actions["addBlogUser"] = "AdminAddBlogUserAction";
    // shows a list of the users that belong to this blog
    $actions["showBlogUsers"] = "AdminShowBlogUsersAction";
    // revokes the permissions of users in a blog
    $actions["deleteBlogUserPermissions"] = "AdminDeleteBlogUserPermissionsAction";
    // shows the configuration dialog for plugins
    $actions["configurePlugin"] = "AdminConfigurePluginAction";
    // updates the configuration of a plugin
    $actions["updatePluginConfig"] = "AdminUpdatePluginConfigurationAction";
    // shows a list with all the locale files available
    $actions["siteLocales"] = "AdminSiteLocalesAction";
    // removes a locale from disk
    $actions["deleteLocales"] = "AdminDeleteLocalesAction";
    // shows the form to upload a new locale file
    $actions["newLocale"] = "AdminNewLocaleAction";
    // adds a new locale to the server
    $actions["addLocale"] = "AdminAddLocaleAction";
    // shows a list of the locales available
    $actions["siteTemplates"] = "AdminEditTemplatesAction";
    // deletes templates
    $actions["deleteTemplates"] = "AdminDeleteTemplatesAction";
    // shows the form to add a new template
    $actions["newTemplate"] = "AdminNewTemplateAction";
    // adds a new template to the system
    $actions["addTemplate"] = "AdminAddTemplateAction";
    // adds a file to a template set
    $actions["newTemplateFile"] = "AdminNewGlobalTemplateFileAction";
    // adds a file to a template set
    $actions["addTemplateFile"] = "AdminAddGlobalTemplateFileAction";
    // list of templates available in the blog
    $actions["blogTemplates"] = "AdminEditBlogTemplatesAction";
    // shows the form to add a template
    $actions["newBlogTemplate"] = "AdminNewBlogTemplateAction";
    // adds a new template to the blog
    $actions["addBlogTemplate"] = "AdminAddBlogTemplateAction";
    // removes a template from the blog
    $actions["deleteBlogTemplate"] = "AdminDeleteBlogTemplateAction";
    // adds a file to a blog-specific template set
    $actions["newBlogTemplateFile"] = "AdminNewBlogTemplateFileAction";
    // adds a file to a blog-specific template set
    $actions["addBlogTemplateFile"] = "AdminAddBlogTemplateFileAction";
    // deletes blogs
    $actions["deleteBlogs"] = "AdminDeleteBlogAction";
    // main security page
    $actions["blogSecurity"] = "AdminBlogSecurityAction";
    // filtered contents
    $actions["blogFilteredContent"] = "AdminBlogFilteredContentsAction";
    // deletes filtered contents from a blog
    $actions["deleteBlogFilteredContent"] = "AdminDeleteBlogFilteredContentAction";
    // shows the form to add new filtered content to a blog
    $actions["newBlogFilteredContent"] = "AdminNewBlogFilteredContentAction";
    // adds filtered content to a blog
    $actions["addBlogFilteredContent"] = "AdminAddBlogFilteredContentAction";
    // blocks a host from posting comments
    $actions["blogBlockHostFromPosting"] = "AdminBlogBlockHostFromPostingAction";
    // shows the list of blocked hosts
    $actions["blogBlockedHosts"] = "AdminBlogBlockedHostsAction";
    // deletes blocked hosts
    $actions["blogDeleteBlockedHost"] = "AdminDeleteBlogBlockedHostAction";
    // shows the form to add a blocked host
    $actions["newBlogBlockedHost"] = "AdminNewBlogBlockedHostAction";
    // adds the host to the db
    $actions["addBlogBlockedHost"] = "AdminAddBlogBlockedHostAction";
    // purges posts from the database
    $actions["purgePosts"] = "AdminPurgePostsAction";
    // shows the resource center
    $actions["resourceCenter"] = "AdminResourceCenterAction";
    // shows the form to add a new resource album
    $actions["newResourceAlbum"] = "AdminNewResourceAlbumAction";
    // adds a new album to the database
    $actions["addResourceAlbum"] = "AdminAddResourceAlbumAction";
    // lists the resource albums of a blog
    $actions["resourceAlbums"] = "AdminResourceAlbumsAction";
    // shows the form to add a new resource to the blog
    $actions["newResource"] = "AdminNewResourceAction";
    // adds the new resource to the blog
    $actions["addResource"] = "AdminAddResourceAction";
    // list of resources
    $actions["resources"] = "AdminResourcesAction";
    // information about a resource
    $actions["resourceInfo"] = "AdminResourceInfoAction";
    // updates the information of a resource
    $actions["updateResource"] = "AdminUpdateResourceAction";
    // deletes a resource
    $actions["deleteResources"] = "AdminDeleteResourceAction";
    // shows a window with all the resources
    $actions["resourceList"] = "AdminResourceListAction";
    // show the form to add a globally blocked host
    $actions["newBlockedHost"] = "AdminNewBlockedHostAction";
    // globally blocks a host
    $actions["addBlockedHost"] = "AdminAddBlockedHostAction";
    // shows the list of globally blocked hosts
    $actions["blockedHosts"] = "AdminBlockedHostsAction";
    // deletes blocked hosts
    $actions["deleteBlockedHost"] = "AdminDeleteBlockedHostAction";
    // edits a blocked host
    $actions["editBlockedHost"] = "AdminEditBlockedHostAction";
    // updates a blocked host
    $actions["updateBlockedHost"] = "AdminUpdateBlockedHostAction";
    // edits a host blocked only in the current blog
    $actions["editBlogBlockedHost"] = "AdminEditBlogBlockedHostAction";
    // updates a host blocked only in the current blog
    $actions["updateBlogBlockedHost"] = "AdminUpdateBlogBlockedHostAction";
    // shows the list of filtered content
    $actions["filteredContent"] = "AdminFilteredContentAction";
    // shows form to add filtered content
    $actions["newFilteredContent"] = "AdminNewFilteredContentAction";
    // adds new filtered content
    $actions["addFilteredContent"] = "AdminAddFilteredContentAction";
    // removes filtered content
    $actions["deleteFilteredContent"] = "AdminDeleteFilteredContentAction";
    // edit filtered content
    $actions["editFilteredContent"] = "AdminEditFilteredContentAction";
    // updates filtered content
    $actions["updateFilteredContent"] = "AdminUpdateFilteredContentAction";
    // edits blog filtered content
    $actions["editBlogFilteredContent"] = "AdminEditBlogFilteredContentAction";
    // updates blog filtered content
    $actions["updateBlogFilteredContent"] = "AdminUpdateBlogFilteredContentAction";
    // edits a resource album
    $actions["editResourceAlbum"] = "AdminEditResourceAlbumAction";
    // updates a resource album
    $actions["updateResourceAlbum"] = "AdminUpdateResourceAlbumAction";
    // removes albums
    $actions["deleteResourceAlbum"] = "AdminDeleteResourceAlbumAction";
    // mark as spam
    $actions["markComment"] = "AdminMarkCommentAction";
    // purge spam comments
    $actions["purgeSpamComments"] = "AdminPurgeSpamCommentsAction";
	// regenerate a preview
	$actions["regeneratePreview"] = "AdminRegeneratePreviewAction";
?>
