<?php

	include_once( PLOG_CLASS_PATH."class/dao/model.class.php" );
    include_once( PLOG_CLASS_PATH."class/dao/mylink.class.php" );

    /**
     * Model for the myLinks feature
     */
    class MyLinks extends Model {

        /**
		 * Retrieves the links of the given blog.
         *
         * @param blogId Identifier of the blog
         * @param categoryId Category of the links
		 */
		function getLinks( $blogId, $categoryId = 0 )
		{
			$query = "SELECT * FROM ".$this->getPrefix()."mylinks WHERE blog_id = ".$blogId;
            if( $categoryId != 0 )
            	$query .= " AND category_id = ".$categoryId;
            $query .= " ORDER BY id ASC;";

			$result = $this->_db->Execute( $query );

			if( !$result )
				return false;

			$blogLinks = Array();

			while( $row = $result->FetchRow()) {
                $blogLink = new MyLink( $row["name"], $row["description"], $row["url"], $row["blog_id"], $row["category_id"], $row["id"] );
                array_push( $blogLinks, $blogLink );
			}

			return $blogLinks;
		}

        /**
         * Adds a link to the database
         *
         * @param myLink a MyLink object
         * @param blogId The blog id
         * @return True if successful or false otherwise.
         */
        function addMyLink( $myLink, $blogId )
        {
        	$query = "INSERT INTO ".$this->getPrefix()."mylinks (name,url,description,category_id,blog_id) VALUES ('".Db::qstr($myLink->getName())."','".$myLink->getUrl()."','".Db::qstr($myLink->getDescription())."',".$myLink->getCategoryId().",".$blogId.");";

            $result = $this->_db->Execute( $query );

            return $result;
        }

        /**
         * Removes a MyLink object from the database.
         *
         * @param linkId The link identifier.
         * @param blogId The blog identifier.
         * @return True if successful or false otherwise.
         */
        function deleteMyLink( $linkId, $blogId )
        {
        	$query = "DELETE FROM ".$this->getPrefix()."mylinks WHERE id = ".$linkId." AND blog_id = ".$blogId.";";

            $result = $this->_db->Execute( $query );

            return $result;
        }

        /**
         * Removes all the posts from the given blog
         *
         * @param blogId The blog identifier
         */
        function deleteBlogMyLinks( $blogId )
        {
        	$query = "DELETE FROM ".$this->getPrefix()."mylinks WHERE blog_id = $blogId";

			$result = $this->_db->Execute( $query );

            return $result;
        }        

        /**
         * Retrieves a single link from disk.
         *
         * @param linkId The link identifier
         * @param blogId The blog identifier
         * @return The MyLink object containing information or false if it didn't exist
         */
        function getMyLink( $linkId, $blogId )
        {
        	$query = "SELECT * FROM ".$this->getPrefix()."mylinks WHERE id = ".$linkId." AND blog_id = ".$blogId.";";

            $result = $this->_db->Execute( $query );

            if( !$result )
            	return false;

            if( $result->RecordCount() == 0 )
            	return false;

            $row = $result->FetchRow();
            $blogLink = new MyLink( $row["name"], $row["description"], $row["url"], $row["blog_id"], $row["category_id"], $row["id"] );

            return $blogLink;
        }

        /**
         * Updates a link in the database.
         *
         * @param myLink A MyLink object with the information we'd like to update.
         * @return True if successful or false otherwise.
         */
        function updateMyLink( $myLink )
        {
        	$query = "UPDATE ".$this->getPrefix()."mylinks SET
                      name = '".Db::qstr($myLink->getName())."',
                      description = '".Db::qstr($myLink->getDescription())."',
                      url = '".$myLink->getUrl()."',
                      category_id = ".$myLink->getCategoryId()."
                      WHERE id = ".$myLink->getId()." AND blog_id = ".$myLink->getBlogId().";";

            $result = $this->_db->Execute( $query );

            if( !$result )
            	return false;
            else
            	return true;
        }
    }
?>
