<?php

	include_once( PLOG_CLASS_PATH."class/data/validator.class.php" );
    include_once( PLOG_CLASS_PATH."class/config/config.class.php" );
    include_once( PLOG_CLASS_PATH."class/net/dns.class.php" );

    /**
     * Extends the validator class to determine wether an email address is valid or not.
     */
    class EmailValidator extends Validator {

    	var $_email;
        var $_checkEmailAddress;

    	function EmailValidator( $email )
        {
        	$this->Validator();

            $this->_email = trim($email);

            $config = Config::getConfig();
            $this->_checkEmailAddress = $config->getValue( "check_email_address_validity" );
        }

        /**
         * Returns true if the email address is a valid one, or false otherwise.
         *
         * @return Returns true if it's a valid address or false otherwise.
         */
        function validate($Debug = false)
        {
        	// check that is it not empty
            if( $this->_email == "" || $this->_email == null )
            	return false;

            // if not, check that it is a valid email address
            if(!eregi("^[a-z0-9]+([-_\.]?[a-z0-9])+@[a-z0-9]+([-_\.]?[a-z0-9])+\.[a-z]{2,4}", $this->_email ))
				return false;


            // check if we'd like to perform mx checkings and check with the smtp server
            // that the address exists... if not, as the previous check was passed, the
            // email address is valid.
			if( !$this->_checkEmailAddress )
        		return true;

// ---- Modification begins here---- -------------------------------------------------------
			// split the domain off
			list ( $Username, $Domain ) = split ("@",$this->_email);
			// Check to see if email exists

			// see if mx record exists on server
			if ( Dns::checkdnsrr ( $Domain, "MX" ) )  {
			     if($Debug) echo "Confirmation : MX record about {$Domain} exists.<br>";
			     if ( Dns::getmxrr ($Domain, $MXHost))  {
			      	if($Debug) {
			            echo "Confirmation : Is confirming address by MX LOOKUP.<br>";
			            for ( $i = 0,$j = 1; $i < count ( $MXHost ); $i++,$j++ ) {
			                echo "&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;Result($j) - $MXHost[$i]<BR>";
			            }
			        }
			     }

			     $ConnectAddress = $MXHost[0];
			}
			else {
			     $ConnectAddress = $Domain;
			     if ($Debug) echo "Confirmation : MX record about {$Domain} does not exist.<br>";
			}

			// connect to desired address and verify it exists
			$Connect = fsockopen ( $ConnectAddress, 25 );

			// Success in socket connection
		    if ($Connect)
		    {
		        if ($Debug) echo "Connection succeeded to {$ConnectAddress} SMTP.<br>";
		        if ( ereg ( "^220", $Out = fgets ( $Connect, 1024 ) ) )
		        {
		        	// do {
		        	//	$Out = fgets ( $Connect, 1024 );
					//	if ($Debug) echo "out -- {$Out}<br>";
					// } while ( ereg ( "^220", $Out) )
					$Out = fgets ( $Connect, 1024 );
					$Out = fgets ( $Connect, 1024 );

		            fputs ( $Connect, "HELO $HTTP_HOST\r\n" );
			        $Out = fgets ( $Connect, 1024 ); // Receive server's answering cord.
			        if ($Debug) echo "out -- {$Out}<br>";

			        fputs ( $Connect, "MAIL FROM: <{$this->_email}>\r\n" );
			        $From = fgets ( $Connect, 1024 ); // Receive server's answering cord.
					if ($Debug) echo "from -- {$From}<br>";

			        fputs ( $Connect, "RCPT TO: <{$this->_email}>\r\n" );
			        $To = fgets ( $Connect, 1024 ); // Receive server's answering cord.
					if ($Debug) echo "to -- {$To}<br>";

					fputs ( $Connect, "QUIT\r\n");
			        fclose($Connect);

			        if ( !ereg ( "^250", $From ) || !ereg ( "^250", $To )) {
			             if ($Debug) echo "{$this->_email} is address does not admit in E-Mail server.<br>";
			             return false;
			        }
			    }
			}
			else {
			    if ($Debug) echo "Can not connect E-Mail server ({$ConnectAddress}).<br>";
			    return false;
            }

// ---- Modification ends here---- -------------------------------------------------------

            // if all fine, return true
            $this->_valid = true;
            $this->_message = "Incorrect email address";
            return true;
        }
	}
?>
