<?php

	include_once( PLOG_CLASS_PATH."class/data/validator.class.php" );
    include_once( PLOG_CLASS_PATH."class/config/config.class.php" );

    define( MIN_PASSWORD_LENGTH_DEFAULT, 6 );

    define( ERROR_PASSWORD_TOO_SHORT, 1 );
    define( ERROR_PASSWORD_EMPTY, 2 );

    /**
     * Checks passwords
     */
    class PasswordValidator extends Validator {

    	var $_pass;

    	function PasswordValidator( $value )
        {
        	$this->Validator();

        	$this->_pass = $value;

            $this->_config = Config::getConfig();
        }

        function validate()
        {
        	$this->_valid = true;

        	if( $this->_pass == null || $this->_pass == "" || trim($this->_pass) == "" ) {
            	$this->_valid = false;
                $this->setMessage( ERROR_PASSWORD_EMPTY );
            }

            $passLength = $this->_config->getValue( "minimum_password_length", MIN_PASSWORD_LENGTH_DEFAULT);
            if( strlen($this->_pass) < $passLength ) {
            	$this->_valid = false;
                $this->setMessage( ERROR_PASSWORD_TOO_SHORT );
            }

            return $this->_valid;
        }
    }
?>
