<?php

	include_once( PLOG_CLASS_PATH."class/data/validator.class.php" );
    include_once( PLOG_CLASS_PATH."class/file/file.class.php" );

    define( ERROR_TEMPLATE_NOT_INSIDE_FOLDER, -1 );
    define( ERROR_MISSING_BASE_FILES, -2 );

    /**
     * Little class that will return true if a template set is valid
     * or not.
     *
     * Could have moved this as a static method in the TemplateService
     * class but didn't feel like making TemplateService too big after all...
     */
    class TemplateValidator extends Validator {

    	var $_templateName;
        var $_folder;
        var $_fullName;

        // these are the basic files that should be present in every
        // template set
        var $_basicFiles = Array( "main.template",
                                  "postandcomments.template",
                                  "commentarticle.template",
                                  "linktracker.template",
                                  "posttrackbacks.template",
                                  "error.template",
                                  "album.template",
                                  "albums.template",
                                  "resource.template"
                                 );


    	function TemplateValidator( $templateName, $folder )
        {
        	$this->Validator();

            $this->_templateName = $templateName;
            $this->_folder    = $folder;

            $this->_fullName = $this->_folder;
            if( $this->_fullName[strlen($this->_fullName)-1] != "/" )
            	$this->_fullName[strlen($this->_fullName)] = "/";
            $this->_fullName .= $templateName."/";
        }

        /**
         * Returns true if the template is a valid template set
         */
        function validate()
        {
        	// first of all, check that the folder exists
        	_debug("Checking that ".$this->_fullName." is a folder and exists");
            if( !File::isDir( $this->_fullName )) {
                _debug("Error, it does not exist!");
            	return ERROR_TEMPLATE_NOT_INSIDE_FOLDER;
            }

            // now check that all the basic files are available
            _debug("Checking that all required files ara available...");
            foreach( $this->_basicFiles as $basicFile ) {
            	if( !File::isReadable( $this->_fullName.$basicFile )) {
            	    _debug("Template file $basicFile is missing");
                	return ERROR_MISSING_BASE_FILES;
                }
            }
            
            _debug("Everyhing's correct");
            return true;
        }
    }
?>
