<?php

	include_once( PLOG_CLASS_PATH."class/view/blogview.class.php" );

    define( ADDCOMMENT_TEMPLATE, "postandcomments" );

    /**
     * View for the AddComment action. It shows the same comment again but with our
     * comment added.
     * Does pretty much as every other view. That is, call the TemplateService to
     * find the right template and then simply load the values into the template's
     * context
     */
    class AddCommentView extends BlogView {

		/**
         * Initializes the parent class
         */
    	function AddCommentView( $blogSettings )
        {
        	$this->BlogView( $blogSettings );
        }

    	/**
		 * Renders the view
         */
		function render()
        {
            // load the contents into the template context
            $blogSettings = $this->_blogInfo->getSettings();
            $template = $this->_templateService->Template( ADDCOMMENT_TEMPLATE, $blogSettings->getValue("template"), $this->_blogInfo );
            $template->assign( $this->_params->getAsArray());

            // finally, send the results
            print $template->fetch();
        }
    }
?>
