<?php

	include_once( PLOG_CLASS_PATH."class/view/adminview.class.php" );

    define( MESSAGEADMIN_TEMPLATE, "message" );

    /**
     * Shows a message to the user
     */
    class AdminMessageView extends AdminView {

    	/**
         * This initializes the class, but normally we'll only have to initialize the parent
         */
        function AdminMessageView( $blogInfo )
        {
        	$this->AdminView( $blogInfo );
        }

        /**
         * Renders the view. It simply gets all the parameters we've been adding to it
         * and puts them in the context of the template renderer so that they can be accessed
         * as normal parameters from within the template
         */
        function render()
        {
        	$template = $this->_templateService->Template( MESSAGEADMIN_TEMPLATE, "admin" );
            // assign all the values
            $template->assign( $this->_params->getAsArray());

            // and send the results
            print $template->fetch();
        }

        /**
         * Sets the error message. This method is equivalent of typing
         * $messageView->setValue( "message", "whatever-message-..." ), but using this we
         * type less :)
         *
         * @param message The message we are going to show.
         */
        function setMessage( $message )
        {
        	$this->setValue( "message", $message );
        }

    }
?>
