<?php

	include_once( PLOG_CLASS_PATH."class/view/view.class.php" );
    include_once( PLOG_CLASS_PATH."class/template/templateservice.class.php" );
    include_once( PLOG_CLASS_PATH."class/template/template.class.php" );
    include_once( PLOG_CLASS_PATH."class/locale/locales.class.php" );
    include_once( PLOG_CLASS_PATH."class/locale/locale.class.php" );
    include_once( PLOG_CLASS_PATH."class/dao/bloginfo.class.php" );
    include_once( PLOG_CLASS_PATH."class/dao/blogsettings.class.php" );
    include_once( PLOG_CLASS_PATH."class/template/templateutils.class.php" );
    include_once( PLOG_CLASS_PATH."class/data/plogcalendar.class.php" );

    /**
     * Extends the original 'View' class to provide support for common operations, for example
     * to automatically add support for locale. It is recommended
     * that all classes that generate a view extend from this unless strictly necessary
     */
	class BlogView extends View {

		var $_templateService;
        var $_blogInfo;

		function BlogView( $blogInfo )
        {
        	global $PHP_SELF;
        	$this->View();

            $this->_blogInfo = $blogInfo;

            $this->setValue( "blog", $blogInfo );
            $blogSettings = $blogInfo->getSettings();
            //$this->setValue( "locale", new Locale($blogSettings->getValue("locale")));
	    $this->setValue( "locale", Locales::getLocale( $blogSettings->getValue("locale")));

            // some other useful variables
            $this->setValue( "blogurl", $blogUrl );
            $this->setValue( "utils", new TemplateUtils( $this->_blogInfo));
            $this->setValue( "url", new RequestGenerator( $this->_blogInfo ));
            $this->setValue( "blogsettings", $blogInfo->getSettings());

            $this->_templateService = new TemplateService();
        }

        /**
         * Generates an html calendar based on the posts for the given month
         */
        function generateCalendar( $year = null, $month = null )
        {
			$monthPosts = $this->getValue( "monthposts" );
            $locale     = $this->getValue( "locale" );
            $blogInfo   = $this->getValue( "blog" );

            $calendar = new PlogCalendar( $monthPosts, $blogInfo, $locale->getLocaleCode());

			$this->setValue( "calendar", $calendar->getMonthView( $month, $year ));
        }
    }
?>
