<?php

	include_once( PLOG_CLASS_PATH."class/view/blogview.class.php" );

    // name of the template we are going to use for this view
    define( "SAMPLE_TEMPLATE", "sample" );

    /**
     * Sample implementation of the view, which goes attached to SampleAction
     */
    class SampleView extends BlogView {

    	/**
         * This initializes the class, but normally we'll only have to initialize the parent
         *
         * It gets the BlogSettings object since we need to know a few things about the blog we're
         * rendering before doing this.
         */
        function SampleView( $blogSettings )
        {
        	$this->BlogView( $blogSettings );
        }

        /**
         * Renders the view. It simply gets all the parameters we've been adding to it
         * and puts them in the context of the template renderer so that they can be accessed
         * as normal parameters from within the template
         */
        function render()
        {
        	// to find the template we need, we can use the TemplateService
            $blogSettings = $this->_blogInfo->getSettings();
        	$template = $this->_templateService->Template( SAMPLE_TEMPLATE, $blogSettings->getValue("template"));
            // assign all the values
            $template->assign( $this->_params->getAsArray());

            // and send the results
            print $template->fetch();
        }
    }
?>
