<?php

	include_once( PLOG_CLASS_PATH."class/view/blogview.class.php" );

    /**
     * Loads the given template. The only difference between this class and all
     * the other views is that this one receives as a parameter from the TemplateAction
     * class the name of the template to load, and then renders it.
     * The TemplateAction action takes care of rendering non-standard templates.
     */
    class TemplateView extends BlogView {

    	var $_templateFile;

    	/**
         * Constructor.
         *
         * @param blogInfo The BlogInfo object carrying information about the blog we are
         * rendering the template for. It is required by the constructor of the class
         * BlogView.
         * @param templateFile The filename of the template to load.
         */
    	function TemplateView( $blogInfo, $templateFile )
        {
        	$this->BlogView( $blogInfo );

            $this->_templateFile = $templateFile;
        }

        /**
         * Renders the template
         */
        function render()
        {
        	$blogSettings = $this->_blogInfo->getSettings();
        	
        	$ts =& $this->_templateService;
        	if( $ts->isBlogTemplate( $blogSettings->getValue( "template" ), $this->_blogInfo->getId())) {
                $template = $ts->Template( $this->_templateFile, $blogSettings->getValue( "template" ), $this->_blogInfo );        	
        	}
        	else {
                $template = $ts->Template( $this->_templateFile, $blogSettings->getValue( "template" ));        	
        	}
        	
            $template->assign( $this->_params->getAsArray());

            print( $template->fetch());
        }
    }
?>
