<?php

	if (!defined( "PLOG_CLASS_PATH" )) {
    	define( "PLOG_CLASS_PATH", dirname(__FILE__)."/");
    }

	include_once( PLOG_CLASS_PATH."class/dao/blogs.class.php" );
    include_once( PLOG_CLASS_PATH."class/dao/users.class.php" );
    include_once( PLOG_CLASS_PATH."class/net/httpvars.class.php" );

    /**
     * Implements an error handler for 401, 403 and 404 errors so that
     * if the user types a user name after the url, and Apache complains,
     * thanks to the ErrorDocument directive this handler will receive the
     * request and we will be able to perform a redirectiom
     *
     * To get this to work, we need a provider which allows to use
     * .htaccess files in their accounts and at the same time, allows
     * to have ErrorDocument directives in the .htaccess file.
     *
     * This should be the content of the file:
     *
     * ErrorDocument 401 /plog/error.php
     * ErrorDocument 403 /plog/error.php
     * ErrorDocument 404 /plog/error.php
     *
     * If pLog is running somewhere else other than /plog/, then that
     * should be changed since an absolute URL is required.
     */

     $server  = HttpVars::getServer();
     $request = HttpVars::getRequest();

     $parts = split( "/", $server["REQUEST_URI"] );

     $userParam=$parts[count($parts)-1];
     if( is_numeric($userParam))
     	$request["blogId"] = $userParam;
     else
     	$request["user"] = $userParam;

     HttpVars::setRequest( $request );

     @header("HTTP/1.1 200 OK");
     @header("Status: 200 OK", TRUE);

     include_once ( PLOG_CLASS_PATH."index.php");
?>
