CREATE TABLE plog_articles (
  id int(10) unsigned NOT NULL auto_increment,
  category_id int(10) unsigned NOT NULL default '0',
  topic text NOT NULL,
  text text NOT NULL,
  date timestamp(14) NOT NULL,
  user_id int(10) unsigned NOT NULL default '0',
  blog_id int(10) unsigned NOT NULL default '0',
  status enum('published','draft','deleted') NOT NULL default 'published',
  num_reads int(10) default '0',
  properties TEXT NOT NULL default '',
  PRIMARY KEY  (id)
) TYPE=MyISAM;

CREATE TABLE plog_articles_categories (
  id int(10) unsigned NOT NULL auto_increment,
  name varchar(255) NOT NULL default '',
  url varchar(255) NOT NULL default '',
  blog_id int(10) unsigned NOT NULL default '0',
  last_modification timestamp(14) NOT NULL,
  in_main_page TINYINT(1) NOT NULL DEFAULT '1',
  PRIMARY KEY  (id)
) TYPE=MyISAM;

 CREATE TABLE plog_articles_comments (
  id int(10) unsigned NOT NULL auto_increment,
  article_id int(10) unsigned NOT NULL default '0',
  topic text NOT NULL,
  text text,
  date timestamp(14) NOT NULL,
  user_email varchar(255) default '',
  user_url varchar(255) default '',
  user_name varchar(255) NOT NULL default 'Anonymous',
  parent_id int(10) unsigned default '0',
  client_ip varchar(15) default '0.0.0.0',
  send_notification tinyint(1) default '0',
  status tinyint(2) default '1',
  spam_rate float default '0',
  PRIMARY KEY  (id)
) TYPE=MyISAM;

CREATE TABLE plog_articles_notifications (
  id int(10) NOT NULL auto_increment,
  blog_id int(10) NOT NULL default '0',
  user_id int(10) NOT NULL default '0',
  article_id int(10) NOT NULL default '0',
  PRIMARY KEY  (id)
) TYPE=MyISAM;

 CREATE TABLE plog_blogs (
  id int(10) unsigned NOT NULL auto_increment,
  blog varchar(50) NOT NULL default '',
  owner_id int(10) unsigned NOT NULL default '0',
  about text,
  settings text NOT NULL,
  PRIMARY KEY  (id)
) TYPE=MyISAM;

CREATE TABLE plog_mylinks (
  id int(10) unsigned NOT NULL auto_increment,
  category_id int(10) unsigned NOT NULL default '0',
  url varchar(255) NOT NULL default '',
  name varchar(100) default '',
  description text NOT NULL,
  blog_id int(10) unsigned NOT NULL default '0',
  PRIMARY KEY  (id)
) TYPE=MyISAM;

CREATE TABLE plog_mylinks_categories (
  id int(10) NOT NULL auto_increment,
  name varchar(100) NOT NULL default '',
  blog_id int(10) NOT NULL default '0',
  last_modification timestamp(14) NOT NULL,
  PRIMARY KEY  (id)
) TYPE=MyISAM;

CREATE TABLE plog_myrecent (
  id int(10) unsigned NOT NULL auto_increment,
  category_id int(10) unsigned NOT NULL default '0',
  name varchar(255) NOT NULL default '',
  text text NOT NULL,
  user_id int(10) unsigned NOT NULL default '0',
  blog_id int(10) unsigned NOT NULL default '0',
  PRIMARY KEY  (id)
) TYPE=MyISAM;

CREATE TABLE plog_myrecent_categories (
  id int(10) unsigned NOT NULL auto_increment,
  name varchar(255) NOT NULL default '',
  blog_id int(10) unsigned NOT NULL default '0',
  last_modification timestamp(14) NOT NULL,
  PRIMARY KEY  (id)
) TYPE=MyISAM;

CREATE TABLE plog_permissions (
  id int(10) unsigned NOT NULL auto_increment,
  permission varchar(25) NOT NULL default '',
  description varchar(100) NOT NULL default '',
  PRIMARY KEY  (id)
) TYPE=MyISAM;

CREATE TABLE plog_referers (
  id int(10) NOT NULL auto_increment,
  url text NOT NULL,
  article_id int(10) NOT NULL default '0',
  blog_id int(10) NOT NULL default '0',
  hits int(10) default '1',
  last_date timestamp(14),
  PRIMARY KEY  (id)
) TYPE=MyISAM;

CREATE TABLE plog_trackbacks (
  id int(10) NOT NULL auto_increment,
  url text NOT NULL,
  title varchar(255) default '',
  article_id int(10) NOT NULL default '0',
  excerpt varchar(255) default '',
  blog_name varchar(255) default '',
  date timestamp(14) NOT NULL,
  PRIMARY KEY  (id)
) TYPE=MyISAM;

CREATE TABLE plog_users (
  id int(10) unsigned NOT NULL auto_increment,
  user varchar(15) NOT NULL default '' UNIQUE,
  password varchar(32) NOT NULL default '',
  email varchar(255) NOT NULL default '',
  about text,
  PRIMARY KEY  (id)
) TYPE=MyISAM;

CREATE TABLE plog_users_permissions (
  id int(10) unsigned NOT NULL auto_increment,
  user_id int(10) unsigned NOT NULL default '0',
  blog_id int(10) unsigned NOT NULL default '0',
  permission_id int(10) unsigned NOT NULL default '0',
  PRIMARY KEY  (id)
) TYPE=MyISAM;


CREATE TABLE plog_config (
   id int(10) NOT NULL auto_increment,
   config_key varchar(255) NOT NULL default '',
   config_value text NOT NULL,
   value_type int(3) default '0',
   PRIMARY KEY  (id,config_key)
   ) TYPE=MyISAM;

CREATE TABLE plog_filtered_content (
   id int(10) NOT NULL auto_increment,
   reg_exp text,
   blog_id int(10) NOT NULL default '0',
   reason text,
   date timestamp(14) NOT NULL,
   PRIMARY KEY  (id)
   ) TYPE=MyISAM;

CREATE TABLE plog_host_blocking_rules (
   id int(10) NOT NULL auto_increment,
   reason text,
   date timestamp(14) NOT NULL,
   blog_id int(10) NOT NULL default '0',
   block_type int(1) default '1',
   list_type int(1) default '1',
   mask int(2) default '0',
   host varchar(15) default '0.0.0.0',
   PRIMARY KEY  (id)
   ) TYPE=MyISAM;

CREATE TABLE plog_gallery_resources (
  id int(10) NOT NULL auto_increment,
  owner_id int(10) NOT NULL default '0',
  album_id int(10) NOT NULL default '0',
  description text,
  date timestamp(14) NOT NULL,
  flags int(10) default '0',
  resource_type int(3) default NULL,
  file_path varchar(255) default '',
  file_name varchar(255) default '',
  metadata text,
  thumbnail_format varchar(4) not null default 'same',
  PRIMARY KEY  (id)
  ) TYPE=MyISAM;

CREATE TABLE plog_gallery_albums (
  id int(10) NOT NULL auto_increment,
  owner_id int(10) NOT NULL default '0',
  description text NOT NULL,
  name varchar(255) NOT NULL default '',
  flags int(10) NOT NULL default '0',
  parent_id int(10) NOT NULL default '0',
  date timestamp(14) NOT NULL,
  properties text NOT NULL DEFAULT '',
  show_album TINYINT(1) DEFAULT 1,
  PRIMARY KEY  (id)
  ) TYPE=MyISAM;

CREATE TABLE plog_bayesian_filter_info (
  id int(10) unsigned NOT NULL auto_increment,
  blog_id int(10) unsigned default NULL,
  total_spam int(10) unsigned default NULL,
  total_nonspam int(10) unsigned default NULL,
  PRIMARY KEY  (id)
  ) TYPE=MyISAM;
  
CREATE TABLE plog_bayesian_tokens (
   id int(10) unsigned NOT NULL auto_increment,
   blog_id int(10) unsigned default NULL,
   token char(100) default NULL,
   spam_occurrences int(10) unsigned default NULL,
   nonspam_occurrences int(10) unsigned default NULL,
   prob float default NULL,
   PRIMARY KEY  (id),
   KEY blog_id (blog_id),
   KEY token (token)
   ) TYPE=MyISAM;  

# These are the config dumps. You'll need to either change these now, or alter, in the Settings Panel.

INSERT INTO plog_config (config_key, config_value, value_type) VALUES ('comments_enabled','1',1);
INSERT INTO plog_config (config_key, config_value, value_type) VALUES ('beautify_comments_text','1',1);
INSERT INTO plog_config (config_key, config_value, value_type) VALUES ('rdf_enabled','1',1);
INSERT INTO plog_config (config_key, config_value, value_type) VALUES ('temp_folder','./tmp',3);
INSERT INTO plog_config (config_key, config_value, value_type) VALUES ('base_url','{plog_base_url}',3);
INSERT INTO plog_config (config_key, config_value, value_type) VALUES ('show_posts_max','15',1);
INSERT INTO plog_config (config_key, config_value, value_type) VALUES ('recent_posts_max','10',1);
INSERT INTO plog_config (config_key, config_value, value_type) VALUES ('default_template','blueish',3);
INSERT INTO plog_config (config_key, config_value, value_type) VALUES ('template_folder','./templates',3);
INSERT INTO plog_config (config_key, config_value, value_type) VALUES ('default_blog_id','1',1);
INSERT INTO plog_config (config_key, config_value, value_type) VALUES ('default_locale','en_UK',3);
INSERT INTO plog_config (config_key, config_value, value_type) VALUES ('html_allowed_tags_in_comments','<a><i><br><br/><b>',3);
INSERT INTO plog_config (config_key, config_value, value_type) VALUES ('referer_tracker_enabled','1',1);
INSERT INTO plog_config (config_key, config_value, value_type) VALUES ('rss_parser_enabled','1',1);
INSERT INTO plog_config (config_key, config_value, value_type) VALUES ('show_more_enabled','1',1);
INSERT INTO plog_config (config_key, config_value, value_type) VALUES ('show_more_threshold','150',1);
INSERT INTO plog_config (config_key, config_value, value_type) VALUES ('update_article_reads','1',1);
INSERT INTO plog_config (config_key, config_value, value_type) VALUES ('email_service_enabled','1',1);
INSERT INTO plog_config (config_key, config_value, value_type) VALUES ('post_notification_source_address','noreply@your.host.com',3);
INSERT INTO plog_config (config_key, config_value, value_type) VALUES ('request_format_mode','1',1);
INSERT INTO plog_config (config_key, config_value, value_type) VALUES ('xmlrpc_ping_hosts','a:2:{i:0;s:27:\"http://rpc.weblogs.com/RPC2\i:1;s:0:\"\}',5);
INSERT INTO plog_config (config_key, config_value, value_type) VALUES ('trackback_server_enabled','1',1);
INSERT INTO plog_config (config_key, config_value, value_type) VALUES ('htmlarea_enabled','1',1);
INSERT INTO plog_config (config_key, config_value, value_type) VALUES ('plugin_manager_enabled','1',1);
INSERT INTO plog_config (config_key, config_value, value_type) VALUES ('check_email_address_validity','0',1);
INSERT INTO plog_config (config_key, config_value, value_type) VALUES ('summary_page_show_max','15',1);
INSERT INTO plog_config (config_key, config_value, value_type) VALUES ('minimum_password_length','4',1);
INSERT INTO plog_config (config_key, config_value, value_type) VALUES ('templates','a:3:{i:0;s:7:\"blueish\";i:1;s:4:\"grey\";i:2;s:6:\"lemons\";}',5);
INSERT INTO plog_config (config_key, config_value, value_type) VALUES ('locales','a:10:{i:0;s:5:"en_UK";i:1;s:5:"es_ES";i:2;s:5:"ca_ES";i:3;s:5:"ja_JP";i:4;s:5:"nl_BE";i:5;s:5:"zh_TW";i:6;s:5:"fr_FR";i:7;s:5:"de_DE";i:8;s:5:"zh_CN";i:9;s:5:"ko_KR";}',5);
INSERT INTO plog_config (config_key, config_value, value_type) VALUES ('email_service_type','php',3);
INSERT INTO plog_config (config_key, config_value, value_type) VALUES ('smtp_host','your.smtp.host.com',3);
INSERT INTO plog_config (config_key, config_value, value_type) VALUES ('smtp_port','25',1);
INSERT INTO plog_config (config_key, config_value, value_type) VALUES ('smtp_use_authentication','0',1);
INSERT INTO plog_config (config_key, config_value, value_type) VALUES ('smtp_username','',3);
INSERT INTO plog_config (config_key, config_value, value_type) VALUES ('smtp_password','',3);
INSERT INTO plog_config (config_key, config_value, value_type) VALUES ('locale_folder','./locale',3);
INSERT INTO plog_config (config_key, config_value, value_type) VALUES ('xmlrpc_ping_enabled','0',1);
INSERT INTO plog_config (config_key, config_value, value_type) VALUES ('path_to_tar','/bin/tar',3);
INSERT INTO plog_config (config_key, config_value, value_type) VALUES ('path_to_gzip','/bin/gzip',3);
INSERT INTO plog_config (config_key, config_value, value_type) VALUES ('path_to_bz2','/bin/bzip2',3);
INSERT INTO plog_config (config_key, config_value, value_type) VALUES ('path_to_unzip','/usr/bin/unzip',3);
INSERT INTO plog_config (config_key, config_value, value_type) VALUES ('users_can_add_templates','/bin/unzip',3);
INSERT INTO plog_config (config_key, config_value, value_type) VALUES ('maximum_file_upload_size', 2000000, 1);
INSERT INTO plog_config (config_key, config_value, value_type) VALUES ('upload_forbidden_files', '*.php *.php3 *.php4 *.phtml', 3);
INSERT INTO plog_config (config_key, config_value, value_type) VALUES ('comments_order', 1, 1);
INSERT INTO plog_config (config_key, config_value, value_type) VALUES ('security_pipeline_enabled', 1, 1);
INSERT INTO plog_config (config_key, config_value, value_type) VALUES ('maximum_comment_size', 0, 1 );
INSERT INTO plog_config (config_key, config_value, value_type) VALUES ('resources_enabled', 1, 1 );
INSERT INTO plog_config (config_key, config_value, value_type) VALUES ('thumbnail_method', 'gd', 3);
INSERT INTO plog_config (config_key, config_value, value_type) VALUES ('path_to_convert', '/usr/bin/convert', 3);
INSERT INTO plog_config (config_key, config_value, value_type) VALUES ('thumbnail_height', 120, 1);
INSERT INTO plog_config (config_key, config_value, value_type) VALUES ('thumbnail_width', 120, 1);
INSERT INTO plog_config (config_key, config_value, value_type) VALUES ('thumbnails_keep_aspect_ratio', 1, 1);
INSERT INTO plog_config (config_key, config_value, value_type) VALUES ('thumbnail_format','same',3);
INSERT INTO plog_config (config_key, config_value, value_type) VALUES ('resources_folder','./gallery/',3);
INSERT INTO plog_config (config_key, config_value, value_type) VALUES ('xmlrpc_api_enabled', 1, 1);
INSERT INTO plog_config (config_key, config_value, value_type) VALUES ('uploads_enabled', 1, 1);
INSERT INTO plog_config (config_key, config_value, value_type) VALUES ('default_rss_profile', 'rss090', 3);
INSERT INTO plog_config (config_key, config_value, value_type) VALUES ('bayesian_filter_enabled', 1, 2);
INSERT INTO plog_config (config_key, config_value, value_type) VALUES ('bayesian_filter_spam_probability_treshold', '0.9', 6);
INSERT INTO plog_config (config_key, config_value, value_type) VALUES ('bayesian_filter_nonspam_probability_treshold', '0.2', 6);
INSERT INTO plog_config (config_key, config_value, value_type) VALUES ('bayesian_filter_min_length_token', '3', 1);
INSERT INTO plog_config (config_key, config_value, value_type) VALUES ('bayesian_filter_max_length_token', '100', 1);
INSERT INTO plog_config (config_key, config_value, value_type) VALUES ('bayesian_filter_number_significant_tokens', 15, 1);
INSERT INTO plog_config (config_key, config_value, value_type) VALUES ('disable_apache_error_handler',0, 1);
INSERT INTO plog_config (config_key, config_value, value_type) VALUES ('show_future_posts_in_calendar',0, 1);

--
-- This is for the bayesian filter... this rows must have been initialized beforehand
-- The wizard does it automatically but there is no way to do it here, so we initialize 10
-- of them here... if by any chance we have more than 10 blogs, we'll have to do it manually
-- or else the bayesian filter won't work!
--
INSERT INTO plog_bayesian_filter_info VALUES ( 1, 1, 0, 0 );
INSERT INTO plog_bayesian_filter_info VALUES ( 2, 2, 0, 0 );
INSERT INTO plog_bayesian_filter_info VALUES ( 3, 3, 0, 0 );
INSERT INTO plog_bayesian_filter_info VALUES ( 4, 4, 0, 0 );
INSERT INTO plog_bayesian_filter_info VALUES ( 5, 5, 0, 0 );
INSERT INTO plog_bayesian_filter_info VALUES ( 6, 6, 0, 0 );
INSERT INTO plog_bayesian_filter_info VALUES ( 7, 7, 0, 0 );
INSERT INTO plog_bayesian_filter_info VALUES ( 8, 8, 0, 0 );
INSERT INTO plog_bayesian_filter_info VALUES ( 9, 9, 0, 0 );
INSERT INTO plog_bayesian_filter_info VALUES ( 10, 10, 0, 0 );
