<?php

	include_once( PLOG_CLASS_PATH."class/plugin/pluginbase.class.php" );
    include_once( PLOG_CLASS_PATH."class/plugin/pluginmanager.class.php" );

    define( SINFEST_BASE, "http://sinfest.net/comics/" );


    /**
     * Plugin that creates a url to see the day strip of sinfest, a
     * hilarious comic strip :)
     * It does not fetch it, it just returns the right url for today.
     *
     * It is exported with "sfstrip" as identifier.
     *
     * Usage:
     *
     * <img src="{$sfstring->SinfestStripUrl()" alt="Sinfest Strip"/>
     */
    class PluginSinfestStrip extends PluginBase {

    	function PluginSinfestStrip()
        {
        	$this->PluginBase();

            $this->desc = "Plugin that creates a url to see the day strip of sinfest, a
                           hilarious comic strip :) It does not fetch it, it just returns the right url for today.
                           It is exported with \"sfstrip\" as identifier.<br/>
                           Usage:<br/><br/>
                           &lt;img src=\"{\$sfstring->SinfestStripUrl()\" alt=\"Sinfest Strip\"/&gt;";
            $this->author = "The pLog team";
        }

        /**
         * Returns the url for the strip.
         *
         * @return The correct url for the strip.
         */
        function SinfestStripUrl()
        {
        	// with no parameters, timestamp has today's date
        	$t = new Timestamp();

            // name of the image is sfYYYYMMDD.gif
            $fileName = "sf".$t->getYear().$t->getMonth().$t->getDay();

            return SINFEST_BASE.$fileName.".gif";
        }
    }

    PluginManager::registerPlugin( "sfstrip", "PluginSinfestStrip" );
?>
