<?php
    /* registration.php (ver 0.01)  Bradley Liang.
    /
    /   This modification to pLog enables webmasters to set up a self-
    /   registering script for users to signup and create their own
    /   blogs.  Note that this is an insecure registration method.
    /
    /   DONE:  Simple 1-step registration with checks based on the
    /		   included file "wizard.php"
    /
    /   TODO:
    /  		  -Clean up code.
    /  		  -Email notification.
    /  		  -Email unlock-code.
    /			*The last two require some looking at the email
   	/			 class(es). The last one will require db structure
   	/			 modification as well as an ecryption class.*
   	/		  -Lots else.
    */

	if (!defined( "PLOG_CLASS_PATH" )) {
    	define( "PLOG_CLASS_PATH", dirname(__FILE__)."/");
    }    

	include_once( PLOG_CLASS_PATH."class/controller/controller.class.php" );
    include_once( PLOG_CLASS_PATH."class/template/templateservice.class.php" );
    include_once( PLOG_CLASS_PATH."class/action/action.class.php" );
    include_once( PLOG_CLASS_PATH."class/view/view.class.php" );
    include_once( PLOG_CLASS_PATH."class/database/adodb/adodb.inc.php" );
    include_once( PLOG_CLASS_PATH."class/data/emailvalidator.class.php" );
    include_once( PLOG_CLASS_PATH."class/data/stringvalidator.class.php" );
    include_once( PLOG_CLASS_PATH."class/dao/users.class.php" );
    include_once( PLOG_CLASS_PATH."class/dao/blogs.class.php" );
    include_once( PLOG_CLASS_PATH."class/dao/articlecategories.class.php" );
    include_once( PLOG_CLASS_PATH."class/dao/articles.class.php" );
    include_once( PLOG_CLASS_PATH."class/misc/version.class.php" );
    include_once( PLOG_CLASS_PATH."class/locale/locales.class.php" );

    // maps used to map requests with actions
    $_actionMap["Step1"] = "doUserRegister";
    $_actionMap["Default"] = "doUserRegister";
    $_actionMap["Step2"] = "doUserCreation";
    $_actionMap["Step3"] = "doBlogRegistration";


	// functions

    function connectDb()
    {
     	$config = new Config();
		// open a connection to the database
		$db = NewADOConnection( 'mysql' );
		$db->Connect($config->getValue( "db_host" ), $config->getValue( "db_username" ), $config->getValue( "db_password" ), $config->getValue( "db_database" ));

        return $db;
	}

    function dupeUsers($desiredName)
    {
    	$db = connectDb();
		$users = new Users();
        $userExists = $users->getUserInfoFromUsername($desiredName);

        if( $userExists == false )
        	return true;

		if( $userExists->getUsername() == $desiredName )
			return false;
		else
		    return true;
    }

    class doUserRegister extends Action {

    	function perform()
        {
        	$this->_view = new RegisterView( "step1" );
        }
    }

    class doUserCreation extends Action {

    	var $_userName;
        var $_userPassword;
        var $_confirmPassword;
        var $_userEmail;

        function validate()
        {
        	// user values
        	$this->_userName = $this->_request->getValue( "userName" );
            $this->_userPassword = $this->_request->getValue( "userPassword" );
            $this->_confirmPassword = $this->_request->getValue( "userPasswordCheck" );
            $this->_userEmail = $this->_request->getValue( "userEmail" );

            // blog values
            $this->_blogName = $this->_request->getValue( "blogName" );

            $errors = false;

		// ----------------------------------------------------------------------------------
		// ----------------------------------------------------------------------------------

            // validate the information
            $userVal = new StringValidator( $this->_userName );
            if( !$userVal->validate()) {
            	$message .= "<li>Incorrect user name, please try again.<br/>";
                $errors  = true;
            }

			// set validate (true) to see echoed fsocket operations
            $emailVal = new EmailValidator( $this->_userEmail );
            if( !$emailVal->validate( false ) ) {
            	$message .= "<li>Email address is invalid, please try again. <br/>";
                $errors = true;
            }

		// ----------------------------------------------------------------------------------
		// ----------------------------------------------------------------------------------

            // check for duped users
			if ( !dupeUsers( $this->_userName ) ) {
			    $message .= "<li>There is already a user with that name, please try again.<br/>";
			    $errors = true;
			}

		// ----------------------------------------------------------------------------------
		// ----------------------------------------------------------------------------------

            $passVal = new StringValidator( $this->_userPassword );
            if( !$passVal->validate()) {
            	$message .= "<li>Password is invalid, please try again. <br/>";
                $errors = true;
            }

            if( $this->_userPassword != $this->_confirmPassword ) {
            	$message .= "<li>Passwords do not match, please try again. <br/>";
                $errors = true;
            }

		// ----------------------------------------------------------------------------------
		// ----------------------------------------------------------------------------------

        	if( $errors ) {
            	$this->_view = new RegisterView( "step1" );
                $this->_view->setValue( "message", $message );
                $this->_view->setValue( "errors", $errors );
                $this->_view->setValue( "userName", $this->_userName );
                $this->_view->setValue( "userEmail", $this->_userEmail );
                return false;
            }

            return true;
        }

        // creates the user + blog
        function perform()
        {
        	$db = connectDb();

            $users = new Users();
            $userId = $users->addUser( $this->_userName, $this->_userPassword, $this->_userEmail);
            if( !$userId ) {
            	$this->_view = new RegisterView( "error" );
                $this->_view->setValue( "message", "Error adding the user: ".$users->DbError());
                return false;
            }

            $this->_view = new RegisterView( "step2" );
            $this->_view->setValue( "userId", $userId );
            return true;
        }

    }

    class doBlogRegistration extends Action {

    	var $_userId;
        var $_blogName;

    	function validate()
        {
        	// user values
        	$this->_userId = $this->_request->getValue( "userId" );
            // blog values
            $this->_blogName = $this->_request->getValue( "blogName" );

            $errors = false;

            $blogVal = new StringValidator( $this->_blogName );
			if( !$blogVal->validate()) {
			    $errors = true;
			    $message .= "<li>You should choose a better name for the blog.<br/>" ;
            }

        	if( $errors ) {
            	$this->_view = new RegisterView( "step2" );
                $this->_view->setValue( "message", $message );
                $this->_view->setValue( "errors", $errors );
                return false;
            }

            return true;
        }

        function perform()
        {
            $blogs = new Blogs();
            $newblogId = $blogs->addBlog( $this->_blogName, $this->_userId );
            if( !$newblogId ) {
            	$this->_view = new RegisterView( "error" );
                $this->_view->setValue( "message", "There was an error creating the new blog");
                return false;
            }

		// ----------------------------------------------------------------------------------
		// ----------------------------------------------------------------------------------

            // get info about the blog
            $blogInfo = $blogs->getBlogInfo( $newblogId );
            $rg = new RequestGenerator( $blogInfo );
            $blogUrl = $rg->blogLink($blogInfo);
            
            // get the default locale configured for the site
            $config =& Config::getConfig();
            $locale =& Locales::getLocale( $config->getValue( "default_locale" ));

            // if the blog was created, we can add some basic information
            // add a category
            $articleCategories = new ArticleCategories();
            $articleCategory = new ArticleCategory( $locale->tr("register_default_category" ), "", $newblogId, true );
            $catId = $articleCategories->addArticleCategory( $articleCategory );

            // add an article based on that category
            $articleTopic = $locale->tr( "register_default_article_topic" );
            $articleText  = $locale->tr("register_default_article_text" );
            $article = new Article( $articleTopic, $articleText, $catId, $this->_userId, $newblogId, 'published', 0 );
            $article->setDateObject( new Timestamp());  // set it to the current date
            $article->setCommentsEnabled( true ); // enable comments
            $articles = new Articles();
            $articles->addArticle( $article );

		// ----------------------------------------------------------------------------------
		// ----------------------------------------------------------------------------------


            $this->_view = new RegisterView( "step3" );
            $this->_view->setValue( "blogurl", $blogUrl );
        }
    }

    /* Renders template file. */
	class RegisterView extends View {

    	var $_templateName;

    	function RegisterView( $templateName )
        {
        	$this->View();
            $this->_templateName = $templateName;
        }

        function render()
        {
        	$templateService = new TemplateService();
            $template = $templateService->Template( $this->_templateName, "register" );

            $config =& Config::getConfig();
            $this->_locale =& Locales::getLocale( $config->getValue("default_locale" ));
            $this->_params->setValue( "version", new Version());
            $this->_params->setValue( "locale", $this->_locale );
            $template->assign( $this->_params->getAsArray());
            print $template->fetch();
        }
    }

    //// main part ////
    $controller = new Controller( $_actionMap, "nextStep", false );
    $controller->process( $_REQUEST );
?>
