<?php

	/**
     * Implementation of a very simple resource server.
     *
     * As a parameter, receives the name of a resource and it will take
     * care of fetching it.
     */
	if (!defined( "PLOG_CLASS_PATH" )) {
    	define( "PLOG_CLASS_PATH", dirname(__FILE__)."/");
    }     

	include_once( PLOG_CLASS_PATH."class/gallery/dao/galleryresources.class.php" );
    include_once( PLOG_CLASS_PATH."class/net/httpvars.class.php" );

    // get the parameters
    $params = HttpVars::getRequest();
    $blogId = $params["blogId"];
    $resName = $params["resource"];
    $resId = $params["resId"];
    $mode = $params["mode"];

    // and fetch the resource
    $resources = new GalleryResources();
    if( $resName ) {
    	$resource = $resources->getResourceFile( $blogId, $resName );
    }
    else {
    	$resource = $resources->getResource( $resId, $blogId );
    }

    if( !$resource ) {
    	// return 404 not found because the resource wasn't found
    	header( "HTTP/1.1 404 Not Found" );
    	header( "Status: 404 Not Found" );
    	die();
    }

    header( "Pragma: public" );
    header( "Accept-Ranges: bytes" );
    header( "Content-Disposition: inline; filename=".urlencode($resource->getFileName()));


    if( $mode == "preview" ) {
		header( "Content-Type: ".$resource->getThumbnailMimeType());	
        print( $resource->getPreview());
    }
    else {
        // otherwise, it's all good!
        $data = $resource->getMetadataReader();
		header( "Content-Type: ".$resource->getMimeType());
		header( "Content-Length: ".$data->getFileSize());
        print( $resource->getData());
    }
?>
