<?php

    /*

	// working with pLOG 0.2 // 0.3

        mhe@ltcgroup.de
        todo
            - security, can delete/post/update on blog ? ACL

	hints
            - blogid/categoryid hardcoded in "blogid", check int _encode()
            - newline unix/windows/mac, currently hardcoded \r\n

	history
	    2003-12-27: added improved xmlrpc error handling
	    2003-12-28: fixed hardcoded topic length
	    2004-01-21: added xmlrpc_api_enabled config check
    */

	if (!defined( "PLOG_CLASS_PATH" )) {
    	define( "PLOG_CLASS_PATH", dirname(__FILE__)."/");
    }


    // include required classes, dont know what, but it works for me :-)
    include_once( PLOG_CLASS_PATH."class/object/object.class.php" );
    include_once( PLOG_CLASS_PATH."class/net/xmlrpc/IXR_Library.lib.php" );
    include_once( PLOG_CLASS_PATH."class/config/config.class.php" );
    include_once( PLOG_CLASS_PATH."class/database/db.class.php" );

    include_once(PLOG_CLASS_PATH."class/dao/users.class.php");
    include_once(PLOG_CLASS_PATH."class/dao/article.class.php");
    include_once(PLOG_CLASS_PATH."class/dao/articles.class.php");
    include_once(PLOG_CLASS_PATH."class/dao/articlecategories.class.php");
	include_once(PLOG_CLASS_PATH."class/dao/users.class.php" );

    // init database
    $_db = new Db;
    $adodb = $_db->getDb();

    // config object
    $config = new Config;

    // users object
    $users = new Users;

    // articles object
    $articles = new Articles;

    // category object
    $category = new ArticleCategories;

    function _encode($blogid, $category)
    {
        $max = 8;

        $hash = 0;
        for($i=1;$i<$max-strlen($category);$i++)
        {
            $hash .= "0";
        }
        $hash = $blogid . $hash . $category;
        return $hash;
    }

    function _decode_blogid($hash)
    {
        $max = 8;
        return substr($hash, 0, strlen($hash)-$max);
    }

    function _decode_category($hash)
    {
        $max = 8;
        return substr($hash, strlen($hash)-$max)+0;
    }

    function newPost($args)
    {
        global $users, $articles;
        $appkey     = $args[0];
        $blogid     = $args[1];
        $username   = $args[2];
        $password   = $args[3];
        $content    = $args[4];
        $publish    = $args[5]; // true post&publish | false post only
        /*
         int postid
        */

        // -mhe todo security

        $erg = $users->getUserInfo(
            $username,
            $password
        );

        if ($erg != false)
        {
            if ($publish)
            {
                $status = "published";
            } else
            {
                $status = "draft";
            }

            // fake topic
            $dummy = explode("\n", $content);
            $title = $dummy[0];
            unset($dummy[0]);
            $content = implode("\n", $dummy);
            unset($dummy);



            $article = new Article(
                $title,
                $content, // text
                _decode_category($blogid), // catid
                $erg->_id, // userid
                _decode_blogid($blogid), // blogid
                $status,
                0, // numread
                Array( "comments_enabled" => true ) // enable comments
            );
            $article->setDate(date("YmdHis"));
            $postid = $articles->addArticle($article);
	    if ($postid != 0)
	    {
		return $postid;
	    } else
	    {
		return new IXR_Error(-1, 'Internal error occured creating your post!');
	    }
        } else
        {
            return new IXR_Error(-1, 'You did not provide the correct password');
        }
    }

    function getPost($args)
    {
        global $users, $articles;
        $appkey     = $args[0];
        $postid     = $args[1];
        $username   = $args[2];
        $password   = $args[3];

        /*
            "userid" =>
            "dateCreated" =>
            "content" =>
            "postid" =>
        */

        $erg = $users->getUserInfo($username,$password);
        if ($erg != false)
        {
            $item = $articles->getUserArticle($postid, $erg->_id);
            $time = mktime(
                substr($item->_date,8,2),
                substr($item->_date,10,2),
                substr($item->_date,12,2),
                substr($item->_date,4,2),
                substr($item->_date,6,2),
                substr($item->_date,0,4)
            );

            $dummy                  = array();
            $dummy["userid"]        = $item->_userInfo->_id;
            $dummy["dateCreated"]   = new IXR_Date($time);
            $dummy["content"]       = $item->_topic . "\r\n" . $item->_text . " ";
            $dummy["postid"]        = $item->_id;
            return $dummy;
        } else
        {
            return new IXR_Error(-1, 'You did not provide the correct password');
        }
    }

    function editPost($args)
    {
        global $users, $articles;

        $appkey     = $args[0];
        $postid     = $args[1];
        $username   = $args[2];
        $password   = $args[3];
        $content    = $args[4];
        $publish    = $args[5];

        /*
            boolean, true or false
        */

        $erg = $users->getUserInfo($username,$password);
        if ($erg != false)
        {
            if ($publish)
            {
                $status = "published";
            } else
            {
                $status = "draft";
            }

            // fake topic
            $dummy = explode("\n", $content);
            $title = $dummy[0];
            unset($dummy[0]);
            $content = implode("\n", $dummy);
            unset($dummy);

            $article = $articles->getUserArticle($postid);
            $article->setText($content);
            $article->setTopic($title);
            $article->setStatus($status);

            $articles->updateArticle($article);

            return true;
        } else
        {
            return new IXR_Error(-1, 'You did not provide the correct password');
        }
    }

    function deletePost($args)
    {
        global $users, $articles;

        $appkey     = $args[0];
        $postid     = $args[1];
        $username   = $args[2];
        $password   = $args[3];
        $publish    = $args[4];

        // -mhe todo
        $erg = $users->getUserInfo($username,$password);
        if ($erg != false)
        {

            $article = $articles->getUserArticle($postid, $erg->_id);
            $articles->deleteArticle(
                $postid,
                $erg->_id, // userid
                $article->getBlog(),
                $forever = true // kick 4eva
            );
            return true;
        } else
        {
            return new IXR_Error(-1, 'You did not provide the correct password');
        }
    }

    function getRecentPosts($args)
    {
        global $users, $articles;
        /*
            "userid" =>
            "dateCreated" =>
            "content" =>
            "postid" =>
        */
        $appkey     = $args[0];
        $blogid     = $args[1];
        $username   = $args[2];
        $password   = $args[3];
        $number     = $args[4];

        $erg = $users->getUserInfo($username,$password);
        if ($erg != false)
        {
            $ret = array();
            $list = $articles->getBlogArticles(
                _decode_blogid($blogid),
                -1,
                $number,
                _decode_category($blogid),
                0
            );

            foreach($list as $item)
            {
                $time = mktime(
                    substr($item->_date,8,2),
                    substr($item->_date,10,2),
                    substr($item->_date,12,2),
                    substr($item->_date,4,2),
                    substr($item->_date,6,2),
                    substr($item->_date,0,4)
                );

                $dummy                  = array();
                $dummy["userid"]        = $item->_userInfo->_id;
                $dummy["dateCreated"]   = new IXR_Date($time);
                $dummy["content"]       = $item->_topic . "\r\n" . $item->_text . " ";
                $dummy["postid"]        = $item->_id;

                $ret[]                  = $dummy;
            }
            return $ret;
        } else
        {
            return new IXR_Error(-1, 'You did not provide the correct password');
        }
    }

    function getUserInfo($args)
    {
        $appkeyp    = $args[0];
        $username   = $args[1];
        $password   = $args[2];
        /*
        "nickname" =>
        "firstname" =>
        "lastname" =>
        "email" =>
        "userid" =>
        "url" =>
        */
		
		$users = new Users();
		
        $erg = $users->getUserInfo(
            $username,
            $password
        );

        if ($erg != false)
        {
            $ret                = array();
            $ret["nickname"]    = $erg["_username"];
            $ret["firstname"]   = $erg["_username"];
            $ret["lastname"]    = "";
            $ret["email"]       = $erg["_email"];
            $ret["userid"]      = $erg["_id"];
            $ret["url"]         = "";
            return $ret;
        } else
        {
            return new IXR_Error(-1, 'You did not provide the correct password');
        }
    }

    function getUsersBlogs($args)
    {
        global $users, $category;
        $appkey     = $args[0];
        $username   = $args[1];
        $password   = $args[2];
        /*
            "blogName" =>
            "url" =>
            "blogid" =>
        */

        $erg = $users->getUserInfo(
            $username,
            $password
        );

        if ($erg != false)
        {
            $blogs = $users->getUsersBlogs($erg->_id);
            $ret = array();
            foreach($blogs as $blog)
            {
                $cats = $category->getBlogCategories($blog->_id);
                foreach($cats as $cat)
                {
                    $dummy              = array();
                    $dummy["blogid"]    = _encode($blog->_id, $cat->_id);
                    $dummy["blogName"]  = "/" . $blog->_blog . "/" . $cat->_name;
                    $dummy["url"]       = "http://";
                    $ret[]              = $dummy;
                }
            }
            return $ret;
        } else
        {
            return new IXR_Error(-1, 'You did not provide the correct password');
        }
    }

    if ($config->getValue("xmlrpc_api_enabled"))
    {
	$xmlrpc = new IXR_Server(
    	    array (
        	"blogger.newPost"           => "newPost",
        	"blogger.getUserInfo"       => "getUserInfo",
        	"blogger.getPost"           => "getPost",
        	"blogger.editPost"          => "editPost",
        	"blogger.deletePost"        => "deletePost",
        	"blogger.getRecentPosts"    => "getRecentPosts",
        	"blogger.getUserInfo"       => "getUserInfo",
        	"blogger.getUsersBlogs"     => "getUsersBlogs"
    	    )
	);
    } else
    {
	// xmlrpc_api disabled, no methods configured
	$xmlrpc = new IXR_Server(
    	    array (
    	    )
	);
    
    }

?>